#!/usr/bin/env ruby
#
# singinit-onecard.rb
#
# try singinit0.csh and singinit2.csh many times...
#
require 'pty'
require 'expect'

module Expect
  def spawn(cmd)
    puts "CMD: #{cmd}" if $expect_verbose
    PTY.spawn(cmd) { |r,w,pid|
      @input_stream = r
      @output_stream = w
      @child_pid = pid
      yield
    }
  end
  
  def myexpect(pat, timeout=5)
     @input_stream.expect(pat, timeout)
  end
end

include Expect
def trial(scriptname, waittext)
  STDERR.print "trying #{scriptname}..."
  spawn(scriptname) {
    begin
      if myexpect(waittext, 30)!= nil
        STDERR.print "command #{scriptname} normal end\n"
        return true
      end
      rescue
        STDERR.print "command #{scriptname} timeout\n"
      end
    }
  return false
end

(1..10).each{|i|
  STDERR.print "trial #{i}\n"
  system("${GDRBASEDIR}/gdrtb3/bin/singinit0.csh")
  x = $?.exitstatus
  if ( x == 0) then
      exit 0
  end
}
print "initialization failed\n"
print "rebooting...\n"
system ("/sbin/reboot")




