//
// hibutilsub.c
//
// helper functions (need to be in high-level optimization
//
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>

#include <xmmintrin.h>
#include <emmintrin.h>
#include "typedef.h"
typedef double v2df __attribute__((vector_size(16)));

void hibutil_memcopy64_0(UINT64 * src, UINT64 * dest, int len)
{
    int i;
    for (i=0;i<len;i++){
#if 1
	dest[i]=src[i];
#else
	__builtin_ia32_movntq(&(dest[i]), src[i]);
#endif	
    }
    __builtin_ia32_lfence();
}

void hibutil_memcopy64(UINT64 * src, UINT64 * dest, int len)
{
    int i;
    if (len == 1){
	*dest = *src;
	return;
    }
    if ( (((UINT64)src)& 0xf)||(((UINT64)dest)& 0xf)){
	//	fprintf(stderr,"unaliend copy %lx %lx %d\n", (UINT64)src, (UINT64)dest, len);
	hibutil_memcopy64_old(src,dest, len);
	return;
    }
    //    fprintf(stderr,"aliend copy %lx %lx %d\n", (UINT64)src, (UINT64)dest, len);
    while (len & 7){
	*dest++ = *src ++;
	len--;
    }
    for (i=0;i<len;i+=8){
	v2df * s = (v2df*) (src+i);
#if 0
	v2df * d = (v2df*) (dest+i);
	d[0]=s[0];
	d[1]=s[1];
	d[2]=s[2];
	d[3]=s[3];
#else	
	__builtin_ia32_movntpd((double*)dest, s[0]);
	__builtin_ia32_movntpd((double*)dest+2, s[1]);
	__builtin_ia32_movntpd((double*)dest+4, s[2]);
	__builtin_ia32_movntpd((double*)dest+6, s[3]);
	dest += 8;
#endif
    }
    //    __builtin_ia32_lfence();
}

void hibutil_memcopy64_old(UINT64 * src, UINT64 * dest, int len)
{
    int i;
    while (len & 7){
	*dest++ = *src ++;
	len--;
    }
    for (i=0;i<len;i+=8){
#if 1
	dest[i]=src[i];
	dest[i+1]=src[i+1];
	dest[i+2]=src[i+2];
	dest[i+3]=src[i+3];
	dest[i+4]=src[i+4];
	dest[i+5]=src[i+5];
	dest[i+6]=src[i+6];
	dest[i+7]=src[i+7];
#else
	// actually, this code seems to be slightly slower
	// than the above. The data to be transferred by DMA READ
	// may be better in the cache than in the main memory,
	// since the time to copy to the main memory can be
	// overlapped with actual DMA.
	__builtin_ia32_movntq(dest+i, src[i]);
	__builtin_ia32_movntq(dest+i+1, src[i+1]);
	__builtin_ia32_movntq(dest+i+2, src[i+2]);
	__builtin_ia32_movntq(dest+i+3, src[i+3]);
	__builtin_ia32_movntq(dest+i+4, src[i+4]);
	__builtin_ia32_movntq(dest+i+5, src[i+5]);
	__builtin_ia32_movntq(dest+i+6, src[i+6]);
	__builtin_ia32_movntq(dest+i+7, src[i+7]);
	//	dest +=8;
#endif	
    }
    //    __builtin_ia32_lfence();
}

