#include <stdio.h>
#include <singMC.h>
#include <sing_dbg.h>
#include <hibutil.h>

void checkodp()
{
  int info, perr, i;
  UINT64 long_boardinfo;

  Hib *h;
  for(i=0;i<4;i++){
    h = hib_openMC(i);
    info = hib_mem_readMC(i, h->boardinfo);
    long_boardinfo = hib_mem_read64MC(i, h->boardinfo);
    printf("32bit : chip%d , %08x \n", i, info);
    printf("64bit : chip%d , %016llx \n", i, long_boardinfo);
    perr = info >> 14;
    printf("perr%d , %d \n", i, perr);
    hib_closeMC(i);
  }
}

void checkidpsum()
{
  int info, perr, i;
  UINT64 sum0, sum1, sum2, sumall;

  Hib *h;
  for(i=0;i<4;i++){
    h = hib_openMC(i);
    sum0 = hib_mem_read64MC(i, 0x40);
    printf("IDP0 checksum : chip%d , %016llx \n", i, sum0);
    sum1 = hib_mem_read64MC(i, 0x48);
    printf("IDP1 checksum : chip%d , %016llx \n", i, sum1);
    sumall = sum0 ^ sum1;
    printf("%016llx \n", sumall);
    sum2 = hib_mem_read64MC(i, 0x50);
    printf("ODP checksum : chip%d , %016llx \n", i, sum2);
    hib_closeMC(i);
  }
}

int hetconv[] = {0, 0, 0, 0, 0, 0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0,0,0,0,0,0,0};
//double data[] = {1, 2, 3, 4, 5, 6, 7, 8, 5, 6, 7, 8, 9, 10, 11, 12,13};
UINT64 data[] = { 0x662731f7edbd1ad1 , 0x2df0cf6c8028d0f8 , 0x26e17185a18187f2 ,
		  0x6e565f782d9a7a8c ,
		  0xa9400bb195dac5b3 ,
		  0xfe122bc911db80f2 ,
		  0xbd33acaef7620fb8 ,
		  0x537226d005b7e768 };
//checksum is 0xba737a60975a9ac6



int senddataidp()
{
  int emid, bbid, err, ilid, i, j;
  INSTLIST *instlist;
  double result[64];
  CTRLinfo *chip[4];
  SINGinfo *s;
  
  s = SING_openMC(0);
  chip[0] = s->c;
  for(i=1;i<4;i++){
    chip[i] = CTRL_open(i);
  }

#if 1
  CTRL_setodpcom(s->c, 0x0ffULL);
  CTRL_setodpcom(s->c, 0x200ULL);
  for(i=1;i<4;i++){
    CTRL_setodpcom(chip[i], 0x0ffULL);
    CTRL_setodpcom(chip[i], 0x200ULL);
  }
#endif

  CTRL_beginbcast(s->c);
  
  SING_EM_fifoclrMC(s);
  usleep(20);
  emid = SING_EM_allocMC(s, 4, hetconv, 16, &err);
  bbid = SING_BM_allocMC(s, emid, /* emid */
		       2, /* size */
		       &err);
  usleep(10);
  SING_EM_statusMC(s);
  SING_BM_statusMC(s);
  SING_EM_sendMC(s, emid, /* areaid */
	         0, /* start */
	         2, /* ndata */
	         data);
  usleep(30);

  SING_EM_BM_transferMC(s,bbid, 
		      0, /* emstart */
		      0, /* bmstart */
		      2, /* ndata */
                      0, /* mode */
                      -1 /* bbid */
		      );
  usleep(10);
  
#if 1
  ilid = SING_ialloc_i(&(s->isp), 80);
  instlist = &(s->isp.instlists[ilid]);
  SING_asm_add_nop(instlist);
  SING_asm_add_nop(instlist);
  SING_asm_add_nop(instlist);
  SING_asm_add_nop(instlist);
  
  SING_asm_add_RRN("bb", 0, 0, 1, "", "flt72to64", instlist);
  SING_asm_add_nop(instlist);
  SING_asm_add_nop(instlist);
  SING_asm_add_nop(instlist);
  SING_asm_add_nop(instlist);
  SING_asm_add_nop(instlist);
  SING_asm_add_RRN("bb", 0, 8, 1, "", "flt72to64", instlist);
  SING_asm_add_nop(instlist);
  SING_asm_add_nop(instlist);
  SING_asm_add_nop(instlist);
  SING_asm_add_nop(instlist);
  SING_asm_add_nop(instlist);

  SING_register_instlist(s->c, instlist);
  SING_send_instlist(s->c, instlist,1,0);
#endif
  CTRL_endbcast(s->c);

#if 1
  CTRL_setodpcom(s->c, 0x0ffULL);
  for(i=1;i<4;i++){
    CTRL_setodpcom(chip[i], 0x0ffULL);
  }
#endif
  SING_closeMC(s);
  for(i=1;i<4;i++){
    CTRL_close(chip[i]);
  }

  return 0;
}


int main()
{
  printf("sing board info register \n");
  checkodp();
  checkidpsum();
  /* 
  senddataidp();
  checkidpsum();
  */
}
