#include <stdio.h>
#include <stdarg.h>
#include "./ew02.h"
#ifndef NJP
#    define NJP 65536
#endif
struct SING_grape_consts{
  INT64 _const_0;
  INT64 _const_1;
  INT64 _const_2;
  UINT64 _const_3[2];
  UINT64 _const_4;
  UINT64 _const_5;
  double _const_6;
  double _const_7;
  double _const_8;
  double _const_9;
  double _const_10;
};
struct SING_grape_consts constants;

int SING_send_vsm_constants()
{
    int ndata = 12;
    int firstaddress= 60;
    int conversions[]={4,4,4,6,6,6,6,1,1,1,1,1};

    constants._const_0 = 28;
    constants._const_1 = 60;
    constants._const_2 = 1;
    constants._const_3[0] = 0;
    constants._const_3[1] = 0x9fdLL;
    constants._const_4 = 0x000ffffffLL;
    constants._const_5 = 0x3ff000000LL;
    constants._const_6 = 0.57;
    constants._const_7 = 1.57;
    constants._const_8 = 1.414;
    constants._const_9 = 0.5;
    constants._const_10 = 1.5;

    SING_LM_write_regconv(ndata,conversions);
    SING_LM_write(&constants, firstaddress, 0);
}
static int emareaid;
static int bmareaid;
int SING_send_j_particle(struct grape_j_particle_struct *jp,
                         int index_in_EM)
{
//    int length = ((sizeof(struct grape_j_particle_struct)+4)/8)*8;
//    int offset = length*index_in_EM/sizeof(INT32);
//    SING_EM_write(length/sizeof(INT32), (void*)jp,offset);
      int ret;
      ret = SING_EM_send(emareaid,index_in_EM,1, (void*) jp);
      if (ret){
          fprintf(stderr,"SING_EM_send returns: %d\n", ret);
          exit(-1);
      }
}


// for multiple-routine version, these static variables
// must be made routine-specific

void SING_register_j_particle_conversion()
{
    int err;
    int conversions[]={0,0,0,1};

//    SING_EM_BM_transfer_register(4,
//			     conversions,
//			     0,
//			     1);
    emareaid=SING_EM_alloc(4, conversions, NJP, &err);
    if (emareaid < 0){
        fprintf(stderr,"register jp, EMalloc err = %d\n",err);
        exit(-1);
    }
    bmareaid=SING_BM_alloc(emareaid,vpm_number_of_bb(),&err);
    if (emareaid < 0){
        fprintf(stderr,"register jp, BMalloc err = %d\n",err);
        exit(-1);
    }
}



static SING_copy_ip_to_vip(struct grape_i_particle_struct *p,
			   struct grape_i_particle_vector_struct *vp,
			   int k)
{
   vp->xi[k]= p->xi;
   vp->yi[k]= p->yi;
   vp->zi[k]= p->zi;

}

int SING_send_i_particle(struct grape_i_particle_struct *ip,
                         int n)
{
    struct grape_i_particle_vector_struct ipv[NPE];
    int i;
    for(i=0;i<n;i++){
        int iv = i/4;
	int k  = i%4;
        SING_copy_ip_to_vip(ip+i, ipv+iv, k);
    }
    i = (n+3)/4;
    SING_LM_write(ipv, 0, i);
}

void SING_register_i_particle_conversion()
{
    int conversions[]={0,0,0,0,0,0,0,0,0,0,0,0};

    SING_LM_write_regconv(12,conversions);
}




int SING_send_hlt_data1(struct SING_hlt_struct1 *ip,
                         int peindex)
{
    int conversions[]={0,0,0,0,0};

    SING_LM_write_regconv(5,conversions);
    SING_LM_write(ip, 24, peindex);
}

static char* rrnstring[]={
"RRN   24 4 0 1 1 1 1 1 0 0 1  0 0 1 1 # fadd accx",
"RRN   2c 4 0 1 1 1 1 1 0 0 1  0 0 1 1 # fadd accy",
"RRN   34 4 0 1 1 1 1 1 0 0 1  0 0 1 1 # fadd accz"
};
static SING_copy_vr_to_r(struct grape_result_vector_struct *vp,
                         struct grape_result_struct *p,
                         int k)
{
   p->accx=vp->accx[k];
   p->accy=vp->accy[k];
   p->accz=vp->accz[k];

}

static int n_rrn;

int SING_get_result(struct grape_result_struct *rp)
{
    struct grape_result_vector_struct rvp;
    int i;
    int n = (NPE*4);
    SING_LM_read((UINT32*)&rvp);

    for(i=0;i<n;i++){
        SING_copy_vr_to_r(&rvp, rp+i,i);
    }
}

void SING_register_result_conversion()
{
    int conversions[]={0,0,0};

    SING_LM_read_regconv(3,conversions,rrnstring,
                          36,1,0);
}

static char* codes_1[]={
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  7 1 0 0   0  0 0 #  uxor $t $t $t",
"ISP 4 0 0 0 0 1 0 1 1 28 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $ti $ti $lr40v",
"ISP 4 0 0 0 0 0 0 1 1 30 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $t $t   $lr48v",
"ISP 4 0 0 0 0 0 0 1 1 38 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $t $t   $lr56v"
};
static char* codes_2[]={
"DBGP 0 0 LM fl 24 1 test0",
"DBGP 0 0 LM fl 26 1 test1",
"DBGP 0 0 LM fl 28 1 test2",
"DBGP 0 0 LM fl 30 1 test3",
"DBGP 0 0 LM fl 32 1 test4",
"DBGP 0 0 LM fl 24 1 $lm24",
"DBGP 0 0 LM fl 26 1 $lm26",
"DBGP 0 0 LM fl 28 1 $lm28",
"DBGP 0 0 LM fl 30 1 $lm30",
"DBGP 0 0 LM fl 32 1 $lm32",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 0  0 0 0 0 0  3c 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 2  a 1 0 0   0  0 0 #  upassa _const_0 $t $t",
"DBGP 0 0 TREG hl 0 4 $t",
"DBGP 0 0 GRF fl 0 4 $lr0v",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0   0 0 1 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  upassa $st $st $lr0v",
"DBGP 0 0 GRF fl 0 4 $lr0v",
"ISP 3 0 0 0 0 0 0 1 2  0 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 1 #  bm vxj $lr0v",
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  22 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   6  0 0 #  bm chargej lchargej",
"ISP 4 0 0 0 1 0 1 1 1  6 1 0  0 0 1  0 0 0 0 0   0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub $lr0 xi $r6v  $t # This instruction is a dummy",
"ISP 4 0 0 0 1 0 1 1 1  6 1 0  0 0 1  0 0 0 0 0   0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub $lr0 xi $r6v  $t",
"ISP 4 0 0 0 1 1 0 1 1  a 1 0  2 0 1  0 0 0 0 0   8 1 0 1 0 0 1 1 0 0 1 1 0 1 2 2 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub $lr2 yi $r10v ;  fmul $ti $ti $t ",
"ISP 4 0 0 0 0 0 0 1 1  e 1 0  4 0 1  0 0 0 0 0  10 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub $lr4 zi $r14v   ",
"ISP 4 0 0 0 0 0 0 1 0 12 1 0  a 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r10v $r10v $r18v",
"ISP 4 0 0 0 0 0 0 1 0 16 1 0  e 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r14v $r14v $r22v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0 12 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 0  0 0 1 0   0  0 0 #  fadd $t $r18v $t",
"ISP 4 0 0 0 1 1 1 1 1 12 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 1 1 2 0  0 0 1 0   0  0 0 #  fadd $ti $r22v $r18v $t # rsq is now in r18 t, dx, dy,dz are in  6,10,14",
"ISP 4 0 0 0 1 1 1 1 1 16 1 1  0 0 0  0 0 0 0 0  3e 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  d 1 0 0   0  0 0 #  ulsr $ti     _const_1  $t $lr22v",
"ISP 4 0 0 0 0 1 0 1 1 1e 1 1  0 0 0  0 0 0 0 0  40 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  d 1 0 0   0  0 0 #  ulsr $ti     _const_2   $lr30v",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0 1e 1 1  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 0  0 1 0 0   0  0 0 #  uadd $ti     $lr30v  $t",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 0  0 0 0 0 0  42 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 2  1 1 0 0   0  0 0 #  usub _const_3 $t     $t       # $lr8v ϻؿ1.5 ",
"ISP 4 0 0 0 0 1 0 1 1 1e 1 1  0 0 0  0 0 0 0 0  3e 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  c 1 0 0   0  0 0 #  ulsl $ti     _const_1  $lr30v",
"ISP 4 0 1 0 0 0 0 0 0  0 0 0 16 1 1  0 0 0 0 0  40 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 0  5 1 0 0   0  0 0 #  uand _const_2 $lr22v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0 12 1 0  0 0 0 0 0  44 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 3  5 1 0 0   0  0 0 #  uand $r18v _const_4 $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  45 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  6 1 0 0   0  0 0 #  uor  $ti _const_5 $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0  46 0 0 0 0 0 1 1 0 0 0 1 0 1 2 3 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti _const_6 $t",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 0  0 0 0 0 0  47 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_7 $t $t",
"ISP 4 1 0 0 1 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0  48 0 0 0 0 0 0 1 0 0 1 1 0 1 3 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul _const_8 $t $t",
"ISP 4 0 0 0 1 0 0 1 0 16 1 0 1e 1 1  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 1 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $t $lr30v $t $r22v # Here the result is the initial guess",
"ISP 4 0 0 0 1 0 0 1 0 1a 1 0 12 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r18v $r18v $r26v $t",
"ISP 4 0 0 0 1 1 0 1 0 1a 1 0 12 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 1 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r18v $ti   $r26v $t",
"ISP 4 0 0 0 0 1 0 1 0 1a 1 0  0 0 0  0 0 0 0 0  49 0 0 0 0 0 1 1 0 0 0 1 1 1 2 3 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti _const_9 $r26v # r26v is a**3/2",
"ISP 4 0 0 0 1 0 0 0 0  0 0 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $r22v $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  4a 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_10 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 1 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  4a 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_10 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 1 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  4a 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_10 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 1 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  4a 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_10 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 1 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  4a 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_10 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 1 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v  # r22v is the resulted r2**(-3/2)",
"ISP 4 0 0 0 1 0 0 1 0 12 1 0  0 0 0  0 0 0 0 0  22 0 0 0 0 0 0 1 0 0 1 1 1 1 3 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul lchargej $t $t $r18v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  6 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 1 1 0 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r6v $ti $t",
"ISP 4 0 0 0 0 1 0 1 1 28 1 1 28 1 1  0 0 0 1 1  24 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 2  0 0 1 0   0  0 0 #  fadd $lr40v $ti $lr40v accx",
"ISP 4 0 0 0 1 0 0 0 0  0 0 0  a 1 0 12 1 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 1 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r10v $r18v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1 30 1 1  0 0 0 1 1  2c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 2  0 0 1 0   0  0 0 #  fadd $lr48v $ti $lr48v accy",
"ISP 4 0 0 0 1 0 0 0 0  0 0 0  e 1 0 12 1 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 1 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r14v $r18v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1 38 1 1  0 0 0 1 1  34 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 2  0 0 1 0   0  0 0 #  fadd $lr56v $ti $lr56v accz"
};
static SING_register_grape_codes(int id[])
{
    int k;
    for (k=0;k<3;k++) id[k]=-1;
    SING_iflush();
    id[1]=SING_iregister(4,codes_1,-1);
    id[2]=SING_iregister(67,codes_2,17);
}

static ids[3];

void SING_grape_init()
{
    SING_open();
    SING_send_vsm_constants();
    SING_register_j_particle_conversion();
    SING_register_i_particle_conversion();
    SING_register_grape_codes(ids);
    SING_register_result_conversion();

}

int SING_grape_run(int n)
{
    return SING_execute(ids[1],ids[2], n,bmareaid);
}
