//
// grapesing.c
// grape-like simple N-squre inerface for simplegravity.
//
// J. Makino
//    Time-stamp: <10/12/11 01:13:44 makino>

#include <stdio.h>
#include <math.h>

#include "g5sim-gdr.h"


int devid = 1;

void set_gdr_devid(int id)
{
    devid = id;
}

void calculate_accel_by_singsim_1c(int n,
				double x[][3],
				double m[],
				double a[][3],
				double pot[],
				double eps2)
{
    static first=1;
    int i, niparallel;
    double epsinv = 1.0/sqrt(eps2);
    if (first){
	g5_openMC(devid);
	first=0;
    }
    g5_set_jpMC(devid, 0,  n, m, x);
    niparallel = g5_get_number_of_pipelinesMC(devid);
    for (i=0; i< n;i+=niparallel){
	int k;
	int njreal = n/SING_number_of_bb();
	int nireal = niparallel;
	if (i+nireal > n) nireal = n - i;
	g5_set_xiMC(devid,  nireal, x+i);
	g5_set_eps2_to_allMC(devid, eps2);
	g5_set_nMC(devid, n);
	g5_runMC(devid);
	g5_get_forceMC(devid, nireal, a+i, pot+i);
    }
    for(i=0;i<n;i++) pot[i] += m[i]*epsinv;
}

void calculate_accel_by_singsim(int n,
				double x[][3],
				double m[],
				double a[][3],
				double pot[],
				double eps2)
{
    static first=1;
    int i, niparallel;
    double epsinv = 1.0/sqrt(eps2);
    g5_set_debug_level(0);
    if (first){
	g5_open();
	first=0;
    }
    g5_set_jp(0,  n, m, x);
    g5_set_n(n);
    g5_set_eps2_to_all(eps2);
    g5_calculate_force_on_x(x, a, pot, n);
#if 0
    niparallel = g5_get_number_of_pipelinesMC(devid);
    for (i=0; i< n;i+=niparallel){
	//	fprintf(stderr,"i = %d\n",i);
	int k;
	int nireal = niparallel;
	if (i+nireal > n) nireal = n - i;
	g5_set_xi(nireal, x+i);
	g5_run();
	g5_get_force(nireal, a+i, pot+i);
    }
#endif    
    for(i=0;i<n;i++) pot[i] += m[i]*epsinv;
}
