//
// grapesing-usum.c
// grape-like simple N-squre inerface for simplegravity.
//
// J. Makino
//    Time-stamp: <2005/08/02 16:53:37 makino>

#include <stdio.h>
#include <math.h>
#include "gravity-usum.h"
#define NDIM (3)

double topower2(double x)
{
    int e;
    double f;
    f=frexp(x, &e);
    //    fprintf(stderr,"scales = %e %e %d\n", x, f, e);
    return ldexp(1.0e0, e);
}
static void guestimate_acc_etc( int n,
				double eps2,
				double m[],
				double a[][NDIM],
				double p[])
{
    int i,k;
    double fscale = m[0]/eps2*sqrt(n+0.0);
    double pscale = m[0]/sqrt(eps2)*sqrt(n+0.0);
    if (fscale < 10.0) fscale = 10.0;
    if (pscale < 10.0) pscale = 10.0;
    fscale = topower2(fscale);
    pscale = topower2(pscale);
    //    fprintf(stderr,"scales = %e %e\n", fscale, pscale);    
    for(i=0;i<n;i++){
	p[i] = pscale;
	for(k=0;k<NDIM;k++){
	    a[i][k] = fscale;
	    p[i] = pscale;
	}
    }
}



void calculate_accel_by_singsim(int n,
				double x[][3],
				double m[],
				double a[][3],
				double pot[],
				double eps2)
{
    static first=1;
    int i, niparallel;
    double epsinv = 1.0/sqrt(eps2);
    if (first){
	gravity_grape_init();
	first=0;
    }

    guestimate_acc_etc(n, eps2, m, a, pot);
    for(i=0;i<n;i++){
	struct grape_j_particle_struct jp;
	jp.xj=x[i][0];
	jp.yj=x[i][1];
	jp.zj=x[i][2];
	jp.mj=m[i];
	jp.eps2=eps2;
	jp.idxj=i;
	gravity_send_j_particle(&jp, i);
    }
    niparallel = SING_number_of_pe()*4;
    for (i=0; i< n;i+=niparallel){
	int k;
	int njreal = n/SING_number_of_bb();
	struct grape_i_particle_struct ip[256];
	struct gravity_result_struct result[256];
	for(k=0;k<niparallel; k++){
	    ip[k].xi=x[i+k][0];
	    ip[k].yi=x[i+k][1];
	    ip[k].zi=x[i+k][2];
	    ip[k].ascale=a[i+k][0];
	    ip[k].pscale=pot[i+k];
	    ip[k].idxi=i+k;
	}
	gravity_send_i_particle(ip, niparallel);
	gravity_grape_run(njreal);
	gravity_get_result(result);
	for(k=0;k<niparallel; k++){
	    a[i+k][0]=result[k].accx;
	    a[i+k][1]=result[k].accy;
	    a[i+k][2]=result[k].accz;
	    pot[i+k] = -result[k].pot;
	}
	
    }
}
