#include <stdio.h>
#include <stdarg.h>
#include "./gravity-16x32.h"
#ifndef NJP
#    define NJP 65536
#endif
struct gravity_grape_consts{
  INT64 _const_0;
  INT64 _const_1;
  UINT64 _const_2[2];
  UINT64 _const_3;
  UINT64 _const_4;
  double _const_5;
  double _const_6;
  double _const_7;
  double _const_8;
  double _const_9;
};
struct gravity_grape_consts constants;

int gravity_send_vsm_constants()
{
    int ndata = 11;
    int firstaddress= 64;
    int conversions[]={4,4,6,6,6,6,1,1,1,1,1};

    constants._const_0 = 60;
    constants._const_1 = 1;
    constants._const_2[0] = 0;
    constants._const_2[1] = 0x9fdLL;
    constants._const_3 = 0x000ffffffLL;
    constants._const_4 = 0x3ff000000LL;
    constants._const_5 = 0.57;
    constants._const_6 = 1.57;
    constants._const_7 = 1.414;
    constants._const_8 = 0.5;
    constants._const_9 = 1.5;

    SING_LM_write_regconv(ndata,conversions);
    SING_LM_write(&constants, firstaddress, 0);
}
int gravity_send_j_particle(struct gravity_elt_struct0 *jp, int index)
{
      return gravity_send_elt_data0(jp, index);
}


static gravity_copy_ip_to_vip(struct gravity_hlt_struct0 *p,
                                 struct gravity_hlt_vector_struct0 *vp,
			         int k)
{
   vp->xi[k]= p->xi;
   vp->yi[k]= p->yi;
   vp->zi[k]= p->zi;
   vp->idxi[k]= p->idxi;

}

int gravity_send_i_particle(struct gravity_hlt_struct0 *ip,
                         int n)
{
    struct gravity_hlt_vector_struct0 ipv[NPEMAX];
    int i;
    for(i=0;i<n;i++){
        int iv = i/4;
	int k  = i%4;
        gravity_copy_ip_to_vip(ip+i, ipv+iv, k);
    }
    i = (n+3)/4;
    SING_LM_write(ipv, 0, i);
}

void gravity_register_i_particle_conversion()
{
    int conversions[]={0,0,0,0,0,0,0,0,0,0,0,0,9,9,9,9};

    SING_LM_write_regconv(16,conversions);
}




static int emid0;
static int bmid0;
int gravity_setup_elt_data0()
{
    int err;
    int conversions[]={0,0,0,1,1,9};

    emid0=SING_EM_alloc(6, conversions, 65536, &err);
    if (emid0 < 0){
        fprintf(stderr,"register jp, EMalloc err = %d\n",err);
        exit(-1);
    }
    bmid0=SING_BM_alloc(emid0,1,&err);
    if (bmid0 < 0){
    fprintf(stderr,"register jp, BMalloc err = %d\n",err);
          exit(-1);
    }
}


int gravity_send_elt_data0(struct gravity_elt_struct0 *ip, int index_in_EM)
{
    int ret;
    ret = SING_EM_send(emid0,index_in_EM,1,ip);
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(-1);
    }
}

int gravity_move_elt_data0(int index)
{
    SING_EM_BM_transfer(bmid0,index,0,1,1,-1);
}
static gravity_copy_vr_to_r(struct gravity_result_vectorstruct *vp,
                              struct gravity_result_struct *p,
                         int k)
{
   p->accx=vp->accx[k];
   p->accy=vp->accy[k];
   p->accz=vp->accz[k];
   p->pot=vp->pot[k];

}
static struct gravity_result_vectorstruct gravity_rvp;

int gravity_get_result(struct gravity_result_struct *rp)
{
    int i;
    for(i=0;i<128;i++){
        gravity_copy_vr_to_r(&gravity_rvp, rp+i,i);
    }
}
static char* codes_1[]={
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 0   # idp 0",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  7 1 0 0   0  0 0 #  uxor $t $t $t",
"ISP 4 0 0 0 0 1 0 1 1 28 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $ti $ti $lr40v",
"ISP 4 0 0 0 0 0 0 1 1 30 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $t $t   $lr48v",
"ISP 4 0 0 0 0 0 0 1 1 38 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $t $t   $lr56v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 1  38 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $t $t   pot"
};
static char* codes_2[]={
"ISP 3 0 0 0 0 0 0 1 2  0 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 1 #  bm vxj $lr0v",
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  1c 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   6  0 0 #  bm mj lmj",
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  1d 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   7  0 0 #  bm eps2 leps2",
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  1e 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   8  0 0 #  bm idxj lidxj",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0  idp 0 #  nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 0  0 0 0 0 0  18 1 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  upassa idxi  idxi  $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  1e 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  7 1 0 0   0  0 0 #  uxor  $ti lidxj $t",
"ISP 4 0 2 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2 10 1 0 0   0  0 0 #  ulnot $ti $ti $t  # mreg 1 indicates i != j",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 0 0 0 1 0 1 1 1  6 1 0  0 0 1  0 0 0 0 0   0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub $lr0 xi $r6v  $t",
"ISP 4 0 0 0 1 1 0 1 1  a 1 0  2 0 1  0 0 0 0 0   8 1 0 1 0 0 0 1 0 0 0 1 0 1 2 2 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub $lr2 yi $r10v ;  fmul $ti $ti $t",
"ISP 4 0 0 0 0 0 0 1 1  e 1 0  4 0 1  0 0 0 0 0  10 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub $lr4 zi $r14v   ",
"ISP 4 0 0 0 1 0 1 1 0 12 1 0  a 1 0  0 0 0 0 0  1d 0 0 0 0 0 0 1 0 0 0 1 1 1 0 0 1 1 0 0 1 2 3  0 0 1 0   0  0 0 #  fmul $r10v $r10v $r18v ; fadd $t leps2 $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  e 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 0 1 1 0 0 1 6 2  0 0 1 0   0  0 0 #  fmul $r14v $r14v ;  fadd $fb $ti  $t",
"ISP 4 0 0 0 1 1 1 1 1 12 1 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 1 1 6 2  0 0 1 0   0  0 0 #  fadd $fb $ti  $r18v $t # rsq is now in r18 t, dx, dy,dz are in  6,10,14",
"ISP 4 0 0 0 1 1 1 1 1 16 1 1  0 0 0  0 0 0 0 0  40 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  d 1 0 0   0  0 0 #  ulsr $ti     _const_0  $t $lr22v",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  42 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  d 1 0 0   0  0 0 #  ulsr $ti     _const_1   $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0 16 1 1  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 0  0 1 0 0   0  0 0 #  uadd $ti     $lr22v  $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  44 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 2  1 1 0 0   0  0 0 #  usub _const_2 $ti     $t       # $lr8v ϻؿ1.5",
"ISP 4 0 0 0 0 1 0 1 1 1e 1 1  0 0 0  0 0 0 0 0  40 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  c 1 0 0   0  0 0 #  ulsl $ti     _const_0  $lr30v",
"ISP 4 0 1 0 0 0 0 0 0  0 0 0 16 1 1  0 0 0 0 0  42 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 0  5 1 0 0   0  0 0 #  uand _const_1 $lr22v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0 12 1 0  0 0 0 0 0  46 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 3  5 1 0 0   0  0 0 #  uand $r18v _const_3 $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  47 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  6 1 0 0   0  0 0 #  uor  $ti _const_4 $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0  48 0 0 0 0 0 0 1 0 0 0 1 0 1 2 3 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti _const_5 $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  49 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_6 $ti $t",
"ISP 4 1 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0  4a 0 0 0 0 0 0 1 0 0 0 1 0 1 3 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul _const_7 $ti $t",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 0 0 0 1 0 0 1 0 16 1 0 1e 1 1  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $t $lr30v $t $r22v # Here the result is the initial guess",
"ISP 4 0 0 0 1 0 0 1 0 1a 1 0 12 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r18v $r18v $r26v $t",
"ISP 4 0 0 0 1 1 0 1 0 1a 1 0 12 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r18v $ti   $r26v $t",
"ISP 4 0 0 0 0 1 0 1 0 1a 1 0  0 0 0  0 0 0 0 0  4b 0 0 0 0 0 0 1 0 0 0 1 1 1 2 3 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti _const_8 $r26v # r26v is a**3/2",
"ISP 4 0 0 0 1 0 0 0 0  0 0 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $r22v $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  4c 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_9 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  4c 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_9 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  4c 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_9 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  4c 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_9 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  4b 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_8 $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 2  0 0 1 0   0  0 0 #  fadd $r22v $ti $t",
"DBGP 0 0 TREG hl 0 4 $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0  0 0 0  0 0 0 0 0  1c 0 0 0 0 0 0 1 0 0 0 1 1 1 3 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul lmj $ti $t $r22v",
"DBGP 0 0 TREG hl 0 4 $t",
"ISP 4 2 0 0 0 1 0 1 1  0 1 1  6 1 0  0 0 0 0 0  38 1 0 1 0 0 0 1 0 0 0 1 0 1 0 2 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  fmul $r6v $ti  ;  upassa pot pot $lr0v",
"ISP 4 2 0 0 0 0 0 1 1 28 1 1  a 1 0 28 1 1 1 1  20 1 0 1 0 0 0 1 0 0 0 1 0 1 0 2 1 1 0 0 1 6 1  0 0 1 0   0  0 0 #  fmul $r10v $t ;  fadd $fb $lr40v  $lr40v accx",
"ISP 4 2 0 0 0 0 0 1 1 30 1 1  e 1 0 30 1 1 1 1  28 1 0 1 0 0 0 1 0 0 0 1 0 1 0 2 1 1 0 0 1 6 1  0 0 1 0   0  0 0 #  fmul $r14v $t ; fadd $fb $lr48v  $lr48v accy",
"ISP 4 2 0 0 0 0 0 1 1 38 1 1 12 1 0 38 1 1 1 1  30 1 0 1 0 0 0 1 0 0 0 1 0 1 0 2 1 1 0 0 1 6 1  0 0 1 0   0  0 0 #  fmul $r18v $t ; fadd $fb $lr56v $lr56v accz",
"ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 1 1  0 0 0 1 1  38 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 6 0  0 0 1 0   0  0 0 #  fadd $fb $lr0v  pot"
};
static char* codes_3[]={
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  20 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa accx accx $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 700  0 1 # bm $lr0v $lb1792v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 708  1 1 rrn 700 80 0 1 1 1 1 1 0 0 1 0 0 1 1 conv 0 # bm $lr0v $lb1800v  1 ; rrn fadd $lb1792v  128 flt72to64 accx",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 710  2 1 # bm $lr0v $lb1808v  2",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 718  3 1 # bm $lr0v $lb1816v  3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 720  4 1 # bm $lr0v $lb1824v  4",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 728  5 1 # bm $lr0v $lb1832v  5",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 730  6 1 # bm $lr0v $lb1840v  6",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 738  7 1 # bm $lr0v $lb1848v  7",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 740  8 1 # bm $lr0v $lb1856v  8",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 748  9 1 # bm $lr0v $lb1864v  9",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 750  a 1 # bm $lr0v $lb1872v  10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 758  b 1 # bm $lr0v $lb1880v  11",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 760  c 1 # bm $lr0v $lb1888v  12",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 768  d 1 # bm $lr0v $lb1896v  13",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 770  e 1 # bm $lr0v $lb1904v  14",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 778  f 1 # bm $lr0v $lb1912v  15",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 780 10 1 # bm $lr0v $lb1920v  16",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 788 11 1 # bm $lr0v $lb1928v  17",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 790 12 1 # bm $lr0v $lb1936v  18",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 798 13 1 # bm $lr0v $lb1944v  19",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a0 14 1 # bm $lr0v $lb1952v  20",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a8 15 1 # bm $lr0v $lb1960v  21",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b0 16 1 # bm $lr0v $lb1968v  22",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b8 17 1 # bm $lr0v $lb1976v  23",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c0 18 1 # bm $lr0v $lb1984v  24",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c8 19 1 # bm $lr0v $lb1992v  25",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d0 1a 1 # bm $lr0v $lb2000v  26",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d8 1b 1 # bm $lr0v $lb2008v  27",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e0 1c 1 # bm $lr0v $lb2016v  28",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e8 1d 1 # bm $lr0v $lb2024v  29",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0 1e 1 # bm $lr0v $lb2032v  30",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8 1f 1 # bm $lr0v $lb2040v  31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  28 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa accy accy $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 700  0 1 # bm $lr0v $lb1792v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 708  1 1 rrn 700 80 0 1 1 1 1 1 0 0 1 0 0 1 1 conv 0 # bm $lr0v $lb1800v  1 ; rrn fadd $lb1792v  128 flt72to64 accy",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 710  2 1 # bm $lr0v $lb1808v  2",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 718  3 1 # bm $lr0v $lb1816v  3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 720  4 1 # bm $lr0v $lb1824v  4",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 728  5 1 # bm $lr0v $lb1832v  5",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 730  6 1 # bm $lr0v $lb1840v  6",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 738  7 1 # bm $lr0v $lb1848v  7",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 740  8 1 # bm $lr0v $lb1856v  8",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 748  9 1 # bm $lr0v $lb1864v  9",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 750  a 1 # bm $lr0v $lb1872v  10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 758  b 1 # bm $lr0v $lb1880v  11",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 760  c 1 # bm $lr0v $lb1888v  12",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 768  d 1 # bm $lr0v $lb1896v  13",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 770  e 1 # bm $lr0v $lb1904v  14",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 778  f 1 # bm $lr0v $lb1912v  15",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 780 10 1 # bm $lr0v $lb1920v  16",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 788 11 1 # bm $lr0v $lb1928v  17",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 790 12 1 # bm $lr0v $lb1936v  18",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 798 13 1 # bm $lr0v $lb1944v  19",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a0 14 1 # bm $lr0v $lb1952v  20",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a8 15 1 # bm $lr0v $lb1960v  21",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b0 16 1 # bm $lr0v $lb1968v  22",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b8 17 1 # bm $lr0v $lb1976v  23",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c0 18 1 # bm $lr0v $lb1984v  24",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c8 19 1 # bm $lr0v $lb1992v  25",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d0 1a 1 # bm $lr0v $lb2000v  26",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d8 1b 1 # bm $lr0v $lb2008v  27",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e0 1c 1 # bm $lr0v $lb2016v  28",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e8 1d 1 # bm $lr0v $lb2024v  29",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0 1e 1 # bm $lr0v $lb2032v  30",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8 1f 1 # bm $lr0v $lb2040v  31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  30 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa accz accz $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 700  0 1 # bm $lr0v $lb1792v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 708  1 1 rrn 700 80 0 1 1 1 1 1 0 0 1 0 0 1 1 conv 0 # bm $lr0v $lb1800v  1 ; rrn fadd $lb1792v  128 flt72to64 accz",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 710  2 1 # bm $lr0v $lb1808v  2",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 718  3 1 # bm $lr0v $lb1816v  3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 720  4 1 # bm $lr0v $lb1824v  4",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 728  5 1 # bm $lr0v $lb1832v  5",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 730  6 1 # bm $lr0v $lb1840v  6",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 738  7 1 # bm $lr0v $lb1848v  7",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 740  8 1 # bm $lr0v $lb1856v  8",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 748  9 1 # bm $lr0v $lb1864v  9",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 750  a 1 # bm $lr0v $lb1872v  10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 758  b 1 # bm $lr0v $lb1880v  11",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 760  c 1 # bm $lr0v $lb1888v  12",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 768  d 1 # bm $lr0v $lb1896v  13",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 770  e 1 # bm $lr0v $lb1904v  14",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 778  f 1 # bm $lr0v $lb1912v  15",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 780 10 1 # bm $lr0v $lb1920v  16",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 788 11 1 # bm $lr0v $lb1928v  17",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 790 12 1 # bm $lr0v $lb1936v  18",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 798 13 1 # bm $lr0v $lb1944v  19",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a0 14 1 # bm $lr0v $lb1952v  20",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a8 15 1 # bm $lr0v $lb1960v  21",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b0 16 1 # bm $lr0v $lb1968v  22",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b8 17 1 # bm $lr0v $lb1976v  23",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c0 18 1 # bm $lr0v $lb1984v  24",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c8 19 1 # bm $lr0v $lb1992v  25",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d0 1a 1 # bm $lr0v $lb2000v  26",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d8 1b 1 # bm $lr0v $lb2008v  27",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e0 1c 1 # bm $lr0v $lb2016v  28",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e8 1d 1 # bm $lr0v $lb2024v  29",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0 1e 1 # bm $lr0v $lb2032v  30",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8 1f 1 # bm $lr0v $lb2040v  31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  38 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa pot pot $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 700  0 1 # bm $lr0v $lb1792v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 708  1 1 rrn 700 80 0 1 1 1 1 1 0 0 1 0 0 1 1 conv 0 # bm $lr0v $lb1800v  1 ; rrn fadd $lb1792v  128 flt72to64 pot",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 710  2 1 # bm $lr0v $lb1808v  2",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 718  3 1 # bm $lr0v $lb1816v  3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 720  4 1 # bm $lr0v $lb1824v  4",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 728  5 1 # bm $lr0v $lb1832v  5",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 730  6 1 # bm $lr0v $lb1840v  6",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 738  7 1 # bm $lr0v $lb1848v  7",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 740  8 1 # bm $lr0v $lb1856v  8",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 748  9 1 # bm $lr0v $lb1864v  9",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 750  a 1 # bm $lr0v $lb1872v  10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 758  b 1 # bm $lr0v $lb1880v  11",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 760  c 1 # bm $lr0v $lb1888v  12",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 768  d 1 # bm $lr0v $lb1896v  13",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 770  e 1 # bm $lr0v $lb1904v  14",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 778  f 1 # bm $lr0v $lb1912v  15",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 780 10 1 # bm $lr0v $lb1920v  16",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 788 11 1 # bm $lr0v $lb1928v  17",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 790 12 1 # bm $lr0v $lb1936v  18",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 798 13 1 # bm $lr0v $lb1944v  19",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a0 14 1 # bm $lr0v $lb1952v  20",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a8 15 1 # bm $lr0v $lb1960v  21",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b0 16 1 # bm $lr0v $lb1968v  22",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b8 17 1 # bm $lr0v $lb1976v  23",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c0 18 1 # bm $lr0v $lb1984v  24",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c8 19 1 # bm $lr0v $lb1992v  25",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d0 1a 1 # bm $lr0v $lb2000v  26",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d8 1b 1 # bm $lr0v $lb2008v  27",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e0 1c 1 # bm $lr0v $lb2016v  28",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e8 1d 1 # bm $lr0v $lb2024v  29",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0 1e 1 # bm $lr0v $lb2032v  30",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8 1f 1 # bm $lr0v $lb2040v  31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3"
};
static gravity_register_grape_codes(int id[])
{
    int k;
    for (k=0;k<4;k++) id[k]=-1;
    SING_iflush();
    id[1]=SING_iregister(6,codes_1);
    id[2]=SING_iregister(61,codes_2);
    id[3]=SING_iregister(265,codes_3);
}

static int ids[4];
int * gravity_codes_pointer()
{
    return ids;
}

void gravity_grape_init()
{
    
    SING_open();
    gravity_send_vsm_constants();
    gravity_setup_elt_data0();

    gravity_register_i_particle_conversion();
    gravity_register_grape_codes(ids);
    SING_set_result_size(0,sizeof(gravity_rvp));
}


int gravity_grape_run(int n)
{
    
    return SING_execute(ids[1],ids[2],ids[3], n,
                        NULL, (void*) &gravity_rvp);
}
