#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include "./simplegravity-16x32.h"
#ifndef NJP
#    define NJP 65536
#endif
#ifndef NCHIPS
#    define NCHIPS 8
#endif
#include <sing_chip.h>
SINGinfo * chip[NCHIPS];
struct SING_grape_consts{
  UINT64 _const_0[2];
  INT64 _const_1;
  INT64 _const_2;
  INT64 _const_3;
  UINT64 _const_4[2];
  UINT64 _const_5;
  UINT64 _const_6;
  double _const_7;
  double _const_8;
  double _const_9;
  double _const_10;
  double _const_11;
  double _const_12;
};
struct SING_grape_consts constants;

int SING_send_vsm_constants()
{
    int ndata = 15;
    int firstaddress= 76;
    int conversions[]={6,6,4,4,4,6,6,6,6,1,1,1,1,1,1};

    constants._const_0[0] = 0x7ff000000LL;
    constants._const_0[1] = 0x0fffffffffLL;
    constants._const_1 = 36;
    constants._const_2 = 60;
    constants._const_3 = 1;
    constants._const_4[0] = 0;
    constants._const_4[1] = 0x9fdLL;
    constants._const_5 = 0x000ffffffLL;
    constants._const_6 = 0x3ff000000LL;
    constants._const_7 = 0.57;
    constants._const_8 = 1.57;
    constants._const_9 = 1.414;
    constants._const_10 = 0.5;
    constants._const_11 = 1.5;
    constants._const_12 = 0.0;

    SING_LM_write_regconv(ndata,conversions);
    SING_LM_write(&constants, firstaddress, 0);
}
int SING_send_vsm_constantsMC(SINGinfo * s)
{
    int ndata = 15;
    int firstaddress= 76;
    int conversions[]={6,6,4,4,4,6,6,6,6,1,1,1,1,1,1};

    constants._const_0[0] = 0x7ff000000LL;
    constants._const_0[1] = 0x0fffffffffLL;
    constants._const_1 = 36;
    constants._const_2 = 60;
    constants._const_3 = 1;
    constants._const_4[0] = 0;
    constants._const_4[1] = 0x9fdLL;
    constants._const_5 = 0x000ffffffLL;
    constants._const_6 = 0x3ff000000LL;
    constants._const_7 = 0.57;
    constants._const_8 = 1.57;
    constants._const_9 = 1.414;
    constants._const_10 = 0.5;
    constants._const_11 = 1.5;
    constants._const_12 = 0.0;

    SING_LM_write_regconvMC(s, ndata,conversions);
    SING_LM_writeMC(s, &constants, firstaddress, 0);
}
int SING_send_j_particle(struct SING_elt_struct0 *jp, int index)
{
      return SING_send_elt_data0(jp, index);
}
int SING_send_j_particleMC(int chipid, struct SING_elt_struct0 *jp, int index)
{
      return SING_send_elt_data0MC(chipid, jp, index);
}
static int ids[7];



static int emid0;
static int bmid0;
static int emid0a[NCHIPS];
static int bmid0a[NCHIPS];
int SING_setup_elt_data0()
{
    int err;
    int conversions[]={0,0,0,1,1,9,9};

    int bcastmode = 0;
    emid0=SING_EM_alloc(7, conversions, 1048576, &err);
    if (emid0 < 0){
        fprintf(stderr,"register jp, EMalloc err = %d\n",err);
        exit(-1);
    }
    bmid0=SING_BM_alloc(emid0,1,&err);
    if (bmid0 < 0){
    fprintf(stderr,"register jp, BMalloc err = %d\n",err);
          exit(-1);
    }
    SING_EM_BM_transfer_setup(emid0,bmid0,0,0,1,bcastmode,-1);

}

int SING_setup_elt_data0MC(int chipid)
{
    int err;
    int conversions[]={0,0,0,1,1,9,9};

    int bcastmode = 0;
    emid0=SING_EM_allocMC(chip[chipid],7, conversions, 1048576, &err);
    if (emid0 < 0){
        fprintf(stderr,"register jp, EMalloc err = %d\n",err);
        exit(-1);
    }
    bmid0=SING_BM_allocMC(chip[chipid],emid0,1,&err);
    if (bmid0 < 0){
    fprintf(stderr,"register jp, BMalloc err = %d\n",err);
          exit(-1);
    }
    emid0a[chipid]=emid0;
    bmid0a[chipid]=bmid0;
    SING_EM_BM_transfer_setupMC(chip[chipid],emid0,bmid0,0,0,1,bcastmode,-1);
}

int SING_elt_size0()
{
    return 1048576;
}

int SING_send_elt_data0(struct SING_elt_struct0 *ip, int index_in_EM)
{
    int ret;
    ret = SING_EM_send(emid0,index_in_EM,1,ip);
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(-1);
    }
}

int SING_send_elt_data0MC(int chipid, struct SING_elt_struct0 *ip, int index_in_EM)
{
    int ret;
    ret = SING_EM_vsendMC(chip[chipid], emid0a[chipid],&index_in_EM,1,ip);
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(-1);
    }
}

int SING_send_elt_data0_m(struct SING_elt_struct0 *ip, int index_in_EM, int ndata)
{
    int ret;

    ret = SING_EM_send(emid0,index_in_EM,ndata,ip);
    
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(1);
    }

    return 0;
}

int SING_send_elt_data0_mMC(int chipid, struct SING_elt_struct0 *ip, int index_in_EM, int ndata)
{
    int ret;

    ret = SING_EM_sendMC(chip[chipid], emid0a[chipid],index_in_EM,ndata,ip);
    
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(1);
    }

    return 0;
}

int SING_send_elt_data0_vMC(int chipid, struct SING_elt_struct0 *ip, int index[], int ndata)
{
    int ret;

    ret = SING_EM_vsendMC(chip[chipid], emid0a[chipid],index,ndata,ip);
    
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(1);
    }

    return 0;
}

int SING_move_elt_data0(int index)
{
    SING_EM_BM_transfer(bmid0,index,0,1,1,-1);
}
int SING_move_elt_data0MC(int chipid, int index)
{
    SING_EM_BM_transferMC(chip[chipid],  bmid0a[chipid],index,0,1,1,-1);
}



static int emid1;
static int bmid1;
static int emid1a[NCHIPS];
static int bmid1a[NCHIPS];
int SING_setup_elt_data1()
{
    int err;
    int conversions[]={0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,6,6,6,6};

    int bcastmode = 1;
    emid1=SING_EM_alloc(20, conversions, 32, &err);
    if (emid1 < 0){
        fprintf(stderr,"register jp, EMalloc err = %d\n",err);
        exit(-1);
    }
    bmid1=SING_BM_alloc(emid1,1,&err);
    if (bmid1 < 0){
    fprintf(stderr,"register jp, BMalloc err = %d\n",err);
          exit(-1);
    }
    SING_EM_BM_transfer_setup(emid1,bmid1,0,0,1,bcastmode,-1);

}

int SING_setup_elt_data1MC(int chipid)
{
    int err;
    int conversions[]={0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,6,6,6,6};

    int bcastmode = 1;
    emid1=SING_EM_allocMC(chip[chipid],20, conversions, 32, &err);
    if (emid1 < 0){
        fprintf(stderr,"register jp, EMalloc err = %d\n",err);
        exit(-1);
    }
    bmid1=SING_BM_allocMC(chip[chipid],emid1,1,&err);
    if (bmid1 < 0){
    fprintf(stderr,"register jp, BMalloc err = %d\n",err);
          exit(-1);
    }
    emid1a[chipid]=emid1;
    bmid1a[chipid]=bmid1;
    SING_EM_BM_transfer_setupMC(chip[chipid],emid1,bmid1,0,0,1,bcastmode,-1);
}

int SING_elt_size1()
{
    return 32;
}

int SING_send_elt_data1(struct SING_elt_struct1 *ip, int index_in_EM)
{
    int ret;
    ret = SING_EM_send(emid1,index_in_EM,1,ip);
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(-1);
    }
}

int SING_send_elt_data1MC(int chipid, struct SING_elt_struct1 *ip, int index_in_EM)
{
    int ret;
    ret = SING_EM_vsendMC(chip[chipid], emid1a[chipid],&index_in_EM,1,ip);
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(-1);
    }
}

int SING_send_elt_data1_m(struct SING_elt_struct1 *ip, int index_in_EM, int ndata)
{
    int ret;

    ret = SING_EM_send(emid1,index_in_EM,ndata,ip);
    
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(1);
    }

    return 0;
}

int SING_send_elt_data1_mMC(int chipid, struct SING_elt_struct1 *ip, int index_in_EM, int ndata)
{
    int ret;

    ret = SING_EM_sendMC(chip[chipid], emid1a[chipid],index_in_EM,ndata,ip);
    
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(1);
    }

    return 0;
}

int SING_send_elt_data1_vMC(int chipid, struct SING_elt_struct1 *ip, int index[], int ndata)
{
    int ret;

    ret = SING_EM_vsendMC(chip[chipid], emid1a[chipid],index,ndata,ip);
    
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(1);
    }

    return 0;
}

int SING_move_elt_data1(int index)
{
    SING_EM_BM_transfer(bmid1,index,0,1,1,-1);
}
int SING_move_elt_data1MC(int chipid, int index)
{
    SING_EM_BM_transferMC(chip[chipid],  bmid1a[chipid],index,0,1,1,-1);
}


static SING_copy_ip_to_vip(struct SING_hlt_struct0 *p,
                                 struct SING_hlt_vector_struct0 *vp,
			         int k)
{
   vp->xi[k]= p->xi;
   vp->yi[k]= p->yi;
   vp->zi[k]= p->zi;
   vp->eps2i[k]= p->eps2i;
   vp->idi[k]= p->idi;

}

int SING_send_i_particle(struct SING_hlt_struct0 *ip,
                         int n)
{
    struct SING_hlt_vector_struct0 ipv[NPEMAX];
    int i;
    for(i=0;i<n;i++){
        int iv = i/4;
	int k  = i%4;
        SING_copy_ip_to_vip(ip+i, ipv+iv, k);
    }
    i = (n+3)/4;
    SING_EM_fifoclr();
    SING_send_elt_data1_m((struct SING_elt_struct1 *)ipv, 0, i);
    SING_EM_fifoclr();
    SING_LM_write(ipv, 0, i);
}

int SING_send_i_particleMC(int chipid, struct SING_hlt_struct0 *ip,
                         int n)
{
    struct SING_hlt_vector_struct0 ipv[NPEMAX];
    int i;
    for(i=0;i<n;i++){
        int iv = i/4;
      int k  = i%4;
        SING_copy_ip_to_vip(ip+i, ipv+iv, k);
    }
    i = (n+3)/4;
    SING_EM_fifoclrMC(chip[chipid]);
    SING_send_elt_data1_mMC(chipid,(struct SING_elt_struct1 *)ipv, 0, i);
    SING_flush_piow_channelMC(chip[chipid]);
    SING_EM_BM_transfer_setupMC_andsend1(chip[chipid], emid1a[chipid], bmid1a[chipid],
				0,0,1,0,-1);
    SING_startMC(chip[chipid], ids[6], 1);
    SING_finishMC(chip[chipid]);
    SING_startMC(chip[chipid], ids[5], i);
    SING_flush_piow_channelMC(chip[chipid]);
    SING_flush_piow_channelMC(chip[chipid]);
    SING_nwait(10000);
    SING_finishMC(chip[chipid]);
}

int SING_send_i_particleMCP(int nchips, int chipid[],
                          struct SING_hlt_struct0 *ip,
                          int n)
// currently support J-parallel only
//
{
    struct SING_hlt_vector_struct0 ipv[NPEMAX];
    int i;
    int nend = n+4 -1;
    if (nend > SING_npipes()){
	nend = SING_npipes();
    }
    for(i=0;i<nend;i++){
        int iv = i/4;
      int k  = i%4;
        SING_copy_ip_to_vip(ip+i, ipv+iv, k);
    }
    i = (n+ 4 -1)/4;
    int ic;
     SING_nwait(10000-i*200);
     // need to wait in case DRAM is written recently?

    if (nchips == 4) CTRL_beginbcast(chip[chipid[0]]->c);


    SING_EM_fifoclrMC(chip[chipid[0]]);

    //    UINT64 t0 = SING_rdtsc();


    SING_send_elt_data1_mMC(chipid[0], (struct SING_elt_struct1 *)ipv,
			    0, i);
    //    UINT64 t1 = SING_rdtsc();
    SING_EM_BM_transfer_setupMC_andsend1(chip[chipid[0]], emid1a[chipid[0]],
				bmid1a[chipid[0]], 0,0,1,0,-1);
    SING_nwait(20000);
    //BEWARE: you might need to increase the wait parameter above
    // to make the library works on some machines
    //    UINT64 t2 = SING_rdtsc();

    if (nchips == 4)     CTRL_coc_setflags(3,-1,-1);
    SING_startMC(chip[chipid[0]], ids[6], 1);
    //    UINT64 t2a = SING_rdtsc();
    for(ic=0;ic<nchips; ic++)SING_finishMC(chip[chipid[ic]]);
//    SING_finishMC(chip[chipid[0]]);
//    SING_nwait(10000);

    //    UINT64 t3 = SING_rdtsc();

    if (nchips == 4)     CTRL_coc_setflags(3,-1,-1);

    SING_startMC(chip[chipid[0]], ids[5], i);

//    SING_finishMC(chip[chipid[0]]);
//    SING_nwait(1000);
    for(ic=0;ic<nchips; ic++)SING_finishMC(chip[chipid[ic]]);
    
    if (nchips == 4) CTRL_endbcast(chip[chipid[0]]->c);

    //    UINT64 t4 = SING_rdtsc();
#if 0
    fprintf(stderr, "i= %d MCP cycles = %e %e %e %e %e\n", 
           i,
           (double)(t1-t0),
           (double)(t2-t1),
           (double)(t2a-t2),
           (double)(t3-t2a),
           (double)(t4-t3));
#endif
}

void SING_register_i_particle_conversion()
{
    int conversions[]={0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,6,6,6,6};

    SING_LM_write_regconv(20,conversions);
}
void SING_register_i_particle_conversionMC(SINGinfo * s)
{
    int conversions[]={0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,6,6,6,6};

    SING_LM_write_regconvMC(s, 20,conversions);
}

int SING_npipes()
{
    return 128;
}


static SING_copy_vr_to_r(struct SING_result_vectorstruct *vp,
                              struct SING_result_struct *p,
                         int k)
{
   p->accx=vp->accx[k];
   p->accy=vp->accy[k];
   p->accz=vp->accz[k];
   p->pot=vp->pot[k];
   p->nnb=vp->nnb[k];

}
static struct SING_result_vectorstruct SING_rvp;
static struct SING_result_vectorstruct SING_rvpa[NCHIPS];

int SING_get_result(struct SING_result_struct *rp)
{
    int i;
    for(i=0;i<128;i++){
        SING_copy_vr_to_r(&SING_rvp, rp+i,i);
    }
}
int SING_get_resultMC(int chipid, struct SING_result_struct *rp)
{
    int i;
    for(i=0;i<128;i++){
        SING_copy_vr_to_r(SING_rvpa+chipid, rp+i,i);
    }
}
static char* codes_1[]={
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 0   # idp 0",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 0  0 0 0 0 0  4c 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 2  a 1 0 0   0  0 0 #  upassa _const_0 $t $t",
"ISP 4 0 0 0 0 1 0 0 0  0 0 0  0 0 0  0 0 0 1 1  44 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $ti $ti nnb",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  7 1 0 0   0  0 0 #  uxor $t $t $t",
"ISP 4 0 0 0 0 1 0 1 1 28 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $ti $ti $lr40v",
"ISP 4 0 0 0 0 0 0 1 1 30 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0  wdp #  upassa $t $t   $lr48v",
"ISP 4 0 0 0 0 0 0 1 1 38 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $t $t   $lr56v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 1  3c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $t $t   pot"
};
static char* codes_2[]={
"ISP 3 0 0 0 0 0 0 1 2  0 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 1 #  bm vxj $lr0v",
"ISP 3 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  20 1 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   6  0 0 #  bm  vmj vlmj",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0  idp 0 #  nop 2",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0  rdp 0 #  nop 2",
"ISP 4 0 0 0 1 0 1 1 1  6 1 0  0 0 1  0 0 0 0 0   0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub $lr0 xi $r6v  $t",
"ISP 4 0 0 0 1 1 0 1 1  a 1 0  2 0 1  0 0 0 0 0   8 1 0 1 0 0 0 1 0 0 0 1 0 1 2 2 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub $lr2 yi $r10v ;  fmul $ti $ti $t ",
"ISP 4 0 0 0 0 0 0 1 1  e 1 0  4 0 1  0 0 0 0 0  10 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub $lr4 zi $r14v   ",
"ISP 4 0 0 0 1 0 1 1 0 12 1 0  a 1 0  0 0 0 0 0  21 0 0 0 0 0 0 1 0 0 0 1 1 1 0 0 1 1 0 0 1 2 3  0 0 1 0   0  0 0 #  fmul $r10v $r10v $r18v ; fadd $t leps2 $t",
"ISP 4 0 0 0 1 1 1 1 0 16 1 0  e 1 0  0 0 0 0 0  18 1 0 0 0 0 0 1 0 0 0 1 1 1 0 0 1 1 0 0 1 2 3  0 0 1 0   0  0 0 #  fmul $r14v $r14v $r22v ; fadd $ti eps2i $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0 12 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 0  0 0 1 0   0  0 0 #  fadd $ti $r18v $t",
"ISP 4 0 0 0 0 0 0 1 1  0 1 0  0 0 0  0 0 0 0 0  1c 1 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 1 1 3 3  a 1 0 0   0  0 0 #  upassa idi idi $r0v",
"ISP 4 0 0 0 1 0 1 1 1 12 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 1 1 2 0  0 0 1 0   0  0 0 #  fadd $t $r22v $r18v $t # rsq is now in r18 t, dx, dy,dz are in  6,10,14",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 1 0  0 0 0 0 0  22 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 3  7 1 0 0   0  0 0 #  uxor $r0v lidj $t",
"ISP 4 0 2 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2 10 1 0 0   0  0 0 #  ulnot $ti $ti $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  4e 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 2  a 1 0 0   0  0 0 #  upassa _const_1 $ti $t",
"ISP 1 0 0 0 0 1 0 1 1 22 0 1  0 0 0  0 0 0 0 0  22 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 2  d 1 0 0   0  0 0 #  ulsr lidj $ti $lr34",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0 3f 1 1 3f 1 1 0 0   0 0 0 0 1 1 1 1 1 1 1 1 1 1 3 3 1 1 1 1 1 4 0 1f 0 0 0   0  0 0 #  imm fffffffff $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0 12 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 0  5 1 0 0   0  0 0 #  uand $ti $r18v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0 22 0 1  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 0  6 1 0 0   0  0 0 #  uor $ti $lr34 $t",
"ISP 4 2 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  44 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  9 1 0 0   0  0 0 #  umin $ti nnb $t",
"ISP 4 2 0 0 0 1 0 0 0  0 0 0  0 0 0  0 0 0 1 1  44 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $ti $ti nnb",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop 2",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop 2",
"ISP 4 0 0 0 1 0 1 1 1 16 1 1 12 1 0  0 0 0 0 0  50 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 3  d 1 0 0   0  0 0 #  ulsr $r18v     _const_2  $t $lr22v",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  52 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  d 1 0 0   0  0 0 #  ulsr $ti     _const_3   $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0 16 1 1  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 2  0 1 0 0   0  0 0 #  uadd $lr22v     $ti  $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  54 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 2  1 1 0 0   0  0 0 #  usub _const_4 $ti     $t       # $lr8v ϻؿ1.5",
"ISP 4 0 0 0 0 1 0 1 1 1e 1 1  0 0 0  0 0 0 0 0  50 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  c 1 0 0   0  0 0 #  ulsl $ti     _const_2  $lr30v",
"ISP 4 0 1 0 0 0 0 0 0  0 0 0 16 1 1  0 0 0 0 0  52 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 0  5 1 0 0   0  0 0 #  uand _const_3 $lr22v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0 12 1 0  0 0 0 0 0  56 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 3  5 1 0 0   0  0 0 #  uand $r18v _const_5 $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  57 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  6 1 0 0   0  0 0 #  uor  $ti _const_6 $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0  58 0 0 0 0 0 0 1 0 0 0 1 0 1 2 3 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti _const_7 $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  59 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_8 $ti $t",
"ISP 4 1 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0  5a 0 0 0 0 0 0 1 0 0 0 1 0 1 3 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul _const_9 $ti $t",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 0 0 0 1 0 0 1 0 16 1 0 1e 1 1  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $t $lr30v $t $r22v # Here the result is the initial guess",
"ISP 4 0 0 0 1 0 0 1 0 1a 1 0 12 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r18v $r18v $r26v $t",
"ISP 4 0 0 0 1 1 0 1 0 1a 1 0 12 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r18v $ti   $r26v $t",
"ISP 4 0 0 0 0 1 0 1 0 1a 1 0  0 0 0  0 0 0 0 0  5b 0 0 0 0 0 0 1 0 0 0 1 1 1 2 3 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti _const_10 $r26v # r26v is a**3/2",
"ISP 4 0 0 0 1 0 0 0 0  0 0 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $r22v $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  5c 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_11 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  5c 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_11 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  5c 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_11 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  5c 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_11 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  5c 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_11 $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t  # $t is the resulted r2**(-3/2)",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0  0 0 0  0 0 0 0 0  20 0 0 0 0 0 0 1 0 0 0 1 1 1 3 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul lmj $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 1 1  0 1 1  6 1 0  0 0 0 0 0  3c 1 0 1 0 0 0 1 0 0 0 1 0 1 0 2 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  fmul $r6v $ti $t ; upassa pot pot $lr0v",
"ISP 4 0 0 0 0 1 0 1 1 28 1 1 28 1 1  0 0 0 1 1  24 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 2  0 0 1 0   0  0 0 #  fadd $lr40v $ti $lr40v accx",
"ISP 4 0 0 0 1 0 0 0 0  0 0 0  a 1 0 16 1 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 1 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r10v $r22v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1 30 1 1  0 0 0 1 1  2c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 2  0 0 1 0   0  0 0 #  fadd $lr48v $ti $lr48v accy",
"ISP 4 0 0 0 1 0 0 0 0  0 0 0  e 1 0 16 1 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 1 1 1 0 0 1 0 0  0 0 0 0   0  0 0  wdp #  fmul $r14v $r22v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1 38 1 1  0 0 0 1 1  34 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 2  0 0 1 0   0  0 0 #  fadd $lr56v $ti $lr56v accz",
"ISP 4 0 0 0 1 0 0 0 0  0 0 0 12 1 0 16 1 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 1 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r18v $r22v $t",
"ISP 4 0 0 0 0 1 0 0 0  0 0 0  0 1 1  0 0 0 1 1  3c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 2  0 0 1 0   0  0 0 #  fadd $lr0v $ti pot"
};
static char* codes_3[]={
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  24 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa accx accx $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 700  0 1 # bm $lr0v $lb1792v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 708  1 1 # bm $lr0v $lb1800v  1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 710  2 1 # bm $lr0v $lb1808v  2",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 718  3 1 rrn 700 80 0 1 1 1 1 1 0 0 1 0 0 1 1 conv 0 # bm $lr0v $lb1816v  3 ; rrn fadd $lb1792v  128 flt72to64 accx",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 720  4 1 # bm $lr0v $lb1824v  4",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 728  5 1 # bm $lr0v $lb1832v  5",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 730  6 1 # bm $lr0v $lb1840v  6",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 738  7 1 # bm $lr0v $lb1848v  7",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 740  8 1 # bm $lr0v $lb1856v  8",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 748  9 1 # bm $lr0v $lb1864v  9",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 750  a 1 # bm $lr0v $lb1872v  10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 758  b 1 # bm $lr0v $lb1880v  11",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 760  c 1 # bm $lr0v $lb1888v  12",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 768  d 1 # bm $lr0v $lb1896v  13",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 770  e 1 # bm $lr0v $lb1904v  14",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 778  f 1 # bm $lr0v $lb1912v  15",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 780 10 1 # bm $lr0v $lb1920v  16",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 788 11 1 # bm $lr0v $lb1928v  17",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 790 12 1 # bm $lr0v $lb1936v  18",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 798 13 1 # bm $lr0v $lb1944v  19",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a0 14 1 # bm $lr0v $lb1952v  20",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a8 15 1 # bm $lr0v $lb1960v  21",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b0 16 1 # bm $lr0v $lb1968v  22",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b8 17 1 # bm $lr0v $lb1976v  23",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c0 18 1 # bm $lr0v $lb1984v  24",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c8 19 1 # bm $lr0v $lb1992v  25",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d0 1a 1 # bm $lr0v $lb2000v  26",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d8 1b 1 # bm $lr0v $lb2008v  27",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e0 1c 1 # bm $lr0v $lb2016v  28",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e8 1d 1 # bm $lr0v $lb2024v  29",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0 1e 1 # bm $lr0v $lb2032v  30",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8 1f 1 # bm $lr0v $lb2040v  31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  2c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa accy accy $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 700  0 1 # bm $lr0v $lb1792v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 708  1 1 # bm $lr0v $lb1800v  1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 710  2 1 # bm $lr0v $lb1808v  2",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 718  3 1 rrn 700 80 0 1 1 1 1 1 0 0 1 0 0 1 1 conv 0 # bm $lr0v $lb1816v  3 ; rrn fadd $lb1792v  128 flt72to64 accy",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 720  4 1 # bm $lr0v $lb1824v  4",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 728  5 1 # bm $lr0v $lb1832v  5",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 730  6 1 # bm $lr0v $lb1840v  6",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 738  7 1 # bm $lr0v $lb1848v  7",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 740  8 1 # bm $lr0v $lb1856v  8",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 748  9 1 # bm $lr0v $lb1864v  9",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 750  a 1 # bm $lr0v $lb1872v  10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 758  b 1 # bm $lr0v $lb1880v  11",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 760  c 1 # bm $lr0v $lb1888v  12",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 768  d 1 # bm $lr0v $lb1896v  13",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 770  e 1 # bm $lr0v $lb1904v  14",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 778  f 1 # bm $lr0v $lb1912v  15",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 780 10 1 # bm $lr0v $lb1920v  16",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 788 11 1 # bm $lr0v $lb1928v  17",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 790 12 1 # bm $lr0v $lb1936v  18",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 798 13 1 # bm $lr0v $lb1944v  19",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a0 14 1 # bm $lr0v $lb1952v  20",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a8 15 1 # bm $lr0v $lb1960v  21",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b0 16 1 # bm $lr0v $lb1968v  22",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b8 17 1 # bm $lr0v $lb1976v  23",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c0 18 1 # bm $lr0v $lb1984v  24",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c8 19 1 # bm $lr0v $lb1992v  25",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d0 1a 1 # bm $lr0v $lb2000v  26",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d8 1b 1 # bm $lr0v $lb2008v  27",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e0 1c 1 # bm $lr0v $lb2016v  28",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e8 1d 1 # bm $lr0v $lb2024v  29",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0 1e 1 # bm $lr0v $lb2032v  30",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8 1f 1 # bm $lr0v $lb2040v  31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  34 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa accz accz $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 700  0 1 # bm $lr0v $lb1792v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 708  1 1 # bm $lr0v $lb1800v  1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 710  2 1 # bm $lr0v $lb1808v  2",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 718  3 1 rrn 700 80 0 1 1 1 1 1 0 0 1 0 0 1 1 conv 0 # bm $lr0v $lb1816v  3 ; rrn fadd $lb1792v  128 flt72to64 accz",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 720  4 1 # bm $lr0v $lb1824v  4",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 728  5 1 # bm $lr0v $lb1832v  5",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 730  6 1 # bm $lr0v $lb1840v  6",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 738  7 1 # bm $lr0v $lb1848v  7",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 740  8 1 # bm $lr0v $lb1856v  8",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 748  9 1 # bm $lr0v $lb1864v  9",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 750  a 1 # bm $lr0v $lb1872v  10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 758  b 1 # bm $lr0v $lb1880v  11",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 760  c 1 # bm $lr0v $lb1888v  12",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 768  d 1 # bm $lr0v $lb1896v  13",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 770  e 1 # bm $lr0v $lb1904v  14",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 778  f 1 # bm $lr0v $lb1912v  15",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 780 10 1 # bm $lr0v $lb1920v  16",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 788 11 1 # bm $lr0v $lb1928v  17",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 790 12 1 # bm $lr0v $lb1936v  18",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 798 13 1 # bm $lr0v $lb1944v  19",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a0 14 1 # bm $lr0v $lb1952v  20",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a8 15 1 # bm $lr0v $lb1960v  21",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b0 16 1 # bm $lr0v $lb1968v  22",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b8 17 1 # bm $lr0v $lb1976v  23",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c0 18 1 # bm $lr0v $lb1984v  24",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c8 19 1 # bm $lr0v $lb1992v  25",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d0 1a 1 # bm $lr0v $lb2000v  26",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d8 1b 1 # bm $lr0v $lb2008v  27",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e0 1c 1 # bm $lr0v $lb2016v  28",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e8 1d 1 # bm $lr0v $lb2024v  29",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0 1e 1 # bm $lr0v $lb2032v  30",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8 1f 1 # bm $lr0v $lb2040v  31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  3c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa pot pot $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 700  0 1 # bm $lr0v $lb1792v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 708  1 1 # bm $lr0v $lb1800v  1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 710  2 1 # bm $lr0v $lb1808v  2",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 718  3 1 rrn 700 80 0 1 1 1 1 1 0 0 1 0 0 1 1 conv 0 # bm $lr0v $lb1816v  3 ; rrn fadd $lb1792v  128 flt72to64 pot",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 720  4 1 # bm $lr0v $lb1824v  4",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 728  5 1 # bm $lr0v $lb1832v  5",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 730  6 1 # bm $lr0v $lb1840v  6",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 738  7 1 # bm $lr0v $lb1848v  7",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 740  8 1 # bm $lr0v $lb1856v  8",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 748  9 1 # bm $lr0v $lb1864v  9",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 750  a 1 # bm $lr0v $lb1872v  10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 758  b 1 # bm $lr0v $lb1880v  11",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 760  c 1 # bm $lr0v $lb1888v  12",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 768  d 1 # bm $lr0v $lb1896v  13",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 770  e 1 # bm $lr0v $lb1904v  14",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 778  f 1 # bm $lr0v $lb1912v  15",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 780 10 1 # bm $lr0v $lb1920v  16",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 788 11 1 # bm $lr0v $lb1928v  17",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 790 12 1 # bm $lr0v $lb1936v  18",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 798 13 1 # bm $lr0v $lb1944v  19",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a0 14 1 # bm $lr0v $lb1952v  20",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a8 15 1 # bm $lr0v $lb1960v  21",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b0 16 1 # bm $lr0v $lb1968v  22",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b8 17 1 # bm $lr0v $lb1976v  23",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c0 18 1 # bm $lr0v $lb1984v  24",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c8 19 1 # bm $lr0v $lb1992v  25",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d0 1a 1 # bm $lr0v $lb2000v  26",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d8 1b 1 # bm $lr0v $lb2008v  27",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e0 1c 1 # bm $lr0v $lb2016v  28",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e8 1d 1 # bm $lr0v $lb2024v  29",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0 1e 1 # bm $lr0v $lb2032v  30",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8 1f 1 # bm $lr0v $lb2040v  31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33"
};
static char* codes_4[]={
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  44 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa nnb nnb $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 700  0 1 # bm $lr0v $lb1792v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 708  1 1 # bm $lr0v $lb1800v  1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 710  2 1 # bm $lr0v $lb1808v  2",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 718  3 1 rrn 700 80 0 1 1 0 1 1 0 0 1 9 1 1 1 conv 0 # bm $lr0v $lb1816v  3 ; rrn umin $lb1792v  128 flt72to64 nnb",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 720  4 1 # bm $lr0v $lb1824v  4",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 728  5 1 # bm $lr0v $lb1832v  5",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 730  6 1 # bm $lr0v $lb1840v  6",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 738  7 1 # bm $lr0v $lb1848v  7",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 740  8 1 # bm $lr0v $lb1856v  8",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 748  9 1 # bm $lr0v $lb1864v  9",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 750  a 1 # bm $lr0v $lb1872v  10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 758  b 1 # bm $lr0v $lb1880v  11",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 760  c 1 # bm $lr0v $lb1888v  12",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 768  d 1 # bm $lr0v $lb1896v  13",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 770  e 1 # bm $lr0v $lb1904v  14",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 778  f 1 # bm $lr0v $lb1912v  15",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 780 10 1 # bm $lr0v $lb1920v  16",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 788 11 1 # bm $lr0v $lb1928v  17",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 790 12 1 # bm $lr0v $lb1936v  18",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 798 13 1 # bm $lr0v $lb1944v  19",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a0 14 1 # bm $lr0v $lb1952v  20",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7a8 15 1 # bm $lr0v $lb1960v  21",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b0 16 1 # bm $lr0v $lb1968v  22",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7b8 17 1 # bm $lr0v $lb1976v  23",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c0 18 1 # bm $lr0v $lb1984v  24",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7c8 19 1 # bm $lr0v $lb1992v  25",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d0 1a 1 # bm $lr0v $lb2000v  26",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7d8 1b 1 # bm $lr0v $lb2008v  27",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e0 1c 1 # bm $lr0v $lb2016v  28",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7e8 1d 1 # bm $lr0v $lb2024v  29",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0 1e 1 # bm $lr0v $lb2032v  30",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8 1f 1 # bm $lr0v $lb2040v  31",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 33"
};
static char* codes_5[]={
"ISP 4 0 1 0 1 0 1 0 0  0 0 0  0 1 1  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 4 0  7 1 0 0   0  0 0 # uxor $peid $lr0v $t ",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 1 1  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  2 1 0 0   0  0 0 # uinc  $lr0v $lr0v $lr0v",
"ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2   0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   a  0 1 # bm xi_b0 xi",
"ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2   8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  12  0 1 # bm yi_b0 yi",
"ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  10 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  1a  0 1 # bm zi_b0 zi",
"ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  18 1 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  22  0 0 # bm eps2i_b0 eps2i",
"ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  1c 1 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  26  0 0 # bm idi_b0 idi",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 1 1  # idp 1 1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 1 # rdp 1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # wdp",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10"
};
static char* codes_6[]={
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 1 1  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  7 1 0 0   0  0 0 rdp 1 # uxor  $lr0v $lr0v $lr0v ; rdp 1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # wdp",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 10"
};
static SING_register_grape_codes(int id[])
{
    int k;
    for (k=0;k< 7;k++) id[k]=-1;
    SING_iflush();
    id[1]=SING_iregister(8,(const char**)codes_1);
    id[2]=SING_iregister(68,(const char**)codes_2);
    id[3]=SING_iregister(270,(const char**)codes_3);
    id[4]=SING_iregister(67,(const char**)codes_4);
    id[5]=SING_iregister(30,(const char**)codes_5);
    id[6]=SING_iregister(32,(const char**)codes_6);
}
static SING_register_grape_codesMC(SINGinfo *s, int id[])
{
    int k;
    for (k=0;k< 7;k++) id[k]=-1;
    SING_iflush();
    id[1]=SING_iregisterMC(s,8,(const char**)codes_1);
    id[2]=SING_iregisterMC(s,68,(const char**)codes_2);
    id[3]=SING_iregisterMC(s,270,(const char**)codes_3);
    id[4]=SING_iregisterMC(s,67,(const char**)codes_4);
    id[5]=SING_iregisterMC(s,30,(const char**)codes_5);
    id[6]=SING_iregisterMC(s,32,(const char**)codes_6);
}

int * SING_codes_pointer()
{
    return ids;
}

int DMAW_size = (4096+1024)/8;

void SING_grape_init(int chipid)
{
    SING_set_chipid(chipid);
    SING_open();
    SING_send_vsm_constants();
    SING_setup_elt_data0();
    SING_setup_elt_data1();

    SING_register_i_particle_conversion();
    SING_register_grape_codes(ids);
    SING_set_result_size(0,sizeof(SING_rvp));
    SING_set_dmacheck_mode(1);
}
void SING_grape_initMC(int chipid)
{
    SINGinfo * s = chip[chipid]=SING_openMC(chipid);
    SING_send_vsm_constantsMC(s);
    SING_setup_elt_data0MC(chipid);
    SING_setup_elt_data1MC(chipid);

    SING_register_i_particle_conversionMC(s);
    SING_register_grape_codesMC(s,ids);
    SING_set_result_sizeMC(s, 0,sizeof(SING_rvp));
    SING_set_dmacheck_mode(1);
    SING_register_dma_seqMC(s, 0, 1, DMAW_size, s->c->h->dmaw_buf);
    CTRL_coc_setflags(0,-1,-1);
}

void SING_use_default_singstruct(int chipid)
{
    chip[chipid] = SING_get_singinfo();
}


int SING_grape_run(int n)
{
    int rrn_sizes[]={4096,1024};
    SING_EM_fifoclr();
    SING_move_elt_data0(0);
    return SING_execute2(4, ids+1, n,
                        NULL, (void*) &SING_rvp,
                        rrn_sizes);
}
int SING_grape_runMC(int chipid, int n)
{
    int rrn_sizes[]={4096,1024};
    SING_EM_fifoclrMC(chip[chipid]);
    SING_move_elt_data0MC(chipid,0);
    SING_initialize_dmawbufferMC(chip[chipid],sizeof(SING_rvp)/8);

    return SING_execute2MC(chip[chipid], 4, ids+1, n,
                           NULL, (void*) (SING_rvpa+chipid),
                           rrn_sizes);
}

int SING_grape_runMCP(int nchips, int chipid[], int n)
{
    int rrn_sizes[]={4096,1024};
    int i;
    static int firstcall = 1;
    if (nchips == 4){
    //    if (0){
	CTRL_beginbcast(chip[chipid[0]]->c);
	SING_EM_fifoclrMC(chip[chipid[0]]);
	SING_nwait(1000);
	if (firstcall){
	    firstcall=0;
	    SING_nwait(100000);
	}

	SING_move_elt_data0MC(chipid[0],0);
	CTRL_endbcast(chip[chipid[0]]->c);
    }else{
	for(i=0;i<nchips; i++)SING_EM_fifoclrMC(chip[chipid[i]]);
	for(i=0;i<nchips; i++)SING_move_elt_data0MC(chipid[i],0);
    }
    for(i=0;i<nchips; i++){
	SING_initialize_dmawbufferMC(chip[chipid[i]],sizeof(SING_rvp)/8);
    }
    SINGinfo *s[NCHIPS];
    SINGISP_INFO * info[NCHIPS];
    CTRLinfo *c[NCHIPS];
    void * final_out[NCHIPS];    
    void * loop_out[NCHIPS];
    
    for(i=0;i<nchips; i++){
	s[i] = chip[chipid[i]];
	info[i] = &(s[i]->isp);
	c[i] = s[i]->c;
	final_out[i] = (void*) (SING_rvpa+chipid[i]);
	loop_out[i] = NULL;
    }
    if (nchips == 4)     CTRL_coc_setflags(3,-1,-1);
    SING_execute2_i_start(info[0], nchips, c, 4, ids+1, n,
			  loop_out, final_out,  rrn_sizes);
    if (nchips == 4)     CTRL_coc_setflags(1,-1,-1);
    SING_execute2_i_end(info[0], nchips, c, 4, ids+1, n,
			loop_out,  final_out,  rrn_sizes);
    return 0;
}

int SING_wait_DMAR(int nchips, int chipid[])
{
    SINGinfo *s[NCHIPS];
    int i;
    for(i=0;i<nchips; i++){
	s[i] = chip[chipid[i]];
    }
    
    SING_DMAR_wait(nchips, s);
    return 0;
}

void SING_grape_close()
{
    SING_close();
}
void SING_grape_closeMC(int chipid)
{
    SING_closeMC(chip[chipid]);
}
