#include "typedef.h"
#include "sing.h"
#include "sing_chip.h"
#include "singMC.h"
#include "ctrl.h"
#define grape_j_particle_struct  SING_elt_struct0

struct SING_elt_struct0{
  double xj;
  double yj;
  double zj;
  double mj;
  double eps2;
  UINT32 idj;
  UINT32 itmp;
};
int SING_send_elt_data0(struct SING_elt_struct0 *ip, int index_in_EM);
int SING_setup_elt_data0MC(int chipid);
int SING_send_elt_data0MC(int chipid, struct SING_elt_struct0 *ip, int index_in_EM);
int SING_move_elt_data0(int index);
int SING_move_elt_data0MC(int chipid, int index);
int SING_elt_size0();
int SING_send_elt_data0_m(struct SING_elt_struct0 *ip, int index_in_EM, int ndata);

int SING_send_elt_data0_mMC(int chipid, struct SING_elt_struct0 *ip, int index_in_EM, int ndata);

int SING_send_elt_data0_vMC(int chipid, struct SING_elt_struct0 *ip, int index[], int ndata);


struct SING_elt_struct1{
  double xi_b0[4];
  double yi_b0[4];
  double zi_b0[4];
  double eps2i_b0[4];
  UINT64 idi_b0[4];
};
int SING_send_elt_data1(struct SING_elt_struct1 *ip, int index_in_EM);
int SING_setup_elt_data1MC(int chipid);
int SING_send_elt_data1MC(int chipid, struct SING_elt_struct1 *ip, int index_in_EM);
int SING_move_elt_data1(int index);
int SING_move_elt_data1MC(int chipid, int index);
int SING_elt_size1();
int SING_send_elt_data1_m(struct SING_elt_struct1 *ip, int index_in_EM, int ndata);

int SING_send_elt_data1_mMC(int chipid, struct SING_elt_struct1 *ip, int index_in_EM, int ndata);

int SING_send_elt_data1_vMC(int chipid, struct SING_elt_struct1 *ip, int index[], int ndata);

struct SING_hlt_struct0{
  double xi;
  double yi;
  double zi;
  double eps2i;
  UINT64 idi;
};
struct SING_hlt_vector_struct0{
  double xi[4];
  double yi[4];
  double zi[4];
  double eps2i[4];
  UINT64 idi[4];
};
int SING_send_i_particle(struct SING_hlt_struct0 *ip,
                         int n);
int SING_send_i_particleMC(int chipid, struct SING_hlt_struct0 *ip,
                         int n);
int SING_send_i_particleMCP(int nchips, int chipid[],
                          struct SING_hlt_struct0 *ip,
                          int n);
#define grape_i_particle_struct SING_hlt_struct0
#define grape_i_particle_vector_struct SING_hlt_vector_struct0
int SING_npipes();
struct SING_result_struct{
  double accx;
  double accy;
  double accz;
  double pot;
  double nnb;

};
struct SING_result_vectorstruct{
  double accx[128];
  double accy[128];
  double accz[128];
  double pot[128];
  double nnb[128];

};
int SING_get_result(struct SING_result_struct *rp);
int SING_get_resultMC(int chipid, struct SING_result_struct *rp);
#define  grape_result_struct SING_result_struct 
void SING_grape_init(int chipid);
int SING_grape_run(int n);
int SING_type2_run(int n, void * loopout);
void SING_grape_initMC(int chipid);
int SING_grape_runMC(int chipid, int n);
int SING_type2_runMC(int chipid, int n, void * loopout);
int SING_wait_DMAR(int nchips, int chipid[]);
int SING_grape_runMCP(int nchips, int chipid[], int n);
void SING_grape_close();
void SING_grape_closeMC(int chipid);
