#include <stdio.h>
#include <stdarg.h>
#include "./simplegravity-k-16x32.h"
#ifndef NJP
#    define NJP 65536
#endif
struct SING_grape_consts{
  INT64 _const_0;
  INT64 _const_1;
  UINT64 _const_2[2];
  UINT64 _const_3;
  UINT64 _const_4;
  double _const_5;
  double _const_6;
  double _const_7;
  double _const_8;
  double _const_9;
};
struct SING_grape_consts constants;

int SING_send_vsm_constants()
{
    int ndata = 11;
    int firstaddress= 58;
    int conversions[]={4,4,6,6,6,6,1,1,1,1,1};

    constants._const_0 = 60;
    constants._const_1 = 1;
    constants._const_2[0] = 0;
    constants._const_2[1] = 0x9fdLL;
    constants._const_3 = 0x000ffffffLL;
    constants._const_4 = 0x3ff000000LL;
    constants._const_5 = 0.57;
    constants._const_6 = 1.57;
    constants._const_7 = 1.414;
    constants._const_8 = 0.5;
    constants._const_9 = 1.5;

    SING_LM_write_regconv(ndata,conversions);
    SING_LM_write(&constants, firstaddress, 0);
}
int SING_send_j_particle(struct SING_elt_struct0 *jp, int index)
{
      return SING_send_elt_data0(jp, index);
}


static SING_copy_ip_to_vip(struct SING_hlt_struct0 *p,
                                 struct SING_hlt_vector_struct0 *vp,
			         int k)
{
   vp->xi[k]= p->xi;
   vp->yi[k]= p->yi;
   vp->zi[k]= p->zi;

}

int SING_send_i_particle(struct SING_hlt_struct0 *ip,
                         int n)
{
    struct SING_hlt_vector_struct0 ipv[NPEMAX];
    int i;
    for(i=0;i<n;i++){
        int iv = i/4;
	int k  = i%4;
        SING_copy_ip_to_vip(ip+i, ipv+iv, k);
    }
    i = (n+3)/4;
    SING_LM_write(ipv, 0, i);
}

void SING_register_i_particle_conversion()
{
    int conversions[]={0,0,0,0,0,0,0,0,0,0,0,0};

    SING_LM_write_regconv(12,conversions);
}




static int emid0;
static int bmid0;
int SING_setup_elt_data0()
{
    int err;
    int conversions[]={0,0,0,1,1};

    emid0=SING_EM_alloc(5, conversions, 65536, &err);
    if (emid0 < 0){
        fprintf(stderr,"register jp, EMalloc err = %d\n",err);
        exit(-1);
    }
    bmid0=SING_BM_alloc(emid0,1,&err);
    if (bmid0 < 0){
    fprintf(stderr,"register jp, BMalloc err = %d\n",err);
          exit(-1);
    }
}


int SING_send_elt_data0(struct SING_elt_struct0 *ip, int index_in_EM)
{
    int ret;
    ret = SING_EM_send(emid0,index_in_EM,1,ip);
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(-1);
    }
}

int SING_move_elt_data0(int index)
{
    SING_EM_BM_transfer(bmid0,index,0,1,1,-1);
}
