#include <stdio.h>
#include <stdarg.h>
#include "./simplegravity-k.h"
#ifndef NJP
#    define NJP 65536
#endif
struct SING_grape_consts{
  INT64 _const_0;
  INT64 _const_1;
  UINT64 _const_2[2];
  UINT64 _const_3;
  UINT64 _const_4;
  double _const_5;
  double _const_6;
  double _const_7;
  double _const_8;
  double _const_9;
};
struct SING_grape_consts constants;

int SING_send_vsm_constants()
{
    int ndata = 11;
    int firstaddress= 58;
    int conversions[]={4,4,6,6,6,6,1,1,1,1,1};

    constants._const_0 = 60;
    constants._const_1 = 1;
    constants._const_2[0] = 0;
    constants._const_2[1] = 0x9fdLL;
    constants._const_3 = 0x000ffffffLL;
    constants._const_4 = 0x3ff000000LL;
    constants._const_5 = 0.57;
    constants._const_6 = 1.57;
    constants._const_7 = 1.414;
    constants._const_8 = 0.5;
    constants._const_9 = 1.5;

    SING_LM_write_regconv(ndata,conversions);
    SING_LM_write(&constants, firstaddress, 0);
}
int SING_send_j_particle(struct SING_elt_struct0 *jp, int index)
{
      return SING_send_elt_data0(jp, index);
}


static SING_copy_ip_to_vip(struct SING_hlt_struct0 *p,
                                 struct SING_hlt_vector_struct0 *vp,
			         int k)
{
   vp->xi[k]= p->xi;
   vp->yi[k]= p->yi;
   vp->zi[k]= p->zi;

}

int SING_send_i_particle(struct SING_hlt_struct0 *ip,
                         int n)
{
    struct SING_hlt_vector_struct0 ipv[NPEMAX];
    int i;
    for(i=0;i<n;i++){
        int iv = i/4;
	int k  = i%4;
        SING_copy_ip_to_vip(ip+i, ipv+iv, k);
    }
    i = (n+3)/4;
    SING_LM_write(ipv, 0, i);
}

void SING_register_i_particle_conversion()
{
    int conversions[]={0,0,0,0,0,0,0,0,0,0,0,0};

    SING_LM_write_regconv(12,conversions);
}




static int emid0;
static int bmid0;
int SING_setup_elt_data0()
{
    int err;
    int conversions[]={0,0,0,1,1};

    emid0=SING_EM_alloc(5, conversions, 65536, &err);
    if (emid0 < 0){
        fprintf(stderr,"register jp, EMalloc err = %d\n",err);
        exit(-1);
    }
    bmid0=SING_BM_alloc(emid0,1,&err);
    if (bmid0 < 0){
    fprintf(stderr,"register jp, BMalloc err = %d\n",err);
          exit(-1);
    }
}


int SING_send_elt_data0(struct SING_elt_struct0 *ip, int index_in_EM)
{
    int ret;
    ret = SING_EM_send(emid0,index_in_EM,1,ip);
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(-1);
    }
}

int SING_move_elt_data0(int index)
{
    SING_EM_BM_transfer(bmid0,index,0,1,1,-1);
}
static char* codes_1[]={
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 0   # idp 0",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  7 1 0 0   0  0 0 #  uxor $t $t $t",
"ISP 4 0 0 0 0 1 0 1 1 28 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $ti $ti $lr40v",
"ISP 4 0 0 0 0 0 0 1 1 30 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0  wdp #  upassa $t $t   $lr48v",
"ISP 4 0 0 0 0 0 0 1 1 38 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $t $t   $lr56v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 1  32 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $t $t   pot"
};
static char* codes_2[]={
"ISP 3 0 0 0 0 0 0 1 2  0 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 1 #  bm vxj $lr0v",
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  18 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   6  0 0 #  bm mj lmj",
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  19 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   7  0 0 #  bm eps2 leps2",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0  idp 0 #  nop 2",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0  rdp 0 #  nop 2",
"ISP 4 0 0 0 1 0 1 1 1  6 1 0  0 0 1  0 0 0 0 0   0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub $lr0 xi $r6v  $t",
"ISP 4 0 0 0 1 1 0 1 1  a 1 0  2 0 1  0 0 0 0 0   8 1 0 1 0 0 0 1 0 0 0 1 0 1 2 2 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub $lr2 yi $r10v ;  fmul $ti $ti $t ",
"ISP 4 0 0 0 0 0 0 1 1  e 1 0  4 0 1  0 0 0 0 0  10 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub $lr4 zi $r14v   ",
"ISP 4 0 0 0 1 0 1 1 0 12 1 0  a 1 0  0 0 0 0 0  19 0 0 0 0 0 0 1 0 0 0 1 1 1 0 0 1 1 0 0 1 2 3  0 0 1 0   0  0 0 #  fmul $r10v $r10v $r18v ; fadd $t leps2 $t",
"ISP 4 0 0 0 0 0 0 1 0 16 1 0  e 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r14v $r14v $r22v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0 12 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 0  0 0 1 0   0  0 0 #  fadd $t $r18v $t",
"ISP 4 0 0 0 1 1 1 1 1 12 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 1 1 2 0  0 0 1 0   0  0 0 #  fadd $ti $r22v $r18v $t # rsq is now in r18 t, dx, dy,dz are in  6,10,14",
"ISP 4 0 0 0 1 1 1 1 1 16 1 1  0 0 0  0 0 0 0 0  3a 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  d 1 0 0   0  0 0 #  ulsr $ti     _const_0  $t $lr22v",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  3c 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  d 1 0 0   0  0 0 #  ulsr $ti     _const_1   $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0 16 1 1  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 2  0 1 0 0   0  0 0 #  uadd $lr22v     $ti  $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  3e 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 2  1 1 0 0   0  0 0 #  usub _const_2 $ti     $t       # $lr8v ϻؿ1.5",
"ISP 4 0 0 0 0 1 0 1 1 1e 1 1  0 0 0  0 0 0 0 0  3a 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  c 1 0 0   0  0 0 #  ulsl $ti     _const_0  $lr30v",
"ISP 4 0 1 0 0 0 0 0 0  0 0 0 16 1 1  0 0 0 0 0  3c 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 0  5 1 0 0   0  0 0 #  uand _const_1 $lr22v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0 12 1 0  0 0 0 0 0  40 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 3  5 1 0 0   0  0 0 #  uand $r18v _const_3 $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  41 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  6 1 0 0   0  0 0 #  uor  $ti _const_4 $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0  42 0 0 0 0 0 0 1 0 0 0 1 0 1 2 3 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti _const_5 $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  43 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_6 $ti $t",
"ISP 4 1 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0  44 0 0 0 0 0 0 1 0 0 0 1 0 1 3 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul _const_7 $ti $t",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 0 0 0 1 0 0 1 0 16 1 0 1e 1 1  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $t $lr30v $t $r22v # Here the result is the initial guess",
"ISP 4 0 0 0 1 0 0 1 0 1a 1 0 12 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r18v $r18v $r26v $t",
"ISP 4 0 0 0 1 1 0 1 0 1a 1 0 12 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r18v $ti   $r26v $t",
"ISP 4 0 0 0 0 1 0 1 0 1a 1 0  0 0 0  0 0 0 0 0  45 0 0 0 0 0 0 1 0 0 0 1 1 1 2 3 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti _const_8 $r26v # r26v is a**3/2",
"ISP 4 0 0 0 1 0 0 0 0  0 0 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $r22v $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  46 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_9 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  46 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_9 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  46 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_9 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  46 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_9 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  46 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_9 $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t  # $t is the resulted r2**(-3/2)",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0  0 0 0  0 0 0 0 0  18 0 0 0 0 0 0 1 0 0 0 1 1 1 3 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul lmj $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 1 1  0 1 1  6 1 0  0 0 0 0 0  32 1 0 1 0 0 0 1 0 0 0 1 0 1 0 2 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  fmul $r6v $ti $t ; upassa pot pot $lr0v",
"ISP 4 0 0 0 0 1 0 1 1 28 1 1 28 1 1  0 0 0 1 1  1a 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 2  0 0 1 0   0  0 0 #  fadd $lr40v $ti $lr40v accx",
"ISP 4 0 0 0 1 0 0 0 0  0 0 0  a 1 0 16 1 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 1 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r10v $r22v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1 30 1 1  0 0 0 1 1  22 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 2  0 0 1 0   0  0 0 #  fadd $lr48v $ti $lr48v accy",
"ISP 4 0 0 0 1 0 0 0 0  0 0 0  e 1 0 16 1 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 1 1 1 0 0 1 0 0  0 0 0 0   0  0 0  wdp #  fmul $r14v $r22v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1 38 1 1  0 0 0 1 1  2a 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 2  0 0 1 0   0  0 0 #  fadd $lr56v $ti $lr56v accz",
"ISP 4 0 0 0 1 0 0 0 0  0 0 0 12 1 0 16 1 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 1 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r18v $r22v $t",
"ISP 4 0 0 0 0 1 0 0 0  0 0 0  0 1 1  0 0 0 1 1  32 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 2  0 0 1 0   0  0 0 #  fadd $lr0v $ti pot"
};
static char* codes_3[]={
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  1a 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa accx accx $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0  0 1 # bm $lr0v $lb2032v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8  1 1 # bm $lr0v $lb2040v  1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  22 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa accy accy $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0  0 1 # bm $lr0v $lb2032v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8  1 1 # bm $lr0v $lb2040v  1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  2a 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa accz accz $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0  0 1 # bm $lr0v $lb2032v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8  1 1 # bm $lr0v $lb2040v  1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  32 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa pot pot $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0  0 1 # bm $lr0v $lb2032v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8  1 1 # bm $lr0v $lb2040v  1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3"
};
static SING_register_grape_codes(int id[])
{
    int k;
    for (k=0;k<4;k++) id[k]=-1;
    SING_iflush();
    id[1]=SING_iregister(6,codes_1);
    id[2]=SING_iregister(57,codes_2);
    id[3]=SING_iregister(33,codes_3);
}

static int ids[4];
int * SING_codes_pointer()
{
    return ids;
}

void SING_grape_init(int chipid)
{
    SING_set_chipid(int chipid);
    SING_open();
    SING_send_vsm_constants();
    SING_setup_elt_data0();

    SING_register_i_particle_conversion();
    SING_register_grape_codes(ids);
    SING_set_result_size(0,sizeof(SING_rvp));
}


int SING_grape_run(int n)
{
    SING_EM_fifoclr();
    SING_move_elt_data0(0);
    return SING_execute(ids[1],ids[2],ids[3], n,
                        NULL, (void*) &SING_rvp);
}
void SING_grape_close()
{
    SING_close();
}

