#include <stdio.h>
#include <stdarg.h>
#include "./simpletest.h"
struct grape_consts{
  double _const_0;
};
struct grape_consts constants;

int SING_send_vsm_constants()
{
    int ndata = 1;
    int firstaddress= 16;
    int conversions[]={1};

    constants._const_0 = 1;

    SING_LM_write_regconv(ndata,conversions);
    SING_LM_write(&constants, firstaddress, 0);
}
int SING_send_j_particle(struct grape_j_particle_struct *jp,
                         int index_in_EM)
{
    int length = ((sizeof(struct grape_j_particle_struct)+4)/8)*8;
    int offset = length*index_in_EM/sizeof(INT32);
    SING_EM_write(length, (void*)jp,offset);
}

void SING_register_j_particle_conversion()
{
    int conversions[]={0};

    SING_EM_BM_transfer_register(1,
			     conversions,
			     0,
			     1);
}



static SING_copy_ip_to_vip(struct grape_i_particle_struct *p,
			   struct grape_i_particle_vector_struct *vp,
			   int k)
{
   vp->xi[k]= p->xi;

}

int SING_send_i_particle(struct grape_i_particle_struct *ip,
                         int n)
{
    struct grape_i_particle_vector_struct ipv[NPE];
    int i;
    for(i=0;i<n;i++){
        int iv = i/4;
	int k  = i%4;
        SING_copy_ip_to_vip(ip+i, ipv+iv, k);
    }
    i = (n+3)/4;
    SING_LM_write(ipv, 0, i);
}

void SING_register_i_particle_conversion()
{
    int conversions[]={0,0,0,0};

    SING_LM_write_regconv(4,conversions);
}


static char* rrnstring[]={
"RRN    8 4 0 1 1 1 1 1 0 0 1  0 0 1 1 # fadd lx"
};
static SING_copy_vr_to_r(struct grape_result_vector_struct *vp,
                         struct grape_result_struct *p,
                         int k)
{
   p->lx=vp->lx[k];

}

static int n_rrn;

int SING_get_result(struct grape_result_struct *rp)
{
    struct grape_result_vector_struct rvp;
    int i;
    int n = (NPE*4);
    SING_LM_read((UINT32*)&rvp);

    for(i=0;i<n;i++){
        SING_copy_vr_to_r(&rvp, rp+i,i);
    }
}

void SING_register_result_conversion()
{
    int conversions[]={0};

    SING_LM_read_regconv(1,conversions,rrnstring,
                          8,1,0);
}

char* codes_1[]={
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 1   8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  7 1 0 0   0  0 0 #  uxor $t $t lx"
};
char* codes_2[]={
"ISP 1 0 0 0 0 0 0 1 2  0 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 1 #  bm xj $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  4 1 1  0 0 0 0 0  10 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 0  a 1 0 0   0  0 0 #  upassa _const_0 $lr4v",
"ISP 4 0 0 0 0 0 0 1 1  4 1 1  0 0 0  0 0 0 0 0   8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  upassa lx lx $lr4v",
"ISP 4 0 0 0 0 0 0 1 1  4 1 1  0 0 1  4 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 1  0 0 1 0   0  0 0 #  fadd $lr0  $lr4v $lr4v",
"ISP 4 0 0 0 0 0 0 1 1  4 1 1  4 1 1  0 0 0 0 0   0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 0  0 0 1 0   0  0 0 #  fadd xi  $lr4v $lr4v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  4 1 1  0 0 0 1 1   8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  a 1 0 0   0  0 0 #  upassa $lr4v  $lr4v lx"
};
static SING_register_grape_codes(int id[])
{
    int k;
    for (k=0;k<3;k++) id[k]=-1;
    SING_iflush();
    id[1]=SING_iregister(1,codes_1,-1);
    id[2]=SING_iregister(6,codes_2,1);
}

static ids[3];

void SING_grape_init()
{
    SING_open();
    SING_send_vsm_constants();
    SING_register_j_particle_conversion();
    SING_register_i_particle_conversion();
    SING_register_grape_codes(ids);
    SING_register_result_conversion();

}

int SING_grape_run(int n)
{
    return SING_execute(ids[1],ids[2], n);
}
