
#include <stdio.h>
#include <math.h>
#include "ew02.h"

#define NI 2
#define NJ 2

struct grape_j_particle_struct xj[NJ];
struct grape_i_particle_struct xi[NI*4];
struct grape_result_struct result[NI*4];
struct SING_hlt_struct1 hlt1;

struct force {
  double x,y,z;
} fc[NI*4];

void init()
{
    int i;
    xj[0].xj=0;
    xj[0].yj=0;
    xj[0].zj=0;
    xj[0].chargej = 1.0;
    xj[1].xj=-1.0;
    xj[1].yj=0;
    xj[1].zj=0;
    xj[1].chargej = 0.0;

    for(i=0;i<NJ;i++)
      SING_send_j_particle(xj+i, i);
    
    xi[0].xi=0;
    xi[0].yi=0;
    xi[0].zi=0;
    for(i=1;i<(NI*4);i++)xi[i]=xi[0];
    for(i=0;i<(NI*4);i++)xi[i].xi=0;
    for(i=0;i<(NI*4);i++)xi[i].yi=1.0/(i+1.0);
    for(i=0;i<(NI*4);i++)xi[i].zi=0;
    for(i=0;i<(NI*4);i++){
	fprintf(stderr,"test init i=%d, x, y, z= %e %e %e\n",
		i,xi[i].xi,xi[i].yi,xi[i].zi);
    }

    hlt1.test0 = 0;
    hlt1.test1 = 1;
    hlt1.test2 = 2;
    hlt1.test3 = 3;
    hlt1.test4 = 4;
    SING_send_hlt_data1(&hlt1, 0);
    SING_register_i_particle_conversion();

}
    
print_result(struct grape_result_struct * result)
{
    struct grape_result_struct *p;
    int i;
    p=result;
    for(i=0;i<(NI*4);i++){
	fprintf(stderr,"test result i=%d, x, y, z= %e %e %e\n",
		i,p->accx,p->accy,p->accz);
	p++;
    }
}    
print_host_result(void)
{
  int i,j;
  double d0,d1,d2,d3,d4;

  printf("\n");
  for(i = 0; i < NI*4; i++){
    fc[i].x = 0; fc[i].y = 0; fc[i].z = 0;
    for(j = 0; j < NJ; j++){
      d0 = xj[j].xj - xi[i].xi;
      d1 = xj[j].yj - xi[i].yi;
      d2 = xj[j].zj - xi[i].zi;
      d3 = d0*d0 + d1*d1 + d2*d2;
      d4 = 1.0*pow(d3,-7) - 0.5*pow(d3,-4);
      fc[i].x += d0*d4;
      fc[i].y += d1*d4;
      fc[i].z += d2*d4;
    }
    fprintf(stderr,"host result i=%d, x, y, z= %e %e %e\n",
	    i,fc[i].x,fc[i].y,fc[i].z);
  }
}
int main()
{
    SING_grape_init();
    init();
    SING_send_i_particle(xi, NI*4);
    SING_grape_run(1);
    SING_get_result(result);
    print_result(result);
    /*    print_host_result();*/
}
