//
// testsimplegravity.c
// test driver for simplegravity.vsm-generated interface library
//
// J. Makino Dec 4 2004
#include <stdio.h>
#include "test.h"

#define N 2

struct grape_j_particle_struct xj[N];
struct grape_i_particle_struct xi[N*4];
struct grape_result_struct result[N*4];
struct SING_hlt_struct2 hlt2;

void init()
{
    int i;
    xj[0].xj=0;
    xj[0].yj=1;
    xj[0].zj=2;
    xj[1]=xj[0];
    xj[1].xj=0;
    xj[1].mj=1;
    xj[0].mj=2;
    fprintf(stderr,"enter SING send j\n");
    for(i=0;i<N;i++)SING_send_j_particle(xj+i, i);
    fprintf(stderr,"end SING send j\n");
    
    xi[0].xi=0;
    xi[0].yi=0;
    xi[0].zi=0;
    for(i=1;i<(N*4);i++)xi[i]=xi[0];
    for(i=0;i<(N*4);i++)xi[i].xi=0;
    for(i=0;i<(N*4);i++)xi[i].yi=1.0/(i+1.0);
    for(i=0;i<(N*4);i++)xi[i].zi=0;
    for(i=0;i<(N*4);i++){
	fprintf(stderr,"test init i=%d, x, y, z= %e %e %e\n",
		i,xi[i].xi,xi[i].yi,xi[i].zi);
    }

    hlt2.testb[0]=1;
    hlt2.testb[1]=2;
    hlt2.testb[2]=4;
    hlt2.testb[3]=99;
    SING_send_hlt_data2(&hlt2, 0);
    SING_register_i_particle_conversion();
}
    
print_result(struct grape_result_struct * result)
{
    struct grape_result_struct *p;
    int i;
    p=result;
    for(i=0;i<(N*4);i++){
	fprintf(stderr,"test result i=%d, x, y, z= %e %e %e\n",
		i,p->accx,p->accy,p->accz);
	p++;
    }
}    

int main()
{
    SING_grape_init();
    init();
    SING_send_i_particle(xi, N*4);
    SING_grape_run(1);
    SING_get_result(result);
    print_result(result);
    
}
