//
// testsgravity.c
// test driver for gravity.vsm-generated interface library
//
// J. Makino
//    Time-stamp: <2005/07/10 13:47:21 makino>

#include <stdio.h>
#include "gravity.h"

#define N 2

struct grape_j_particle_struct xj[N];
struct grape_i_particle_struct xi[N*4];
struct gravity_result_struct result[N*4];

void init()
{
    int i;
    xj[0].xj=0.0;
    xj[0].yj=0.0;
    xj[0].zj=0.0;
    xj[0].mj=1;
    xj[0].eps2=0;
    for(i=1;i<(N*4);i++)xj[i]=xj[0];
    xj[1]=xj[0];
    xj[1].xj=0;
    xj[1].mj=1;
    for(i=0;i<N;i++){
	xj[i].idxj=8;
	gravity_send_j_particle(xj+i, i);
    }
    
    xi[0].xi=0;
    xi[0].yi=0;
    xi[0].zi=0;
    for(i=1;i<(N*4);i++)xi[i]=xi[0];
    for(i=0;i<(N*4);i++)xi[i].xi=0;
    for(i=0;i<(N*4);i++)xi[i].yi=1.0/(i+1.0);
    for(i=0;i<(N*4);i++)xi[i].zi=0;
    for(i=0;i<(N*4);i++)xi[i].idxi=i;
    for(i=0;i<(N*4);i++){
	fprintf(stderr,"test init i=%d, x, y, z= %e %e %e\n",
		i,xi[i].xi,xi[i].yi,xi[i].zi);
    }
}
    
print_result(struct gravity_result_struct * result)
{
    struct gravity_result_struct *p;
    int i;
    p=result;
    for(i=0;i<(N*4);i++){
	fprintf(stderr,"test result i=%d, x, y, z, pot= %e %e %e %e\n",
		i,p->accx,p->accy,p->accz,p->pot);
	p++;
    }
}    

int main()
{
    int i, niparallel, ni, nj;
    ni=N*4;
    nj=N;
    gravity_grape_init();
    init();
    niparallel = SING_number_of_pe()*4;
    for (i=0; i< ni;i+=niparallel){
	int njreal = nj/SING_number_of_bb();
	gravity_send_i_particle(xi+i, niparallel);
	printf("i, njreal=%d %d\n", i, njreal);
	gravity_grape_run(njreal);
	gravity_get_result(result+i);
    }
    print_result(result);
    
}
