#include <stdio.h>
#include <stdarg.h>
#include "./tmp.h"
#ifndef NJP
#    define NJP 65536
#endif
struct XXX_grape_consts{
  INT64 _const_0;
  INT64 _const_1;
  UINT64 _const_2[2];
  UINT64 _const_3;
  UINT64 _const_4;
  double _const_5;
  double _const_6;
  double _const_7;
  double _const_8;
  double _const_9;
};
struct XXX_grape_consts constants;

int XXX_send_vsm_constants()
{
    int ndata = 11;
    int firstaddress= 68;
    int conversions[]={4,4,6,6,6,6,1,1,1,1,1};

    constants._const_0 = 60;
    constants._const_1 = 1;
    constants._const_2[0] = 0;
    constants._const_2[1] = 0x9fdLL;
    constants._const_3 = 0x000ffffffLL;
    constants._const_4 = 0x3ff000000LL;
    constants._const_5 = 0.57;
    constants._const_6 = 1.57;
    constants._const_7 = 1.414;
    constants._const_8 = 0.5;
    constants._const_9 = 1.5;

    SING_LM_write_regconv(ndata,conversions);
    SING_LM_write(&constants, firstaddress, 0);
}
static int emareaid;
static int bmareaid;
int XXX_send_j_particle(struct grape_j_particle_struct *jp,
                         int index_in_EM)
{
//    int length = ((sizeof(struct grape_j_particle_struct)+4)/8)*8;
//    int offset = length*index_in_EM/sizeof(INT32);
//    SING_EM_write(length/sizeof(INT32), (void*)jp,offset);
      int ret;
      ret = SING_EM_send(emareaid,index_in_EM,1, (void*) jp);
      if (ret){
          fprintf(stderr,"SING_EM_send returns: %d\n", ret);
          exit(-1);
      }
}


// for multiple-routine version, these static variables
// must be made routine-specific

void XXX_register_j_particle_conversion()
{
    int err;
    int conversions[]={0,0,0,1,1,9};

//    SING_EM_BM_transfer_register(6,
//			     conversions,
//			     0,
//			     1);
    emareaid=SING_EM_alloc(6, conversions, NJP, &err);
    if (emareaid < 0){
        fprintf(stderr,"register jp, EMalloc err = %d\n",err);
        exit(-1);
    }
    bmareaid=SING_BM_alloc(emareaid,vpm_number_of_bb(),&err);
    if (bmareaid < 0){
        fprintf(stderr,"register jp, BMalloc err = %d\n",err);
        exit(-1);
    }
}



static XXX_copy_ip_to_vip(struct grape_i_particle_struct *p,
			   struct grape_i_particle_vector_struct *vp,
			   int k)
{
   vp->xi[k]= p->xi;
   vp->yi[k]= p->yi;
   vp->zi[k]= p->zi;
   vp->idxi[k]= p->idxi;

}

int XXX_send_i_particle(struct grape_i_particle_struct *ip,
                         int n)
{
    struct grape_i_particle_vector_struct ipv[NPE];
    int i;
    for(i=0;i<n;i++){
        int iv = i/4;
	int k  = i%4;
        XXX_copy_ip_to_vip(ip+i, ipv+iv, k);
    }
    i = (n+3)/4;
    SING_LM_write(ipv, 0, i);
}

void XXX_register_i_particle_conversion()
{
    int conversions[]={0,0,0,0,0,0,0,0,0,0,0,0,9,9,9,9};

    SING_LM_write_regconv(16,conversions);
}




int XXX_send_hlt_data1(struct XXX_hlt_struct1 *ip,
                         int peindex)
{
    int conversions[]={9,9,9,9};

    SING_LM_write_regconv(4,conversions);
    SING_LM_write(ip, 28, peindex);
}



int XXX_send_elt_data1(struct XXX_elt_struct1 *ip)
{
    int err;
    static int firstcall = 1;
    static int emid;
    static int bmid;
    int conversions[]={0};


//    SING_LM_write_regconv(1,conversions);
//    SING_LM_write(ip, 6, peindex);
    if (firstcall){
       emid=SING_EM_alloc(1, conversions, 1, &err);
       if (emid < 0){
           fprintf(stderr,"register jp, EMalloc err = %d\n",err);
           exit(-1);
       }
       bmid=SING_BM_alloc(emid,1,&err);
       if (bmid < 0){
          fprintf(stderr,"register jp, BMalloc err = %d\n",err);
          exit(-1);
       }
       firstcall=0;
    }
    SING_EM_send(emid,0,1,ip);
    SING_EM_BM_transfer(bmid,0,0,1,0,-1);
}

static char* rrnstring[]={
"RRN   24 4 0 1 1 1 1 1 0 0 1  0 0 1 1 # fadd accx",
"RRN   2c 4 0 1 1 1 1 1 0 0 1  0 0 1 1 # fadd accy",
"RRN   34 4 0 1 1 1 1 1 0 0 1  0 0 1 1 # fadd accz",
"RRN   3c 4 0 1 1 1 1 1 0 0 1  0 0 1 1 # fadd pot"
};
static XXX_copy_vr_to_r(struct grape_result_vector_struct *vp,
                         struct grape_result_struct *p,
                         int k)
{
   p->accx=vp->accx[k];
   p->accy=vp->accy[k];
   p->accz=vp->accz[k];
   p->pot=vp->pot[k];

}

static int n_rrn;

int XXX_get_result(struct grape_result_struct *rp)
{
    struct grape_result_vector_struct rvp;
    int i;
    int n = (NPE*4);
    SING_LM_read((UINT32*)&rvp);

    for(i=0;i<n;i++){
        XXX_copy_vr_to_r(&rvp, rp+i,i);
    }
}

void XXX_register_result_conversion()
{
    int conversions[]={0,0,0,0};

    SING_LM_read_regconv(4,conversions,rrnstring,
                          36,1,0);
}

static char* codes_1[]={
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  7 1 0 0   0  0 0 #  uxor $t $t $t",
"ISP 4 0 0 0 0 1 0 1 1 28 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $ti $ti $lr40v",
"ISP 4 0 0 0 0 0 0 1 1 30 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $t $t   $lr48v",
"ISP 4 0 0 0 0 0 0 1 1 38 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $t $t   $lr56v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 1  3c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $t $t   pot"
};
static char* codes_2[]={
"ISP 3 0 0 0 0 0 0 1 2  0 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 1 #  bm vxj $lr0v",
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  20 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   8  0 0 #  bm mj lmj",
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  21 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   9  0 0 #  bm eps2 leps2",
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  22 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   a  0 0 #  bm idxj lidxj",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 0  0 0 0 0 0  18 1 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  upassa idxi  idxi  $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  22 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  7 1 0 0   0  0 0 #  uxor  $ti lidxj $t",
"ISP 4 0 2 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2 10 1 0 0   0  0 0 #  ulnot $ti $ti $t  # mreg 1 indicates i != j",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 0 0 0 1 0 1 1 1  6 1 0  0 0 1  0 0 0 0 0   0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub $lr0 xi $r6v  $t",
"ISP 4 0 0 0 1 1 0 1 1  a 1 0  2 0 1  0 0 0 0 0   8 1 0 1 0 0 1 1 0 0 1 1 0 1 2 2 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub $lr2 yi $r10v ;  fmul $ti $ti $t",
"ISP 4 0 0 0 0 0 0 1 1  e 1 0  4 0 1  0 0 0 0 0  10 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub $lr4 zi $r14v   ",
"ISP 4 0 0 0 1 0 1 1 0 12 1 0  a 1 0  0 0 0 0 0  21 0 0 0 0 0 0 1 0 0 0 1 1 1 0 0 1 1 0 0 1 2 3  0 0 1 0   0  0 0 #  fmul $r10v $r10v $r18v ; fadd $t leps2 $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  e 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 0 1 1 0 0 1 6 2  0 0 1 0   0  0 0 #  fmul $r14v $r14v ;  fadd $fb $ti  $t",
"ISP 4 0 0 0 1 1 1 1 1 12 1 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 1 1 6 2  0 0 1 0   0  0 0 #  fadd $fb $ti  $r18v $t # rsq is now in r18 t, dx, dy,dz are in  6,10,14",
"ISP 4 0 0 0 1 1 1 1 1 16 1 1  0 0 0  0 0 0 0 0  44 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  d 1 0 0   0  0 0 #  ulsr $ti     _const_0  $t $lr22v",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  46 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  d 1 0 0   0  0 0 #  ulsr $ti     _const_1   $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0 16 1 1  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 0  0 1 0 0   0  0 0 #  uadd $ti     $lr22v  $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  48 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 2  1 1 0 0   0  0 0 #  usub _const_2 $ti     $t       # $lr8v ϻؿ1.5",
"ISP 4 0 0 0 0 1 0 1 1 1e 1 1  0 0 0  0 0 0 0 0  44 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  c 1 0 0   0  0 0 #  ulsl $ti     _const_0  $lr30v",
"ISP 4 0 1 0 0 0 0 0 0  0 0 0 16 1 1  0 0 0 0 0  46 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 0  5 1 0 0   0  0 0 #  uand _const_1 $lr22v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0 12 1 0  0 0 0 0 0  4a 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 3  5 1 0 0   0  0 0 #  uand $r18v _const_3 $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  4b 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  6 1 0 0   0  0 0 #  uor  $ti _const_4 $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0  4c 0 0 0 0 0 1 1 0 0 0 1 0 1 2 3 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti _const_5 $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  4d 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_6 $ti $t",
"ISP 4 1 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0  4e 0 0 0 0 0 0 1 0 0 1 1 0 1 3 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul _const_7 $ti $t",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 0 0 0 1 0 0 1 0 16 1 0 1e 1 1  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 1 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $t $lr30v $t $r22v # Here the result is the initial guess",
"ISP 4 0 0 0 1 0 0 1 0 1a 1 0 12 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r18v $r18v $r26v $t",
"ISP 4 0 0 0 1 1 0 1 0 1a 1 0 12 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 1 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r18v $ti   $r26v $t",
"ISP 4 0 0 0 0 1 0 1 0 1a 1 0  0 0 0  0 0 0 0 0  4f 0 0 0 0 0 1 1 0 0 0 1 1 1 2 3 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti _const_8 $r26v # r26v is a**3/2",
"ISP 4 0 0 0 1 0 0 0 0  0 0 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $r22v $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  50 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_9 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 1 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  50 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_9 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 1 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  50 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_9 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 1 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  50 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_9 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 1 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t $r22v",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 2 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 1a 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti $r26v $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  4f 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_8 $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 1 1 0 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $r22v $ti $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0 16 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 2  0 0 1 0   0  0 0 #  fadd $r22v $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 16 1 0  0 0 0  0 0 0 0 0  20 0 0 0 0 0 0 1 0 0 1 1 1 1 3 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul lmj $ti $t $r22v",
"ISP 4 2 0 0 0 1 0 1 1  0 1 1  6 1 0  0 0 0 0 0  3c 1 0 1 0 0 0 1 0 0 1 1 0 1 0 2 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  fmul $r6v $ti  ;  upassa pot pot $lr0v",
"ISP 4 2 0 0 0 0 0 1 1 28 1 1  a 1 0 28 1 1 1 1  24 1 0 1 0 0 0 1 0 0 1 1 0 1 0 2 1 1 0 0 1 6 1  0 0 1 0   0  0 0 #  fmul $r10v $t ;  fadd $fb $lr40v  $lr40v accx",
"ISP 4 2 0 0 0 0 0 1 1 30 1 1  e 1 0 30 1 1 1 1  2c 1 0 1 0 0 0 1 0 0 1 1 0 1 0 2 1 1 0 0 1 6 1  0 0 1 0   0  0 0 #  fmul $r14v $t ; fadd $fb $lr48v  $lr48v accy",
"ISP 4 2 0 0 0 0 0 1 1 38 1 1 12 1 0 38 1 1 1 1  34 1 0 1 0 0 0 1 0 0 1 1 0 1 0 2 1 1 0 0 1 6 1  0 0 1 0   0  0 0 #  fmul $r18v $t ; fadd $fb $lr56v $lr56v accz",
"ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 1 1  0 0 0 1 1  3c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 6 0  0 0 1 0   0  0 0 #  fadd $fb $lr0v  pot"
};
static XXX_register_grape_codes(int id[])
{
    int k;
    for (k=0;k<3;k++) id[k]=-1;
    SING_iflush();
    id[1]=SING_iregister(5,codes_1,-1);
    id[2]=SING_iregister(59,codes_2,4);
}

static ids[3];

void XXX_grape_init()
{
    SING_open();
    XXX_send_vsm_constants();
    XXX_register_j_particle_conversion();
    XXX_register_i_particle_conversion();
    XXX_register_grape_codes(ids);
    XXX_register_result_conversion();

}

int XXX_grape_run(int n)
{
    return SING_execute(ids[1],ids[2], n,bmareaid);
}
