#include "typedef.h"
#include "sing.h"
#include "sing_chip.h"
#include "singMC.h"
#include "ctrl.h"
#define grape_j_particle_struct  SING_elt_struct0

struct SING_elt_struct0{
  double x0;
  double y0;
  double z0;
  double tj;
  double sx18;
  double sy18;
  double sz18;
  double jx6;
  double jy6;
  double jz6;
  double ax2;
  double ay2;
  double az2;
  double v0x;
  double v0y;
  double v0z;
  double mj;
  double eps2;
  UINT32 idxj;
  UINT32 jtmp;
};
int SING_send_elt_data0(struct SING_elt_struct0 *ip, int index_in_EM);
int SING_setup_elt_data0MC(int chipid);
int SING_send_elt_data0MC(int chipid, struct SING_elt_struct0 *ip, int index_in_EM);
int SING_move_elt_data0(int index);
int SING_move_elt_data0MC(int chipid, int index);
int SING_elt_size0();
int SING_send_elt_data0_m(struct SING_elt_struct0 *ip, int index_in_EM, int ndata);

int SING_send_elt_data0_mMC(int chipid, struct SING_elt_struct0 *ip, int index_in_EM, int ndata);

int SING_send_elt_data0_vMC(int chipid, struct SING_elt_struct0 *ip, int index[], int ndata);


struct SING_elt_struct1{
  double xi_b0[4];
  double yi_b0[4];
  double zi_b0[4];
  double ti_b0[4];
  double eps2i_b0[4];
  double vxi_b0[4];
  double vyi_b0[4];
  double vzi_b0[4];
  UINT64 idxi_b0[4];
  UINT64 itmp_b0[4];
};
int SING_send_elt_data1(struct SING_elt_struct1 *ip, int index_in_EM);
int SING_setup_elt_data1MC(int chipid);
int SING_send_elt_data1MC(int chipid, struct SING_elt_struct1 *ip, int index_in_EM);
int SING_move_elt_data1(int index);
int SING_move_elt_data1MC(int chipid, int index);
int SING_elt_size1();
int SING_send_elt_data1_m(struct SING_elt_struct1 *ip, int index_in_EM, int ndata);

int SING_send_elt_data1_mMC(int chipid, struct SING_elt_struct1 *ip, int index_in_EM, int ndata);

int SING_send_elt_data1_vMC(int chipid, struct SING_elt_struct1 *ip, int index[], int ndata);

struct SING_hlt_struct0{
  double xi;
  double yi;
  double zi;
  double ti;
  double eps2i;
  double vxi;
  double vyi;
  double vzi;
  UINT64 idxi;
  UINT64 itmp;
};
struct SING_hlt_vector_struct0{
  double xi[4];
  double yi[4];
  double zi[4];
  double ti[4];
  double eps2i[4];
  double vxi[4];
  double vyi[4];
  double vzi[4];
  UINT64 idxi[4];
  UINT64 itmp[4];
};
int SING_send_i_particle(struct SING_hlt_struct0 *ip,
                         int n);
int SING_send_i_particleMC(int chipid, struct SING_hlt_struct0 *ip,
                         int n);
int SING_send_i_particleMCP(int nchips, int chipid[],
                          struct SING_hlt_struct0 *ip,
                          int n);
#define grape_i_particle_struct SING_hlt_struct0
#define grape_i_particle_vector_struct SING_hlt_vector_struct0
int SING_npipes();
struct SING_result_struct{
  double jerkx;
  double jerky;
  double jerkz;
  double accx;
  double accy;
  double accz;
  double pot;
  double nnb;

};
struct SING_result_vectorstruct{
  double jerkx[128];
  double jerky[128];
  double jerkz[128];
  double accx[128];
  double accy[128];
  double accz[128];
  double pot[128];
  double nnb[128];

};
int SING_get_result(struct SING_result_struct *rp);
int SING_get_resultMC(int chipid, struct SING_result_struct *rp);
#define  grape_result_struct SING_result_struct 
void SING_grape_init(int chipid);
int SING_grape_run(int n);
int SING_type2_run(int n, void * loopout);
void SING_grape_initMC(int chipid);
int SING_grape_runMC(int chipid, int n);
int SING_type2_runMC(int chipid, int n, void * loopout);
int SING_grape_runMCP(int nchips, int chipid[], int n);
void SING_grape_close();
void SING_grape_closeMC(int chipid);
