#include <stdio.h>
#include <stdarg.h>
#include "./hermite-k.h"
#ifndef NJP
#    define NJP 65536
#endif
struct SING_grape_consts{
  UINT64 _const_0[2];
  double _const_1;
  double _const_2;
  double _const_3;
  INT64 _const_4;
  INT64 _const_5;
  UINT64 _const_6[2];
  INT64 _const_7;
  UINT64 _const_8;
  UINT64 _const_9;
  UINT64 _const_10;
  double _const_11;
  double _const_12;
  double _const_13;
  double _const_14;
  double _const_15;
  double _const_16;
};
struct SING_grape_consts constants;

int SING_send_vsm_constants()
{
    int ndata = 19;
    int firstaddress= 132;
    int conversions[]={6,6,1,1,1,4,4,6,6,4,6,6,6,1,1,1,1,1,1};

    constants._const_0[0] = 0x7ff000000LL;
    constants._const_0[1] = 0x0fffffffffLL;
    constants._const_1 = 0.75;
    constants._const_2 = 1.5;
    constants._const_3 = 2.0;
    constants._const_4 = 36;
    constants._const_5 = 61;
    constants._const_6[0] = 0;
    constants._const_6[1] = 0x5feLL;
    constants._const_7 = 60;
    constants._const_8 = 0x001000000LL;
    constants._const_9 = 0x000ffffffLL;
    constants._const_10 = 0x3ff000000LL;
    constants._const_11 = 0.14823;
    constants._const_12 = -0.73758;
    constants._const_13 = 1.58935;
    constants._const_14 = 1.41421356;
    constants._const_15 = 0.5;
    constants._const_16 = -3;

    SING_LM_write_regconv(ndata,conversions);
    SING_LM_write(&constants, firstaddress, 0);
}
int SING_send_j_particle(struct SING_elt_struct0 *jp, int index)
{
      return SING_send_elt_data0(jp, index);
}


static SING_copy_ip_to_vip(struct SING_hlt_struct0 *p,
                                 struct SING_hlt_vector_struct0 *vp,
			         int k)
{
   vp->xi[k]= p->xi;
   vp->yi[k]= p->yi;
   vp->zi[k]= p->zi;
   vp->vxi[k]= p->vxi;
   vp->vyi[k]= p->vyi;
   vp->vzi[k]= p->vzi;
   vp->eps2i[k]= p->eps2i;
   vp->idxi[k]= p->idxi;
   vp->ti[k]= p->ti;

}

int SING_send_i_particle(struct SING_hlt_struct0 *ip,
                         int n)
{
    struct SING_hlt_vector_struct0 ipv[NPEMAX];
    int i;
    for(i=0;i<n;i++){
        int iv = i/4;
	int k  = i%4;
        SING_copy_ip_to_vip(ip+i, ipv+iv, k);
    }
    i = (n+3)/4;
    SING_LM_write(ipv, 0, i);
}

void SING_register_i_particle_conversion()
{
    int conversions[]={0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,9,9,9,9,0,0,0,0};

    SING_LM_write_regconv(36,conversions);
}




static int emid0;
static int bmid0;
int SING_setup_elt_data0()
{
    int err;
    int conversions[]={0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,9};

    emid0=SING_EM_alloc(19, conversions, 65536, &err);
    if (emid0 < 0){
        fprintf(stderr,"register jp, EMalloc err = %d\n",err);
        exit(-1);
    }
    bmid0=SING_BM_alloc(emid0,1,&err);
    if (bmid0 < 0){
    fprintf(stderr,"register jp, BMalloc err = %d\n",err);
          exit(-1);
    }
}


int SING_send_elt_data0(struct SING_elt_struct0 *ip, int index_in_EM)
{
    int ret;
    ret = SING_EM_send(emid0,index_in_EM,1,ip);
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(-1);
    }
}

int SING_move_elt_data0(int index)
{
    SING_EM_BM_transfer(bmid0,index,0,1,1,-1);
}
static char* codes_1[]={
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 0   # idp 0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 0  0 0 0 0 0  84 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 2  a 1 0 0   0  0 0 #  upassa _const_0 $t $t",
"ISP 4 0 0 0 0 1 0 0 0  0 0 0  0 0 0  0 0 0 1 1  7c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $ti $ti nnb",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  7 1 0 0   0  0 0 #  uxor $t $t $t",
"ISP 4 0 0 0 0 1 0 0 0  0 0 0  0 0 0  0 0 0 1 1  44 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $ti $ti accx",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 1  4c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $t $t   accy",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 1  54 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $t $t   accz",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 1  5c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $t $t   jerkx",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 1  64 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0  wdp #  upassa $t $t   jerky",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 1  6c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $t $t   jerkz",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 1  74 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $t $t   pot"
};
static char* codes_2[]={
"ISP 4 0 0 0 0 0 0 1 2  0 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   6  0 1 #  bm tj $lr0v   # this one copies 4 lwords, resulting in s18 copied ",
"ISP 3 0 0 0 0 0 0 1 2 18 1 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   b  0 0 #  bm jx6 lj6v",
"ISP 3 0 0 0 0 0 0 1 2 14 1 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   e  0 0 #  bm ax2 la2v",
"ISP 3 0 0 0 0 0 0 1 2 24 1 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  11  0 0 #  bm v0x lv0v",
"ISP 3 0 0 0 1 0 1 0 0  0 0 0  0 0 1  0 0 0 0 0  2c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 0  0 0 1 0   0  0 0 #  fsub ti $lr0 $t",
"ISP 3 0 0 0 0 1 0 1 1  0 0 1  0 0 0  0 0 0 1 1  3c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $ti $ti  dt  dtlm",
"ISP 3 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 3 0 0 0 1 0 0 0 0  0 0 0  2 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $t ls18v $t",
"ISP 3 0 0 0 1 1 1 0 0  0 0 0 18 1 0  0 0 0 0 0  86 0 0 0 0 0 0 1 0 0 0 1 0 1 2 3 1 1 0 0 1 2 0  0 0 1 0   0  0 0 #  fmul $ti _const_1 ; fadd $ti lj6v $t  # fb:s*dt*0.75 t:s*dt+j",
"ISP 3 0 0 0 1 1 0 1 1 20 1 0 18 1 0  0 0 0 0 0  87 0 0 0 0 0 0 1 0 0 0 1 0 1 2 3 1 1 0 1 1 6 0  0 0 1 0   0  0 0 #  fmul $ti _const_2 $t ; fadd $fb lj6v dxp # t:v*1.5 dxp:x+j6",
"ISP 3 0 0 0 0 1 0 1 2  c 1 1  0 0 1  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 1 #  fmul $ti dt ;  bm x0 lx0v #             t:v*t(next:a2)",
"ISP 3 0 0 0 1 0 1 0 0  0 0 0 14 1 0 20 1 0 0 0  3c 1 0 1 0 0 0 1 0 0 0 1 0 1 1 3 1 1 0 0 1 6 0  0 0 1 0   0  0 0 #  fadd $fb la2v $t ; fmul dxp dtlm  # t: v(next:*dt) fb:next:+a2",
"ISP 3 0 0 0 1 1 1 0 0  0 0 0 14 1 0  0 0 1 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 1 1 1 0 0 1 6 0  0 0 1 0   0  0 0 # fadd $fb la2v $t ; fmul $ti dt    #  t:x(next:*dt) fb:v(next:*2)",
"ISP 3 0 0 0 1 1 1 0 0  0 0 0  0 0 1  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 6 2  a 1 0 0   0  0 0 #  fmul $ti dt      ; upassa $fb $ti $t  # fb:x(next:+v) t:v(next:*2)",
"ISP 3 0 0 0 1 1 1 0 0  0 0 0 24 1 0  0 0 0 0 0  88 0 0 0 0 0 0 1 0 0 0 1 0 1 2 3 1 1 0 0 1 6 0  0 0 1 0   0  0 0 #  fadd $fb lv0v $t ; fmul $ti _const_3    # t:x(next:*dt) fb:v(next:+v)",
"ISP 3 0 0 0 0 1 0 0 0  0 0 0  0 0 1 24 1 0 1 1  34 1 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 1 1 6 1  0 0 1 0   0  0 0 # fmul $ti dt ;      fadd $fb lv0v lvxjv  # fb:x(next:+x) t:v(next:*dt)",
"ISP 3 0 0 0 1 0 1 1 1  c 1 1  c 1 1  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 6 0  0 0 1 0   0  0 0 #  fadd $fb lx0v $t lx0v",
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  37 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  14  0 0 #  bm mj  lmj",
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  38 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  15  0 0 #  bm eps2 leps2",
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  39 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  16  0 0 #  bm idxj lidxj",
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0  idp 0 #  nop",
"ISP 1 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0  rdp 0 #  nop",
"ISP 1 0 0 0 1 0 1 0 0  0 0 0  0 0 0  0 0 0 0 0  8a 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 2  a 1 0 0   0  0 0 #  upassa _const_4 $t $t",
"ISP 1 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  39 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 2  d 1 0 0   0  0 0 #  ulsr lidxj $ti $t",
"ISP 1 0 0 0 0 1 0 0 0  0 0 0  0 0 0  0 0 0 1 1  3a 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $ti $ti llidxj",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 0  0 0 0 0 0  28 1 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  upassa idxi  idxi  $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  39 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  7 1 0 0   0  0 0 #  uxor  $ti lidxj $t",
"ISP 4 0 2 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2 10 1 0 0   0  0 0 #  ulnot $ti $ti $t  # mreg 1 indicates i != j",
"ISP 4 0 0 0 1 0 1 1 1  0 1 0  c 0 1  0 0 0 0 0   0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub lxj xi dx  $t",
"ISP 4 0 0 0 1 1 0 1 1  4 1 0  e 0 1  0 0 0 0 0   8 1 0 1 0 0 0 1 0 0 0 1 0 1 2 2 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub lyj yi dy ; fmul $ti $ti $t",
"ISP 4 0 0 0 0 0 0 1 1  8 1 0 10 0 1  0 0 0 0 0  10 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub lzj zi dz",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 1 0  0 0 0 0 0  24 1 0 0 0 0 0 1 0 0 0 1 0 1 0 0 1 1 0 0 1 2 3  0 0 1 0   0  0 0 #  fmul dy dy       ; fadd $t eps2i $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  8 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 0 1 1 0 0 1 6 2  0 0 1 0   0  0 0 #  fmul dz dz  ; fadd $fb $ti  $t",
"ISP 4 0 0 0 1 1 1 1 1  c 1 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 1 1 6 2  0 0 1 0   0  0 0 #  fadd $fb $ti dr2 $t",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0 3f 1 1 3f 1 1 0 0   0 0 0 0 1 1 1 1 1 1 1 1 1 1 3 3 1 1 1 1 1 4 0 1f 0 0 0   0  0 0 #  imm fffffffff $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  c 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 0  5 1 0 0   0  0 0 #  uand $ti dr2 $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  3a 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  6 1 0 0   0  0 0 #  uor $ti llidxj $t",
"ISP 4 2 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  7c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  9 1 0 0   0  0 0 #  umin $ti nnb $t",
"ISP 4 2 0 0 0 1 0 0 0  0 0 0  0 0 0  0 0 0 1 1  7c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 #  upassa $ti $ti nnb",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 1 0  0 0 0 0 0  8c 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 3  d 1 0 0   0  0 0 #  ulsr dr2     _const_5  $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  8e 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 2  1 1 0 0   0  0 0 #  usub _const_6 $ti     $t       # $t is half of the exponent",
"ISP 4 0 0 0 0 1 0 1 1 10 1 0  0 0 0  0 0 0 0 0  90 0 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 1 1 2 3  c 1 0 0   0  0 0 #  ulsl $ti      _const_7  resexp",
"ISP 4 0 1 0 0 0 0 0 0  0 0 0  c 1 0  0 0 0 0 0  92 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 0  5 1 0 0   0  0 0 #   uand _const_8 dr2",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 1 0  0 0 0 0 0  93 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 3  5 1 0 0   0  0 0 #  uand dr2 _const_9 $t",
"ISP 4 0 0 0 1 1 1 1 1 14 1 0  0 0 0  0 0 0 0 0  94 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 1 1 2 3  6 1 0 0   0  0 0 #  uor  $ti _const_10 $t rinv",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0  95 0 0 0 0 0 0 1 0 0 0 1 0 1 2 3 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti _const_11 $t",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  96 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 3  0 0 1 0   0  0 0 #  fadd $ti _const_12 $t",
"ISP 4 0 0 0 1 1 0 1 1 38 1 0 14 1 0  0 0 0 0 0  34 1 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 1 1 3 3  a 1 0 0   0  0 0 #  fmul  $ti rinv $t ; upassa lvxjv lvxjv vjvr",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  97 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 2  0 0 1 0   0  0 0 #  fadd _const_13 $ti $t",
"ISP 4 1 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0  98 0 0 0 0 0 0 1 0 0 0 1 0 1 3 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul _const_14 $ti $t",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 0 0 0 1 0 0 1 0 14 1 0 10 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $t resexp $t rinv # Here the result is the initial guess",
"ISP 4 0 0 0 0 0 0 1 0 10 1 0  c 1 0  0 0 0 0 0  99 0 0 0 0 0 0 1 0 0 0 1 1 1 0 3 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul dr2 _const_15 ahalf # r8v is 0.5a",
"ISP 4 0 0 0 1 0 0 1 1 18 1 1 14 1 0  0 0 0 0 0  74 1 0 1 0 0 0 1 0 0 0 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  fmul rinv rinv $t     ; upassa pot pot ptmp",
"ISP 4 0 0 0 1 1 0 1 1 20 1 1 10 1 0  0 0 0 0 0  44 1 0 1 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  fmul $ti ahalf $t     ; upassa accx accx  axtmp",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  87 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_2 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 14 1 0 14 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul rinv $ti $t rinv ",
"ISP 4 0 0 0 1 1 0 1 1 30 1 1  0 0 0  0 0 0 0 0  54 1 0 1 0 0 0 1 0 0 0 1 0 1 2 2 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  fmul $ti $ti $t       ; upassa accz accz  aztmp",
"ISP 4 0 0 0 1 1 0 1 1 20 1 1 10 1 0  0 0 0 0 0  44 1 0 1 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  fmul $ti ahalf $t     ; upassa accx accx  axtmp",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  87 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_2 $ti $t",
"ISP 4 0 0 0 1 1 0 1 0 14 1 0 14 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul rinv $ti $t rinv ",
"ISP 4 0 0 0 1 1 0 1 1 30 1 1  0 0 0  0 0 0 0 0  54 1 0 1 0 0 0 1 0 0 0 1 0 1 2 2 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  fmul $ti $ti $t       ; upassa accz accz  aztmp",
"ISP 4 0 0 0 1 1 0 1 1 28 1 1 10 1 0  0 0 0 0 0  4c 1 0 1 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  fmul $ti ahalf $t     ; upassa accy accy  aytmp",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0  99 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 0 1 3 2  0 0 1 0   0  0 0 #  fsub _const_15 $ti $t",
"ISP 4 0 0 0 1 1 0 0 0  0 0 0 14 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul rinv $ti $t      ",
"ISP 4 0 0 0 1 1 1 1 1 14 1 0 14 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 1 1 0 2  0 0 1 0   0  0 0 #  fadd rinv  $ti $t rinv",
"ISP 4 2 0 0 1 1 0 1 0  c 1 0  0 0 0  0 0 0 0 0  37 0 0 0 0 0 0 1 0 0 0 1 1 1 3 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul lmj $ti $t mrinv",
"ISP 4 2 0 0 1 1 0 1 0 10 1 0 14 1 0 18 1 1 1 1  74 1 0 1 0 0 0 1 0 0 0 1 1 1 0 0 1 1 1 0 1 1 2  0 0 1 0   0  0 0 #  fmul rinv rinv $t r2inv; fsub ptmp $ti pot",
"ISP 4 2 0 0 1 1 0 1 0  c 1 0  c 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 1 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti mrinv $t mr3inv",
"ISP 4 2 0 0 0 1 0 0 0  0 0 0  0 1 0  0 0 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul $ti dx ",
"ISP 4 2 0 0 0 0 0 0 0  0 0 0  4 1 0 20 1 1 1 1  44 1 0 1 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 6 1  0 0 1 0   0  0 0 #  fmul $t  dy ; fadd $fb axtmp accx",
"ISP 4 2 0 0 0 0 0 0 0  0 0 0  8 1 0 28 1 1 1 1  4c 1 0 1 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 6 1  0 0 1 0   0  0 0 #  fmul $t  dz ; fadd $fb aytmp accy",
"ISP 4 2 0 0 0 0 0 0 0  0 0 0 30 1 1  0 0 0 1 1  54 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 6 0  0 0 1 0   0  0 0 #  fadd $fb aztmp accz",
"ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 #  nop",
"ISP 4 2 0 0 1 0 1 1 1 18 1 0 38 0 0  0 0 0 0 0  18 1 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub vxjr vxi dvx  $t",
"ISP 4 2 0 0 1 1 0 1 1 1c 1 0 39 0 0  0 1 0 0 0  1c 1 0 0 0 0 0 1 0 0 0 1 0 1 2 1 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub vyjr vyi dvy ; fmul $ti dx $t",
"ISP 4 2 0 0 0 0 0 1 1 20 1 0 3a 0 0  0 0 0 0 0  20 1 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 1 1 1 0 3  0 0 1 0   0  0 0 #  fsub vzjr vzi dvz ",
"ISP 4 2 0 0 0 0 0 1 1 2c 1 1 1c 1 0  4 1 0 0 0  5c 1 0 1 0 0 0 1 0 0 0 1 0 1 0 1 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  fmul dvy dy     ;  upassa jerkx jerkx jxacc",
"ISP 4 2 0 0 1 0 1 0 0  0 0 0 20 1 0  8 1 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 1 1 1 0 0 1 6 2  0 0 1 0   0  0 0 #  fmul dvz dz  ; fadd $fb $t $t",
"ISP 4 2 0 0 1 1 1 1 1 24 1 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 1 1 6 2  0 0 1 0   0  0 0 #  fadd $fb $ti rvtmp $t",
"ISP 4 2 0 0 1 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0  9a 0 0 0 0 0 0 1 0 0 0 1 0 1 3 2 1 1 0 0 1 0 0  0 0 0 0   0  0 0 #  fmul _const_16 $ti $t",
"ISP 4 2 0 0 1 1 0 1 1 24 1 1 10 1 0  0 0 0 0 0  6c 1 0 1 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  fmul $ti r2inv $t ;  upassa jerkz jerkz jzacc",
"ISP 4 2 0 0 0 1 0 1 1 10 1 1  0 1 0  0 0 0 0 0  64 1 0 1 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 #  fmul $ti dx  ;  upassa jerky jerky jyacc",
"ISP 4 2 0 0 0 0 0 1 1 34 1 0  4 1 0 18 1 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 1 1 6 1  0 0 1 0   0  0 0 #  fmul $t  dy  ;  fadd $fb dvx jxtmp",
"ISP 4 2 0 0 0 0 0 1 1 38 1 0  8 1 0 1c 1 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 1 1 6 1  0 0 1 0   0  0 0 #  fmul $t  dz   ; fadd $fb dvy jytmp",
"ISP 4 2 0 0 0 0 0 1 1 3c 1 0 20 1 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 1 1 6 0  0 0 1 0   0  0 0 #  fadd $fb dvz jztmp",
"ISP 4 2 0 0 1 0 1 0 0  0 0 0  c 1 0 34 1 0 0 0   0 0 0 0 0 0 0 1 0 0 0 1 0 1 0 1 1 1 0 0 1 0 0  a 1 0 0   0  0 0  wdp #  fmul mr3inv jxtmp  ; upassa mr3inv mr3inv $t",
"ISP 4 2 0 0 0 1 0 0 0  0 0 0 38 1 0 2c 1 1 1 1  5c 1 0 1 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 6 1  0 0 1 0   0  0 0 #  fmul $ti jytmp      ; fadd $fb jxacc jerkx",
"ISP 4 2 0 0 0 0 0 0 0  0 0 0 3c 1 0 10 1 1 1 1  64 1 0 1 0 0 0 1 0 0 0 1 0 1 2 0 1 1 0 0 1 6 1  0 0 1 0   0  0 0 #  fmul $t jztmp      ; fadd $fb jyacc jerky",
"ISP 4 2 0 0 0 0 0 0 0  0 0 0 24 1 1  0 0 0 1 1  6c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 6 0  0 0 1 0   0  0 0 #  fadd $fb jzacc jerkz"
};
static char* codes_3[]={
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  44 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa accx accx $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0  0 1 # bm $lr0v $lb2032v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8  1 1 # bm $lr0v $lb2040v  1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  4c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa accy accy $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0  0 1 # bm $lr0v $lb2032v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8  1 1 # bm $lr0v $lb2040v  1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  54 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa accz accz $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0  0 1 # bm $lr0v $lb2032v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8  1 1 # bm $lr0v $lb2040v  1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  5c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa jerkx jerkx $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0  0 1 # bm $lr0v $lb2032v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8  1 1 # bm $lr0v $lb2040v  1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  64 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa jerky jerky $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0  0 1 # bm $lr0v $lb2032v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8  1 1 # bm $lr0v $lb2040v  1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  6c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa jerkz jerkz $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0  0 1 # bm $lr0v $lb2032v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8  1 1 # bm $lr0v $lb2040v  1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  74 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa pot pot $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0  0 1 # bm $lr0v $lb2032v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8  1 1 # bm $lr0v $lb2040v  1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0  7c 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 3 3  a 1 0 0   0  0 0 # upassa nnb nnb $lr0v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f0  0 1 # bm $lr0v $lb2032v  0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 7f8  1 1 # bm $lr0v $lb2040v  1",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 3"
};
static SING_register_grape_codes(int id[])
{
    int k;
    for (k=0;k<4;k++) id[k]=-1;
    SING_iflush();
    id[1]=SING_iregister(13,codes_1);
    id[2]=SING_iregister(95,codes_2);
    id[3]=SING_iregister(61,codes_3);
}

static int ids[4];
int * SING_codes_pointer()
{
    return ids;
}

void SING_grape_init(int chipid)
{
    SING_set_chipid(int chipid);
    SING_open();
    SING_send_vsm_constants();
    SING_setup_elt_data0();

    SING_register_i_particle_conversion();
    SING_register_grape_codes(ids);
    SING_set_result_size(0,sizeof(SING_rvp));
}


int SING_grape_run(int n)
{
    SING_EM_fifoclr();
    SING_move_elt_data0(0);
    return SING_execute(ids[1],ids[2],ids[3], n,
                        NULL, (void*) &SING_rvp);
}
void SING_grape_close()
{
    SING_close();
}

