void send_i_matrix_mtwork(void *ptr)
{
    double data[16][64][4];
    int ipe, ibb;
  
    struct gdr_send_i_param *p = (struct gdr_send_i_param*)ptr;
    int DIMM  = p->DIMM;
    int DIMK  = p->DIMK;
    int ichip = p->ichip;
    int i     = p->i;
    int NOTA  = p->NOTA;
    int LDA   = p->LDA;
    double *a = p->a;
    double *aem = p->aem;
    int overlap = p->overlap;
    UINT64 start, copy, end;
    int j, nbb=NBB;

    if(overlap){
	/* Overlap case */
	if(DIMK==1024 || DIMK==512){
	    nbb = 16 * DIMK / 2048; 
	    /* if i==0, normal piow write i matdata for LM, and prepare for the next matrixdata */
	    if(i==0){
		double *anext = aem;
		for(ipe=0;ipe < NPE; ipe++){
		    clearBM_i_matrix_16bbMC(s[ichip], ipe);
		    for(ibb=0;ibb < nbb; ibb++){
			copytomata_tb4_dg(LDA, NOTA, a, i, ichip, ibb, ipe, DIMK, data);
		    }
		    send_i_matrix_nbbMC(s[ichip], data, ipe, nbb);
		}
		for(ipe=0;ipe<NPE; ipe++){
		    for(ibb=0;ibb<nbb; ibb++){
#if 1
			copytomata_tb4_dg_onebb(LDA, NOTA, a, i+DIM1, ichip, ibb, ipe, DIMK, anext);
#else
			for(j=0;j<256;j++){
			    anext[j] = 0.0;
			}
#endif

			anext += 256;
		    }
		}
	    } else {
		/* if i!=0, invoked EM->BM trans and BM->LM in partially 8BB(K==1024), 4BB(K==512), and prepare for the next matrixdata */
		double *anext = aem;
		setsend_i_elt2_16bbMC(s[ichip], 0); //PEID
		setsend_i_elt2_BBid_MC(s[ichip], nbb); //BBID < 8 is enable
		clearBM_i_matrix_16bbMC(s[ichip], 0);
		if(DIMK==512) {
		    matmul_move_elt_data2_m1024_npe_nbb_k512(s[ichip], 0, 0, 32);
		} else {
		    matmul_move_elt_data2_m1024_npe_nbb(s[ichip], 0, 0, 32);
		}

		if((i+DIM1)<DIMM){
		    for(ipe=0;ipe<NPE; ipe++){
			for(ibb=0;ibb<nbb; ibb++){
#if 1
			    copytomata_tb4_dg_onebb(LDA, NOTA, a, i+DIM1, ichip, ibb, ipe, DIMK, anext);
#else
			    for(j=0;j<256;j++){
				anext[j] = 0.0;
			    }
#endif

			    anext += 256;
			}
		    }
		} else {
#ifdef MATMULELT2ASYNC
		    while(CTRL_coc_busy(s[ichip]->c)) {}
#endif
		}
		matmul_move_elt_data2_m1024_npe_finish(s[ichip]);
	    }
	} else {
	    /* overlap case K==2048*/
	    if(i != 0){
		start = rdtsc2();
		setsend_i_elt2_16bbMC(s[ichip], 0);
		matmul_move_elt_data2_m1024_npe(s[ichip], 0, 0, 32);
		copy = rdtsc2();
		if((i+DIM1)<DIMM){
		    copytomata_em_1024_tb4_dg(LDA, NOTA, a, i+DIM1, ichip, DIMK, aem);
		} else {
#ifdef MATMULELT2ASYNC
		    while(CTRL_coc_busy(s[ichip]->c)) {}
#endif
		}
		matmul_move_elt_data2_m1024_npe_finish(s[ichip]);
		end = rdtsc2();
#ifdef BENCHSENDI
		printf("ovl send %lld [clk] , copy %lld [clk] \n", copy-start, end-copy);
#endif
	    } else {
		start = rdtsc2();
		for(ipe=0;ipe < NPE; ipe++){
		    for(ibb=0;ibb < NBB; ibb++){
			copytomata_tb4_dg(LDA, NOTA, a, i, ichip, ibb, ipe, DIMK, data);
		    }
		    send_i_matrix_16bbMC(s[ichip], data, ipe);
		}
		//transfer next a matrix to buffer
		copy = rdtsc2();
		copytomata_em_1024_tb4_dg(LDA, NOTA, a, i+DIM1, ichip, DIMK, aem);
		end = rdtsc2();
#ifdef BENCHSENDI
		printf("nonovl send %lld [clk] , copy %lld [clk] \n", copy-start, end-copy);
#endif
	    }
	}
    } else {
	/* overlap case K==1024*/
	start = rdtsc2();
	if(DIMK<2048) {
	    clearBM_i_matrix_16bbMC(s[ichip], ipe);
	}
	nbb = NBB*DIMK/2048;
	copy = rdtsc2();
	for(ipe=0;ipe < NPE; ipe++){
	    for(ibb=0;ibb < nbb; ibb++){
		copytomata_tb4_dg(LDA, NOTA, a, i, ichip, ibb, ipe, DIMK, data);
	    }
	    send_i_matrix_nbbMC(s[ichip], data, ipe, nbb);
	}
	end = rdtsc2();
#ifdef BENCHSENDI
	printf("ipe %d send : clear %lld[clk] send %lld[clk] \n", ipe, copy-start, end-copy); 
#endif
	while(CTRL_coc_busy(s[ichip]->c)) {}
    }
}
