/*
 * pit_plot.c
 *
 * XTC version - 94/11/12
 */

#include "pit_system.h"
#include  <fstream.h>

#include <unistd.h>

#define NMAX 131072
extern "C"{
    void initialize_animation(void);
    void plot_particle(real *x,
		       int n,
		       int c[],
		       int use_c,
		       real time,
		       real rmax);
    
}

static real y_scale;


void initialize_plot(double viewsize)
{
    int view_size;
    if (viewsize < 0.0) return;
    y_scale= viewsize;
    initialize_animation();
}


void plot_particles( int n,
		     particle * p,
		     real time)
{
    static vector * xarray = NULL;
    static  int *   carray = NULL;
    if (xarray == NULL){
	xarray = new vector[n+2000];
	carray = new int[n+2000];
    }
    int use_c = 1;
    for(int i = 0;i<n;i++){
	xarray[i] = p[i].get_pos();
	if ( p[i].get_isbh()){
	    carray[i] = 15;
	}else{
	    carray[i] = 13;
	}
    }
    plot_particle((real*)xarray,n,carray,use_c,time,y_scale);
}

