#include <stdio.h>
#include <stdlib.h>
#include <ctrl.h>
#define NCHIP 4

void readcounter(CTRLinfo *c)
{
  UINT64 buf[3];

  buf[0] = 0x0;
  buf[1] = 1 << 17;
  buf[2] = 0x0;
  CTRL_config_write(c, 10, buf, 3);
  usleep(1000);
}

void setcounter(CTRLinfo *c, int type, int param, int data)
{
  UINT64 buf[3];
  //write | type[15..12] | param[11..9] | data[8..0]
  
  buf[0] = ((UINT64)0 << 16) | ((UINT64)type << 12) | ((UINT64)(param) << 9) | data;
  buf[1] = ((UINT64)1 << 16) | ((UINT64)type << 12) | ((UINT64)(param) << 9) | data;
  buf[2] = ((UINT64)0 << 16) | ((UINT64)type << 12) | ((UINT64)(param) << 9) | data;
  CTRL_config_write(c, 10, buf, 3);
  
  usleep(10000);
}

void pllreconfig(CTRLinfo *c)
{
  UINT64 buf[3];

  buf[0] = 0x0;
  buf[1] = 1 << 18;
  buf[2] = 0x0;
  CTRL_config_write(c, 10, buf, 3);
  usleep(10000);
}

int main(int argc, char **argv)
{
  int i, mcnt, bid;
  CTRLinfo *c;

  
  if(argc==3){
    bid = atoi(argv[1]);
    mcnt = atoi(argv[2]);
  } else {
    printf("pllconf: pllconf (boardid) (mcounter) \n");
    printf("m=24 for 400MHz , m=22 for 366MHz , m=20 for 333MHz \n"); 
    exit(1);
  }
  printf("mcounter = %d \n", mcnt);
  for(i=0;i<NCHIP;i++){
    c = CTRL_open(i + bid*NCHIP);

    readcounter(c);
    /*
      setcounter(c, 0x2, 0x0, 6);
      setcounter(c, 0x2, 0x1, 1);

      setcounter(c, 0x0, 0x0, 1); 
      setcounter(c, 0x1, 0x0, 4); /
    */
    /* for 350Mhz */
#if 0
    setcounter(c, 0x2, 0x0, 9); //Charge current=96uA
    setcounter(c, 0x2, 0x1, 1); //Filter resister=1.5kOhm
    setcounter(c, 0x2, 0x2, 1); //Filter capasitor=16pF

    setcounter(c, 0x0, 0x0, 5); //n=5
    setcounter(c, 0x0, 0x4, 0); //n bypass = 0
    setcounter(c, 0x1, 0x0, 28); //m=28
    setcounter(c, 0x1, 0x4, 0); //m bypass = 0
    /*
    setcounter(c, 0x4, 0x0, 2); //C0 high=2
    setcounter(c, 0x4, 0x1, 2); //C0 low =2
    setcounter(c, 0x4, 0x5, 0); //mode   =even
    setcounter(c, 0x5, 0x0, 4); //C1 high=4
    setcounter(c, 0x5, 0x1, 4); //C1 low =4
    setcounter(c, 0x5, 0x5, 0); //mode   =even
    */
#endif

#if 0
    /* 333MHz */
    setcounter(c, 0x2, 0x0, 6); //Charge current=96uA
    setcounter(c, 0x2, 0x1, 0); //Filter resister=1.5kOhm
    setcounter(c, 0x2, 0x2, 3); //Filter capasitor=16pF

    setcounter(c, 0x0, 0x0, 0); //n=0
    setcounter(c, 0x0, 0x4, 1); //n bypass = 1
    setcounter(c, 0x1, 0x0, 4); //m=4
    setcounter(c, 0x1, 0x4, 0); //m bypass = 0

    setcounter(c, 0x4, 0x0, 2); //C0 high=2
    setcounter(c, 0x4, 0x1, 1); //C0 low =1
    setcounter(c, 0x4, 0x5, 1); //mode   =odd
    setcounter(c, 0x5, 0x0, 3); //C1 high=3
    setcounter(c, 0x5, 0x1, 3); //C1 low =3
    setcounter(c, 0x5, 0x5, 0); //mode   =even
#endif

#if 0
    //375MHz
    setcounter(c, 0x2, 0x0, 11); //Charge current=114uA
    setcounter(c, 0x2, 0x1, 0); //Filter resister=1.0kOhm
    setcounter(c, 0x2, 0x2, 3); //Filter capasitor=5pF

    setcounter(c, 0x0, 0x0, 0); //n=0
    setcounter(c, 0x0, 0x4, 1); //n bypass = 1
    setcounter(c, 0x1, 0x0, 6); //m=6
    setcounter(c, 0x1, 0x4, 0); //m bypass = 0
    setcounter(c, 0x4, 0x0, 2); //C0 high=2
    setcounter(c, 0x4, 0x1, 2); //C0 low =2
    setcounter(c, 0x4, 0x5, 0); //mode   =even
    setcounter(c, 0x5, 0x0, 4); //C1 high=4
    setcounter(c, 0x5, 0x1, 4); //C1 low =4
    setcounter(c, 0x5, 0x5, 0); //mode   =even
#endif

#if 0
    //375MHz
    setcounter(c, 0x2, 0x0, 11); //Charge current=114uA
    setcounter(c, 0x2, 0x1, 0); //Filter resister=1.0kOhm
    setcounter(c, 0x2, 0x2, 3); //Filter capasitor=5pF

    setcounter(c, 0x0, 0x0, 10); //n=0
    setcounter(c, 0x0, 0x4, 0); //n bypass = 1
    setcounter(c, 0x1, 0x0, 55); //m=6
    setcounter(c, 0x1, 0x4, 0); //m bypass = 0
    setcounter(c, 0x4, 0x0, 2); //C0 high=2
    setcounter(c, 0x4, 0x1, 2); //C0 low =2
    setcounter(c, 0x4, 0x5, 0); //mode   =even
    setcounter(c, 0x5, 0x0, 4); //C1 high=4
    setcounter(c, 0x5, 0x1, 4); //C1 low =4
    setcounter(c, 0x5, 0x5, 0); //mode   =even
#endif

#if 1
    //400MHz
    setcounter(c, 0x2, 0x0, 7); //Charge current=77uA
    setcounter(c, 0x2, 0x1, 1); //Filter resister=1.5kOhm
    setcounter(c, 0x2, 0x2, 1); //Filter capasitor=16pF

    setcounter(c, 0x0, 0x0, 5); //n=5
    setcounter(c, 0x0, 0x4, 0); //n bypass = 0
    setcounter(c, 0x1, 0x0, mcnt); //m=24 for 400MHz , m=23 for 383MHz , m=22 for 366MHz ,m=21 for 350MHz , m=20 for 333Mhz
    setcounter(c, 0x1, 0x4, 0); //m bypass = 0
    setcounter(c, 0x4, 0x0, 2); //C0 high=2
    setcounter(c, 0x4, 0x1, 1); //C0 low =1
    setcounter(c, 0x4, 0x5, 1); //mode   =odd
    setcounter(c, 0x5, 0x0, 3); //C1 high=3
    setcounter(c, 0x5, 0x1, 3); //C1 low =3
    setcounter(c, 0x5, 0x5, 0); //mode   =even
#endif

    pllreconfig(c);
    CTRL_close(c);
  }
}
