#ifndef __SING__
#define __SING__

#include <ctrl.h>

#if defined(__cplusplus)
extern "C"
{
#endif
  #define NPEMAX             64

  void SING_set_chipid(int);
  int SING_open();
  int SING_close();
  int SING_number_of_pe();
  int SING_number_of_bb();
  UINT64 SING_get_bb_mask();
  int SING_number_of_active_bb();
  int SING_EM_alloc(int length, const int *conversions, int size, int *err);
  int SING_EM_free();
  int SING_EM_areas();
  void SING_EM_status();
  void SING_BM_status();
  void SING_LM_status();
  int SING_print_instlist(int ilid);
  int SING_EM_send(int areaid, int start, int ndata, void *hostp);
  int SING_LM_write_regconv(int length, int *conversions);
  int SING_LM_write(void *hostp, int lmoffset, int peeach);
  int SING_iregister(int ninst, const char **insts);
  int SING_iflush();
  int SING_BM_alloc(int emid, int size, int *err);
  int SING_BM_free();
  int SING_set_result_size(int dum, int size);
  int SING_EM_BM_transfer(int areaid, int emstart, int bmstart, int ndata, int mode, int bbid);
  void SING_EM_fifoclr();
  int SING_execute(int init_id, int loop_id, int final_id, int loop_count, void *loop_out, void *final_out);
    int SING_execute2(int ncodes, int codes[],
		      int loop_count,
		      void *loop_out,
		      void *final_out,
		      int sizes[]) ;

    int SING_set_dmacheck_mode(int mode);
    int SING_get_dmacheck_mode();

    //    void SING_DMAR_wait(int nchips, SINGinfo * s[nchips]);    
    //    void SING_DMAR_wait_onechip(SINGinfo * s);
    int SING_EM_BM_transfer_setup(int idpid,
				  int areaid,
				  int emstart,
				  int bmstart,
				  int ndata,
				  int mode,
				  int bbid) ;

    int SING_start(int code, int loop_count);
    int SING_finish();
    void SING_flush_piow_channel();
    
    
#if defined(__cplusplus)
}
#endif
#endif /* __SING__*/
