#ifndef __SINGMC__
#define __SINGMC__

#include <sing_chip.h>

#if defined(__cplusplus)
extern "C"
{
#endif
  #define NPEMAX             64

  SINGinfo* SING_openMC(int id);
  int SING_closeMC(SINGinfo *s);
  int SING_number_of_pe();
  int SING_number_of_bb();
 
  int SING_number_of_active_bb();
  int SING_EM_allocMC(SINGinfo *s, int length, const int *conversions, int size, int *err);
  int SING_EM_freeMC(SINGinfo *s);
  int SING_EM_areasMC(SINGinfo *s);
  void SING_EM_statusMC(SINGinfo *s);
  void SING_BM_statusMC(SINGinfo *s);
  void SING_LM_statusMC(SINGinfo *s);
  int SING_EM_sendMC(SINGinfo *s, int areaid, int start, int ndata, void *hostp);
  int SING_EM_vsendMC(SINGinfo *s, int areaid, int address[], int ndata, void *hostp);
  int SING_LM_write_regconvMC(SINGinfo *s, int length, int *conversions);
  int SING_LM_writeMC(SINGinfo *s, void *hostp, int lmoffset, int peeach);
  int SING_iregisterMC(SINGinfo *s, int ninst, const char **insts);
  int SING_iflushMC(SINGinfo *s);
  int SING_BM_allocMC(SINGinfo *s, int emid, int size, int *err);
  int SING_BM_freeMC(SINGinfo *s);
  int SING_set_result_sizeMC(SINGinfo *s, int dum, int size);
  int SING_EM_BM_transferMC(SINGinfo *s, int areaid, int emstart, int bmstart, int ndata, int mode, int bbid);
  int SING_executeMC(SINGinfo *s,
		     int init_id,
		     int loop_id,
		     int final_id,
		     int loop_count,
		     void *loop_out,
		     void *final_out);
  void SING_EM_fifoclrMC(SINGinfo *s);

    int SING_EM_sendMC_singlethread(int nchips,
				    SINGinfo * s[nchips],
				    int areaid,
				    int start,
				    int ndata,
				    void * hostp,
				    int increment);
    int SING_execute2MC(SINGinfo *s,
			int ncodes,
			int codes[],
			int loop_count,
			void *loop_out,
			void *final_out,
			int sizes[]); 

    void SING_initialize_dmawbufferMC(SINGinfo * s, int size);
    int SING_remaining_words_dmawMC(SINGinfo * s);

    int SING_EM_BM_transfer_setupMC(SINGinfo *s,
				    int idpid,
				    int areaid,
				    int emstart,
				    int bmstart,
				    int ndata,
				    int mode,
				    int bbid); 
    int SING_startMC(SINGinfo *s, int code, int loop_count);
    int SING_finishMC(SINGinfo *s);
    void SING_flush_piow_channelMC(SINGinfo * s);
    void SING_register_dma_seqMC(SINGinfo *s, int seq_id, int wmode,
				 int size, UINT64 *buf);

    int SING_EM_BM_transfer_setupMC_andsend1(SINGinfo *s, int idpid, int areaid, int emstart,
					     int bmstart, int ndata, int mode, int bbid);

    
#if defined(__cplusplus)
}
#endif
#endif /* __SING__*/
