#ifndef _SING_CHIP_H
#define _SING_CHIP_H

#include <typedef.h>
#include <ctrl.h>

#include <sing_isp.h>
#include <sing_embm.h>
#include <sing_lm.h>
#include <sing_dbg.h>

typedef struct
{
  SINGISP_INFO isp;
  SINGEM_INFO em;
  SINGBM_INFO bm;
  SINGLM_INFO lm;
  CTRLinfo *c;
} SINGinfo;


// this definition, or this function itself, should
// not be here. Some refactoring necessary

int SING_EM_send_i_multichip(int nchips,
			     SINGinfo * s[nchips],
			     int areaid,
			     int start,
			     int ndata,
			     void *hostp,
			     int increment);

void SING_EM_set_areaid_multichip(int nchips,
				 SINGinfo * s[nchips],
				  int areaid);
int SING_EM_set_skip_areaid(int skip);


int SING_dmar_buffer_control(int nchips, SINGinfo * s[nchips],
			     int flag);

void SING_coc_reg_write(SINGinfo *s, int address, UINT64 data);
void SING_dump_syncstatus(int ndevs, SINGinfo * s[ndevs], char * c);
void SING_dump_savedstatus(int ndevs,  char * c);
void SING_save_syncstatus(int ndevs, SINGinfo * s[ndevs]);
void SING_set_reductionmode(SINGinfo *s,  int f);

SINGinfo* SING_get_singinfo();

void SING_DMAR_wait(int nchips, SINGinfo * s[nchips]);    
void SING_DMAR_wait_onechip(SINGinfo * s);

#endif
