#
# convert_logic_to_simin.rb
#
# Copyright Jun Makino All rights reserved.
# J. Makino, 2004/10/7 
$LOAD_PATH.unshift(File.dirname($0))
$LOAD_PATH.push(ENV["ACSROOT"]+"/src/utilities") if ENV["ACSROOT"] != nil

require "clop.rb"

options_definition_string = <<-END

  Description:     VPM timeless-logic to test vector converter
  Long description:
    VPM timeless-logic to test vector converter
    (c) 2004- Jun Makino
  
    This program convert the SIMOUT chip input/output file
    which does not have the timing information to the test vector
    with time sequence. Note that at least in this version the latency
    of output and skew of two inputs (ISP and IDP) are assumed to be zero.


  Short name: 		-v
  Long name:		--verbose
  Default value:	0
  Value type:		int
  Variable name: 	vlevel
  Description:		Verbose level
  Long description:
    This option specifies the verbose level. The default is 0. Putting larger 
    number should result in more messages (may or may not useful, though).

END

$clop = parse_command_line(options_definition_string, false)

$ispbits= [3, 3, 3, 1, 1, 1, 2, 1, 2, 6,
  1, 1, 6, 1, 1, 6, 1, 1, 1, 2,
  9, 4, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 2, 2, 1, 1, 1, 1,
  1, 3, 2, 5, 1, 1, 1,11, 5, 1]

$idpbits=[8, 13, 5, 5, 1]

$rrnbits=[13, 8, 5, 1,  1,
  1,  1, 1, 1,  1,
  1,  5, 1, 1,  1]


def convert_to_bits(s)
  result=""
  s.each_byte{|c|
    bits=c.chr.hex.to_s(2)
    result += "0"*(4-bits.size)+bits
  }
  result
end
  
def split_bits(spec, hexstring)
  bitstring=convert_to_bits(hexstring)
  result=""
  spec.each{|k|
    result += " "+bitstring[0,k].to_i(2).to_s(16)
    bitstring=bitstring[k,bitstring.size-k]
  }
  result
end

while s = gets
  if s =~ /^ISP:/ 
    print "ISP ", split_bits($ispbits,s.chomp.split[1]), " \# #{s}"
  elsif s =~ /^IDPS/ 
    print "IDP ", split_bits($idpbits,s.chomp.split[1]), "\n"
  elsif s =~ /^IDPD/ 
    data=s.chomp.split[1]
#    print "HEX ", data[0,8], " ", data[9,17], "\n"
    print "HEX ", data, "\n"
  elsif s =~ /^RRNI/
    print "IDP 1 1000  0 0\n"
    print "RRN ", split_bits($rrnbits, s.chomp.split[1]), "\n"
  end
end
