#
# convert_logic_to_vector.rb
#
# Copyright Jun Makino All rights reserved.
# J. Makino, 2004/10/7 
$LOAD_PATH.unshift(File.dirname($0))
$LOAD_PATH.push(ENV["ACSROOT"]+"/src/utilities") if ENV["ACSROOT"] != nil

require "clop.rb"

options_definition_string = <<-END

  Description:     VPM timeless-logic to test vector converter
  Long description:
    VPM timeless-logic to test vector converter
    (c) 2004- Jun Makino
  
    This program convert the SIMOUT chip input/output file
    which does not have the timing information to the test vector
    with time sequence. Note that at least in this version the latency
    of output and skew of two inputs (ISP and IDP) are assumed to be zero.


  Short name: 		-v
  Long name:		--verbose
  Default value:	0
  Value type:		int
  Variable name: 	vlevel
  Description:		Verbose level
  Long description:
    This option specifies the verbose level. The default is 0. Putting larger 
    number should result in more messages (may or may not useful, though).

END

$clop = parse_command_line(options_definition_string, false)

def construct_idpd(a)
  return " 0 0 0 0 0 0 0 0 0 0 0 0"   if a == []
  s = a.shift
  if s =~ /^IDP/
    nadd=3
    3.times{|i| nadd = i if a[i] == nil or a[i] !~ /^IDP/  }
    idpout=" 1 " + s.split[1]
    nadd.times{
      s = a.shift
      idpout +=  s ? (" 1 " + s.split[1]) : " 0 0"
    }
    (5-nadd).times{idpout += " 0 0"}
  elsif s =~ /^RRNI/
    idpout = " 1 018000000000000000 1 #{s.split[1]} 0 0 0 0 0 0 0 0"
  elsif s =~ /^RRND/
    idpout = " 0 0 0 0 0 0 0 0  1 #{s.split[1]} "
    if a[0] =~ /^RRND/
      s = a.shift
      idpout += " 1 "+ s.split[1]
    else
      idpout += " 0 0"
    end
  else
    raise "Unknown input #{s} "
  end
  idpout
end

def printuntilwait(isp,idpandrrn)
  isp_waitstate = nil
  while (isp != [] and not isp_waitstate)  or idpandrrn != []
    sisp = ""
    unless isp_waitstate
      sisp = isp.shift if isp != []
      isp_waitstate = true if sisp =~ /^ISP_/ 
    end
    ispd = (sisp.split.size >= 2) ? sisp.split[1] : "0"
    idpd = construct_idpd(idpandrrn)
    print ispd, " ", idpd, "\n"
  end
end

def printvector(isp,idp, rrn)
  idpwait=rrnblock=false
  isp.each{|s|
    idpwait= true if s.split[0] == "ISP_WAIT_IDP"
    rrnblock= true if s.split[0] == "ISP_BLOCK_RRN"
  }
  printuntilwait(isp, idp) if idpwait
  printuntilwait(isp, idp) if rrnblock 
  printuntilwait(isp,idp+rrn)
end


isp=[]
idp=[]
rrn=[]
inisp=inrrn=false
while s = gets
  s = s.chomp
  if s =~ /^IDP/
    if inisp or inrrn
      printvector(isp,idp,rrn)
      inisp=inrrn=false
      isp=[]; rrn=[]; idp=[]
    end
    idp.push s
  elsif s =~ /^ISP/ 
    if inrrn
      printvector(isp,idp,rrn)
      inrrn=false
      isp=[]; rrn=[]; idp=[]
    end
    inisp=true
    isp.push s
  elsif s =~ /^RRN/
    inrrn=true
    inisp=false
    rrn.push s
  else
    raise "Unknow input #{s} "
  end
end
printvector(isp,idp, rrn)


