#
# convert_logic_to_vector_type2.rb
#
# Copyright Jun Makino All rights reserved.
# J. Makino, 2004/10/7 
$LOAD_PATH.unshift(File.dirname($0))
$LOAD_PATH.push(ENV["ACSROOT"]+"/src/utilities") if ENV["ACSROOT"] != nil

require "clop.rb"

options_definition_string = <<-END

  Description:     VPM timeless-logic to test vector converter type2
  Long description:
    VPM timeless-logic to test vector converter for type 2 output
    (c) 2004- Jun Makino
  
    This program convert the SIMOUT chip input/output file
    which does not have the timing information to the test vector
    with time sequence. Note that at least in this version the latency
    of output and skew of two inputs (ISP and IDP) are assumed to be zero.


  Short name: 		-v
  Long name:		--verbose
  Default value:	0
  Value type:		int
  Variable name: 	vlevel
  Description:		Verbose level
  Long description:
    This option specifies the verbose level. The default is 0. Putting larger 
    number should result in more messages (may or may not useful, though).

END

$clop = parse_command_line(options_definition_string, false)
$nop = "ISP: 800000000000000000000000000 "
def printpattern(s,idp)
  a = s.split
  isps = a[1]
  idps = " 0 0 0 0 0 0 0 0"
  rrns = " 0 0 0 0"
  newidp = true
  if a[2]== "IDPS:" 
    idps = " 0 0 0 0 0 0 1 "+a[3] 
  elsif  a[4]== "IDPS:" 
    idps = " 0 0 0 0 0 0 1 "+a[5] 
  elsif  a[6]== "IDPS:" 
    idps = " 0 0 0 0 0 0 1 "+a[7] 
  elsif a[2]== "RRNI:"
    idps = " 0 0 0 0  1 018000000000000000 1 "+a[3]
  else
    newidp=false
  end
  if idp.size > 0 
    if newidp 
      STDERR.print "Error: premature end of IDP packet at line #{$.}\n"
      STDERR.print "remaining IDP data size= #{idp.size}\n"
      STDERR.print "data = ", s
      exit
    end
    idps= ""
    4.times{
      x=idp.shift
      idps += " 1 " + x.split[1] if x
    }
    (8- idps.split.size).times{ idps += " 0"}
  end
  if a[2]== "RRND:"
    rrns = " 1 #{a[3]} 1 #{a[5]}"
  end
  print isps,idps,rrns, "\n"
end

def flush_idp(idp)
  while idp.size > 0
    printpattern($nop,idp)
  end
end
idp=[]
while s = gets
  s = s.chomp
  s = $nop+s if s =~ /^ IDPS/
  if s =~ /^IDP/
    idp.push s
  elsif s =~ /^ISP_WAIT_IDP/ 
    flush_idp(idp)
    idp = []
  elsif s =~ /^ISP/ 
    printpattern(s,idp)
  elsif s == ""
     #skip blanck line
  else
    raise "Unknow input #{s} "
  end
end
flush_idp(idp)




