#
# generate-ialu-test.rb
#
#
#  ̿ᥳ ڥ졼
#  0x00       A+B
#  0x01       A-B
#  0x02       A+1
#  0x03       A-1
#  0x04       not A
#  0x05       A and B
#  0x06       A or B
#  0x07       A xor B
#  0x08       max (A,B)
#  0x09       min (A,B)
#  0x0A       A
#  0x0B       B
#  0x0C       A lshiftl B
#  0x0D       A lshiftr B
#  0x0E       A bshiftl B
#  0x0F       A bshiftr B
#  0x10       logical not A
#  0x1F       immidiate
# 
# ȡ unsigned bit 롣
# Фɬפ롣

module Alu
  MASK72 = "FFFFFFFFFFFFFFFFFF".to_i(16)
  MASK73 = "1FFFFFFFFFFFFFFFFFF".to_i(16)
  BIT72 =  "800000000000000000".to_i(16)
  BIT73 =  "1000000000000000000".to_i(16)

  def ext73(a,unsigned)
    unless  unsigned
      x=((a & BIT72) != 0) ? (a | BIT73) : a
      retval = x & MASK73
    else
      retval = a & MASK73
    end
    print "ext73 in = #{a.to_s(16)}\n" if $DEBUG
    print "ext73 out= #{retval.to_s(16)}\n" if $DEBUG
    retval
  end
  def iadd(a, b,unsigned)
#    s = (a & MASK72)+ (b & MASK72)
#    s = ext73(a,unsigned)+ ext73(b,unsigned)
    s = a+b
    print "a= #{a.to_s(16)}\n" if $DEBUG
    print "b= #{b.to_s(16)}\n" if $DEBUG
    print "s= #{s.to_s(16)}\n" if $DEBUG
    flg = ( unsigned ) ?  (s & BIT73) :  (s & BIT72)
    flg =  (flg != 0) ? 0:1
    [(s & MASK72),flg]
  end



  def iadd73(a, b,unsigned)
#    s = (a & MASK73)+ (b & MASK73)
#    s = ext73(a,unsigned)+ ext73(b,unsigned)
    s = a+b
    print "a= #{a.to_s(16)}\n" if $DEBUG
    print "b= #{b.to_s(16)}\n" if $DEBUG
    print "s= #{s.to_s(16)}\n" if $DEBUG
    flg =   (s & BIT73)
    flg =  (flg != 0) ? 0:1
    [(s & MASK72),flg]
  end

  def flag(a)
    (a==0) ? 1:0
  end

  def imax(a,b,unsigned)
    dif = iadd73(a,-b,unsigned)[1]
    print "imax dif = #{dif}\n" if $DEBUG
    (dif == 1) ? a:b
  end
  def imin(a,b,unsigned)
    dif = iadd73(a,-b,unsigned)[1]
    (dif == 1) ? b:a
  end

  def generic_shifter(a, shift, left, logical, unsigned)
    print("left=#{left}\n") if $DEBUG
    print("logical=#{logical}\n") if $DEBUG
    print("unsigned=#{unsigned}\n") if $DEBUG
    print("a=#{a.to_s(16)}\n") if $DEBUG
    bitstring = (a & MASK72).to_s(2)
    print("s=#{bitstring}\n") if $DEBUG
    if (bitstring[0,1] == "1") and  (not unsigned) and logical and
        (bitstring.length==72)
      fill="1"
    else
      fill="0"
    end
    bitstring = fill*(72-bitstring.length)+bitstring
    if logical
      bitstring= fill*72+bitstring+"0"*72
    else
      bitstring *= 3
    end
    shift &= 127
    if logical 
      shift = 72 if shift > 72
    else
      shift = (shift & 127) % 72
    end
    shift =  -shift unless left
    p bitstring[0,72] if $DEBUG
    p bitstring[72,72] if $DEBUG
    p bitstring[144,72] if $DEBUG
    p shift if $DEBUG
    bitstring[72+shift,72].to_i(2)
  end

  def lshiftl(a,shift,unsigned)
    generic_shifter(a,shift,true, true, unsigned)
  end
  
  def lshiftr(a,shift,unsigned)
    generic_shifter(a,shift,false, true, unsigned)
  end
  
  def bshiftl(a,shift,unsigned)
    generic_shifter(a,shift,true, false, unsigned)
  end
  
  def bshiftr(a,shift,unsigned)
    generic_shifter(a,shift,false, false, unsigned)
  end
  
  def logical_not(a)
    if a == 0
      "000000001000000001".to_i(16)
    else
      0
    end
  end

  def iadd_string(a, b,unsigned)
    x= iadd(a.to_i(16),b.to_i(16), unsigned.to_i != 0)
    x[0].to_s(16)+ " "+x[1].to_s
  end

  def ialu(a,b,opcode,unsigned)
    a = ext73(a,unsigned)
    b = ext73(b,unsigned)
    case opcode
      when 0
      val=iadd(a,b,unsigned)
      when 1
      val=iadd(a,-b,unsigned)
      when 2
      val=iadd(a,1,unsigned)
      when 3
      val=iadd(a,-1,unsigned)
      when 4
      val= (~ (a | BIT73))&MASK72
      # Note: this strange expression is to workaround an apparent
      # bug of ruby 1.8.2, which returns 0 for ~0xffffffff
      when 5
      val= a & b
      when 6
      val = a | b
      when 7
      val = a ^ b
      when 8
      val = imax(a,b,unsigned)
      when 9
      val = imin(a,b,unsigned)
      when 10
      val = a
      when 11
      val = b
      when 12,13,14,15
      left = (((opcode-12) & 1) == 0)
      logical = (((opcode-12) & 2) == 0)
      val = generic_shifter(a, b, left, logical, unsigned)
      when 16
      val = logical_not(a)
      else
      raise "Unknown opcode #{opcode.to_s}"
    end
    val = [val & MASK72,flag(val)]    unless val.class == Array
    val
  end
end



  def to_idp(i)
    
    s = i.to_s(16)
    raise "to_idp: too large interger #{s} " if s.length  > 18
    if s.length < 10
      "0 "+ s
    else
      s[0,s.length-9]+ " " + s[s.length-9,9]
    end
  end



module PatternGenerator
  include Alu
  LENGTH=72

  def singlebit(i)
    (1 << i) & lsbfill(LENGTH) 
  end
  def lsbfill(i)
    raise if i< 0 or i > LENGTH
    ((1<<i)-1)
  end
  def msbfill(i)
    lsbfill(LENGTH) ^ lsbfill(i)
  end
  def allbutone(i)
    lsbfill(LENGTH) ^ singlebit(i)
  end
  def testpattern(a,b,opcode, unsigned)
    s = to_idp(a)+ " "+ to_idp(b)+" "+ opcode.to_s(16)+ " "+ unsigned.to_s+ " "
    uns = (unsigned == 1)
    c = ialu(a,b,opcode,uns)
    s +=  to_idp(c[0])+ " "+ c[1].to_s 
  end
end

def addpreceedingzeros(a)
  "0"*(9-a.length)+a
end
def patterncheck(s)
  a=s.split
  p a if $DEBUG
  print testpattern( (a[1]+addpreceedingzeros(a[2])).to_i(16),
                     (a[3]+addpreceedingzeros(a[4])).to_i(16),
                     a[5].to_i(16),
                     a[6].to_i(16))
  print "\n"
  exit
end

include  PatternGenerator



#patterncheck("Er: 0 1 800000000 0 8 0")
#patterncheck("Er: 0 1 0 1 3 1")
#patterncheck("Er: 0 1 0 0 c 0 ")
#patterncheck("Er: 0 1 0 1 4 0")
#patterncheck("Er: 0 ffffffff 0 ffffffff 4 0 ")


(0..72).each{|i|
  [2,3,4,10,11,16].each{|opcode|
    (0..1).each{|unsigned|
      [singlebit(i),lsbfill(i),msbfill(i),allbutone(i)].each{|a|
        print testpattern(a,a,opcode,unsigned),"\n"
      }
    }
  }
}



(0..72).each{|i|
  [12,13,14,15].each{|opcode|
    (0..128).each{|j|
      (0..1).each{|unsigned|
        [singlebit(i),lsbfill(i),msbfill(i),allbutone(i)].each{|a|
          print testpattern(a,j,opcode,unsigned),"\n"
        }
      }
    }
  }
}



(0..72).each{|i|
    (0..72).each{|j|
    [0,1,5,6,7,8,9].each{|opcode|
      (0..1).each{|unsigned|
        [singlebit(i),lsbfill(i),msbfill(i),allbutone(i)].each{|a|
          [singlebit(j),lsbfill(j),msbfill(j),allbutone(j)].each{|b|
            print testpattern(a,b,opcode,unsigned),"\n"
          }
        }
      }
    }
  }
}


