//
// EM size is hardcoded in  matmul_setup_elt_data{0,1}MC
// 

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <math.h>

#include <emmintrin.h>
typedef double v2df __attribute__((vector_size(16)));
typedef union {v2df v; double s[2];}v2u;

#include "./matmul32-32.h"
#include "./multiboard-control.h"
#include "./dgemmconf.h"
#include <sing_chip.h>
#include <sing_embm.h>
#include <sing_dbg.h>

#ifndef NJP
#    define NJP 65536
#endif

#ifndef NPE
#define NPE 32
#endif
#ifndef NBB
#define NBB 16
#endif

#define DIM0 (32*NBB*NCHIP)
#define DIM1 (8*NPE)

static char myhostname[257];

int matmul_send_vsm_constants(){}

// several control parameters for use of new features of CP
//

static int use_old_dmaw = 0;

// functions defined in testmatmul32.c
//


static int matmul_msg_level = 1;

void set_matmul_msg_level(level)
{
    matmul_msg_level = level;
}
int get_matmul_msg_level()
{
    return matmul_msg_level;
}

static int nboards = 1;
static int nchips = NCHIP;

void matmul_setnboards(int nb)
{
    nboards = nb;
    nchips = nb*NCHIP;
}
int  matmul_getnboards(){return nboards;}
int  matmul_getnchips(){return nchips;}

inline UINT64 rdtsc2()
{
	UINT64 ret;
	asm __volatile__("rdtsc  \n\t" \
			 "shlq $32, %%rdx \n\t" \
			 "orq  %%rdx, %%rax \n\t" \
			 "movq %%rax, %0" : "=g"(ret) : :"rax", "rdx");
	return ret;
}

static void xwait(int wait)
{
    UINT64 st = rdtsc2();
    while((rdtsc2()-st)<wait) {}
}

void matmul_coc_busywait(CTRLinfo *c)
{
    if (!CTRL_coc_busy(c)) return;
    int iwait = 0;
    do {
	xwait(1000);
	iwait += 10;
	if (iwait > 10000000){
	    fprintf(stderr,"coc_busy, timeout\n");
	    exit (-1);
	}
    } while (CTRL_coc_busy(c));
}    


static matmul_copy_ip_to_vip(struct matmul_hlt_struct0 *p,
                                 struct matmul_hlt_vector_struct0 *vp,
			         int k)
{
   vp->a0[k]= p->a0;
   vp->a1[k]= p->a1;
   vp->a2[k]= p->a2;
   vp->a3[k]= p->a3;
   vp->a4[k]= p->a4;
   vp->a5[k]= p->a5;
   vp->a6[k]= p->a6;
   vp->a7[k]= p->a7;
   vp->a8[k]= p->a8;
   vp->a9[k]= p->a9;
   vp->a10[k]= p->a10;
   vp->a11[k]= p->a11;
   vp->a12[k]= p->a12;
   vp->a13[k]= p->a13;
   vp->a14[k]= p->a14;
   vp->a15[k]= p->a15;
   vp->a16[k]= p->a16;
   vp->a17[k]= p->a17;
   vp->a18[k]= p->a18;
   vp->a19[k]= p->a19;
   vp->a20[k]= p->a20;
   vp->a21[k]= p->a21;
   vp->a22[k]= p->a22;
   vp->a23[k]= p->a23;
   vp->a24[k]= p->a24;
   vp->a25[k]= p->a25;
   vp->a26[k]= p->a26;
   vp->a27[k]= p->a27;
   vp->a28[k]= p->a28;
   vp->a29[k]= p->a29;
   vp->a30[k]= p->a30;
   vp->a31[k]= p->a31;
   vp->a32[k]= p->a32;
   vp->a33[k]= p->a33;
   vp->a34[k]= p->a34;
   vp->a35[k]= p->a35;
   vp->a36[k]= p->a36;
   vp->a37[k]= p->a37;
   vp->a38[k]= p->a38;
   vp->a39[k]= p->a39;
   vp->a40[k]= p->a40;
   vp->a41[k]= p->a41;
   vp->a42[k]= p->a42;
   vp->a43[k]= p->a43;
   vp->a44[k]= p->a44;
   vp->a45[k]= p->a45;
   vp->a46[k]= p->a46;
   vp->a47[k]= p->a47;
   vp->a48[k]= p->a48;
   vp->a49[k]= p->a49;
   vp->a50[k]= p->a50;
   vp->a51[k]= p->a51;
   vp->a52[k]= p->a52;
   vp->a53[k]= p->a53;
   vp->a54[k]= p->a54;
   vp->a55[k]= p->a55;
   vp->a56[k]= p->a56;
   vp->a57[k]= p->a57;
   vp->a58[k]= p->a58;
   vp->a59[k]= p->a59;
   vp->a60[k]= p->a60;
   vp->a61[k]= p->a61;
   vp->a62[k]= p->a62;
   vp->a63[k]= p->a63;

}

#if 0
int matmul_send_i_particleMC(SINGinfo *s, struct matmul_hlt_struct0 *ip,
                         int n)
{
    struct matmul_hlt_vector_struct0 ipv[NPEMAX];
    int i;
    for(i=0;i<n;i++){
        int iv = i/4;
	int k  = i%4;
        matmul_copy_ip_to_vip(ip+i, ipv+iv, k);
    }
    i = (n+3)/4;
    SING_LM_write(ipv, 0, i);
}

void matmul_register_i_particle_conversion()
{
    int conversions[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

    SING_LM_write_regconv(256,conversions);
}
#endif

int idtrans; //imatrix transfer code id
int id_set_mask2;
int id_reset_mask2;

#define MODULE_HIT 1

void CTRL_hit_headerdata2(CTRLinfo *c, int len, int addr, int bbn1, int bbn2, int bbnm, int seq, UINT64 *data)
{
  int size;
  UINT64 datahead1 = 
    ((UINT64)len << 56) +
    ((UINT64)addr << 43) + 
    ((UINT64)bbn1 << 38) +
    ((UINT64)bbnm << 33) +
    ((UINT64)seq << 32);
  UINT64 datahead2 = 
    ((UINT64)len << 56) +
    ((UINT64)addr << 43) + 
    ((UINT64)bbn2 << 38) +
    ((UINT64)bbnm << 33) +
    ((UINT64)seq << 32);

  int s = 256;
  int devid = c->hib_id;
  Hib *hib = c->h;
  int i, j, x;

  UINT64 header1 = ((UINT64)1 << 40)   | ((UINT64)MODULE_HIT << 36) | 0x2ULL;    //for hitheader
  UINT64 header2 = ((UINT64)len << 40) | ((UINT64)MODULE_HIT << 36) | 0x200ULL;  //for data
  size = len + 3; //header + hithead1 + header + data(*len)
  //printf("id , len = %d , %d \n", devid, len);
  x=0;
  for (i = 0; i < 2; i++) {
    hib->piow_dblbuf[0] = header1;
    if(i==0){
      hib->piow_dblbuf[1] = datahead1;
    } else {
      hib->piow_dblbuf[1] = datahead2;
    }
    hib->piow_dblbuf[2] = header2;
    for(j=0; j<len;j++){ //assumed len<s
      hib->piow_dblbuf[j+3] = data[x];
      x++;
    }

    hib_mem_writeMC(devid, hib->dma0misc,
		    (1<<(hib->dma0misc_swap_sram_bit)) |
		    (size<<(hib->dma0misc_sram_wcnt_bit)));

      //      _mm_mfence();
      //      usleep(100000);
      // write '1' to HIB local register 'swap_sram'
      // write data size xto 'sram_wcnt'
  }
}

void CTRL_hit_headerdata1(CTRLinfo *c, int len, int addr, int bbn1,  int bbnm, int seq, UINT64 *data)
{
    int size;
    UINT64 datahead1 = 
	((UINT64)len << 56) +
	((UINT64)addr << 43) + 
	((UINT64)bbn1 << 38) +
	((UINT64)bbnm << 33) +
	((UINT64)seq << 32);
    int s = 256;
    int devid = c->hib_id;
    Hib *hib = c->h;
    int i, j, x;
    
    UINT64 header1 = ((UINT64)1 << 40)   | ((UINT64)MODULE_HIT << 36) | 0x2ULL;    //for hitheader
    UINT64 header2 = ((UINT64)len << 40) | ((UINT64)MODULE_HIT << 36) | 0x200ULL;  //for data
    size = len + 3; //header + hithead1 + header + data(*len)
    hib->piow_dblbuf[0] = header1;
    hib->piow_dblbuf[1] = datahead1;
    hib->piow_dblbuf[2] = header2;
    for(j=0; j<len;j++){ //assumed len<s
	hib->piow_dblbuf[j+3] = data[j];
    }
    
    hib_mem_writeMC(devid, hib->dma0misc,
		    (1<<(hib->dma0misc_swap_sram_bit)) |
		    (size<<(hib->dma0misc_sram_wcnt_bit)));
}

void CTRL_active_BB(SINGinfo *s, UINT64 bbflag, int bbid)
{
  UINT64 convpeid[4] = {4<<4|4, 4<<4|4, 4<<4|4, 4<<4|4}; //fix64to72rs
  UINT64 bbcont = 0x800;
  UINT64 data[4];
  CTRLinfo *c = s->c;
  int i;

  for(i=0;i<4;i++){
    data[i] = bbflag;
  }
  
  CTRL_hit_reset_count(c);
  CTRL_hit_convtable(c, 0, convpeid, 4);
  CTRL_hit_header(c, 4, bbcont, 0x0, 0x0, 0); //bbcontrol
  CTRL_hit_length(c, 4);
  CTRL_hit_data(c, data, 4);
  
}

static UINT64 convdata[256]; // filled in 0

void set_bbid_for_send_imatrixMC(SINGinfo *s,  int bbid)
{
  CTRLinfo *c = s->c;
  UINT64 convid[4] = {4<<4|4, 4<<4|4, 4<<4|4, 4<<4|4}; //fix64to72rs
  UINT64 id[4];
  double x[4], *p;
  UINT64 start, setup, end;
  //  fprintf(stderr, "set bbid mask %d\n", bbid);

  int i, instid;
  if (bbid >= 0){
      
      for(i=0;i<4;i++){
	  id[i] = bbid;
      }
      
      CTRL_hit_reset_count(c);
      CTRL_hit_convtable(c, 0, convid, 4);
      CTRL_hit_header(c, 4, 512, 0, 0, 0);// broadcast id to 16BB
      CTRL_hit_length(c, 4);
      CTRL_hit_data(c, id, 4);
      SING_send_instlist(s->c, &(s->isp.instlists[id_set_mask2]), 1, 1);
  }else{
      SING_send_instlist(s->c, &(s->isp.instlists[id_reset_mask2]), 1, 1);
  }
  //  fprintf(stderr, "set bbid mask end\n");
}


void send_i_matrix_singlebbMC(SINGinfo *s, double a[64][4], int pe, int bb)
{
  CTRLinfo *c = s->c;
  UINT64 convpeid[4] = {4<<4|4, 4<<4|4, 4<<4|4, 4<<4|4}; //fix64to72rs
  UINT64 peid[4];
  double x[4], *p;
  UINT64 start, setup, end;
  int i, instid;
  for(i=0;i<4;i++){
    peid[i] = pe;
  }
#if 0
  for(i=0;i<256;i++){
    convdata[i] = 0;
  }
#endif
  CTRL_hit_reset_count(c);
  CTRL_hit_convtable(c, 0, convpeid, 4);
  CTRL_hit_header(c, 4, 512, 0, 0, 0);// broadcast peid to 16BB
  CTRL_hit_length(c, 4);
  CTRL_hit_data(c, peid, 4);
  CTRL_hit_length(c, 256);
  CTRL_hit_convtable(c, 0, convdata, 256);
  setup = rdtsc2();
  CTRL_hit_headerdata1(c, 256, 0, bb,  0xf, 0, (UINT64*)(&(a[0][0])));
  SING_send_instlist(s->c, &(s->isp.instlists[idtrans]), 1, 1);
}

void send_i_matrix_16bbMC(SINGinfo *s, double a[16][64][4], int pe)
{
  CTRLinfo *c = s->c;
  //UINT64 convdata[256]; 
  UINT64 convpeid[4] = {4<<4|4, 4<<4|4, 4<<4|4, 4<<4|4}; //fix64to72rs
  UINT64 peid[4];
  double x[4], *p;
  UINT64 start, setup, end;

  int i, instid;

  start = rdtsc2();

  for(i=0;i<4;i++){
    peid[i] = pe;
  }
#if 0
  for(i=0;i<256;i++){
    convdata[i] = 0;
  }
#endif

  CTRL_hit_reset_count(c);
  CTRL_hit_convtable(c, 0, convpeid, 4);
  CTRL_hit_header(c, 4, 512, 0, 0, 0);// broadcast peid to 16BB
  CTRL_hit_length(c, 4);
  CTRL_hit_data(c, peid, 4);
  CTRL_hit_length(c, 256);
  CTRL_hit_convtable(c, 0, convdata, 256);
  setup = rdtsc2();

#if 0
  for(i=0;i<NBB;i++){
    //printf("%d : %e \n", i, a[i][0][0]);
#if 0
    CTRL_hit_header(c, 0, 0, i, 0xf, 0); // single BB write 256LW
    CTRL_hit_data(c, &(a[i][0][0]), 256);
#else
    CTRL_hit_headerdata(c, 256, 0, i, 0xf, 0, &(a[i][0][0]));
#endif
  }
#else
  for(i=0;i<NBB;i+=2){
      //    CTRL_hit_headerdata2(c, 256, 0, i, i+1, 0xf, 0, (UINT64*)&(a[i][0][0]));
      CTRL_hit_headerdata1(c, 256, 0, i,  0xf, 0, (UINT64*)&(a[i][0][0]));
    CTRL_hit_headerdata1(c, 256, 0, i+1,  0xf, 0, (UINT64*)&(a[i+1][0][0]));
  }
#endif

  SING_send_instlist(s->c, &(s->isp.instlists[idtrans]), 1, 1);
  end = rdtsc2();
#if 0  //def BENCHSENDI
  printf("i mat send 256*16 : %lld [clk] %lld [clk] elapsed . \n", setup-start, end-setup);
#endif
}

void send_i_matrix_nbbMC(SINGinfo *s, double a[16][64][4], int pe, int nbb)
{
  CTRLinfo *c = s->c;
  UINT64 convpeid[4] = {4<<4|4, 4<<4|4, 4<<4|4, 4<<4|4}; //fix64to72rs
  UINT64 peid[4];
  double x[4], *p;
  UINT64 start, setup, end;

  int i, instid;

  start = rdtsc2();

  for(i=0;i<4;i++){
    peid[i] = pe;
  }
#if 0
  for(i=0;i<256;i++){
    convdata[i] = 0;
  }
#endif
  
  CTRL_hit_reset_count(c);
  CTRL_hit_convtable(c, 0, convpeid, 4);
  CTRL_hit_header(c, 4, 512, 0, 0, 0);// broadcast peid to 16BB
  CTRL_hit_length(c, 4);
  CTRL_hit_data(c, peid, 4);
  CTRL_hit_length(c, 256);
  CTRL_hit_convtable(c, 0, convdata, 256);
  setup = rdtsc2();

  for(i=0;i<nbb;i+=2){
      CTRL_hit_headerdata2(c, 256, 0, i, i+1, 0xf, 0, (UINT64*)&(a[i][0][0]));
  }
  
  SING_send_instlist(s->c, &(s->isp.instlists[idtrans]), 1, 1);
  end = rdtsc2();
  //printf("i mat send 256*16 : %lld [clk] %lld [clk] elapsed . \n", setup-start, end-setup);
}

void clearBM_i_matrix_16bbMC(SINGinfo *s, int pe)
{
  CTRLinfo *c = s->c;
  UINT64 start, setup, end, peid[4];
  double data[256];
  UINT64 convpeid[4] = {4<<4|4, 4<<4|4, 4<<4|4, 4<<4|4}; //fix64to72rs
  int i, instid;

  start = rdtsc2();

  CTRL_hit_reset_count(c);
  setup = rdtsc2();
  for(i=0;i<4;i++){
    peid[i] = pe;
  }
  CTRL_hit_convtable(c, 0, convpeid, 4);
  CTRL_hit_header(c, 4, 512, 0, 0, 0);// broadcast peid to 16BB
  CTRL_hit_length(c, 4);
  CTRL_hit_data(c, peid, 4);
  
  CTRL_hit_length(c, 256);
  CTRL_hit_convtable(c, 0, convdata, 256);
  for(i=0;i<256;i++){
    data[i] = 0.0;
  }
  CTRL_hit_headerdata(c, 256, 0, 0, 0, 0, (UINT64*)data);
  end = rdtsc2();
  //printf("i mat send 256*16 : %lld [clk] %lld [clk] elapsed . \n", setup-start, end-setup);
}


void send_i_matrix_8bbMC(SINGinfo *s, double a[8][64][4], int pe, int bb, int go)
{
  CTRLinfo *c = s->c;
  UINT64 convpeid[4] = {4<<4|4, 4<<4|4, 4<<4|4, 4<<4|4}; //fix64to72rs
  UINT64 peid[4];
  double x[4], *p;
  UINT64 start, setup, end;

  int i, instid;

  start = rdtsc2();
  for(i=0;i<4;i++){
    peid[i] = pe;
  }

  #if 0
  for(i=0;i<256;i++){
    convdata[i] = 0;
  }
  #endif

  CTRL_hit_reset_count(c);
  CTRL_hit_convtable(c, 0, convpeid, 4);
  CTRL_hit_header(c, 4, 512, 0, 0, 0);// broadcast peid to 16BB
  CTRL_hit_length(c, 4);
  CTRL_hit_data(c, peid, 4);
  CTRL_hit_length(c, 256);
  CTRL_hit_convtable(c, 0, convdata, 256);

  setup = rdtsc2();
  for(i=0;i<8;i++){
    //printf("%d : %e \n", i, a[i][0][0]);
#if 0
    CTRL_hit_header(c, 256, 0, i+bb, 0xf, 0); // single BB write 256LW
    CTRL_hit_data(c, &(a[i][0][0]), 256);
#else
    CTRL_hit_headerdata(c, 256, 0, i+bb, 0xf, 0, (UINT64*)&(a[i][0][0]));
#endif
  }
  end = rdtsc2();
  //SING_execute_i(&(s->isp), c, -1, idtrans, -1, 1, NULL, NULL);
  if(go)
    SING_send_instlist(s->c, &(s->isp.instlists[idtrans]), 1, 1);
  //printf("i mat send 256*16 : %lld [clk] %lld [clk] elapsed . \n", setup-start, end-setup);
}


static int emid0;
static int bmid0;
int matmul_setup_elt_data0MC(SINGinfo *s)
{
    int err;
    int conversions[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

    //emid0=SING_EM_allocMC(s, 32, conversions, 131068, &err);
    emid0=SING_EM_allocMC(s, 32, conversions, 409600, &err);
    if (emid0 < 0){
        fprintf(stderr,"register jp, EMalloc err = %d\n",err);
        exit(1);
    }
    bmid0=SING_BM_allocMC(s, emid0,1,&err);
    if (bmid0 < 0){
    fprintf(stderr,"register jp, BMalloc err = %d\n",err);
          exit(1);
    }
}


int matmul_send_elt_data0MC(SINGinfo *s, struct matmul_elt_struct0 *ip, int index_in_EM)
{
    int ret;
    ret = SING_EM_sendMC(s, emid0,index_in_EM,1,ip);
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
        exit(1);
    }
}

int matmul_send_elt_data0MC_m(SINGinfo *s, struct matmul_elt_struct0 *ip, int index_in_EM, int count)
{
    int ret;
    ret = SING_EM_sendMC(s, emid0,index_in_EM,count,ip);
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
	exit(1);
    }
}


int matmul_send_elt_data0MC_m_singlethread(int nchips,
					   SINGinfo *s[nchips],
					   struct matmul_elt_struct0 *ip,
					   int index_in_EM, int count,
					   int increment)
{
    int ret;
    //    fprintf(stderr,"call SING_EM_sendMC_singlethread\n");
    ret = SING_EM_send_i_multichip(nchips, s, emid0,index_in_EM,count,ip,
				   increment);

    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(1);
    }
}


int matmul_move_elt_data0MC(SINGinfo *s, int index)
{
  SING_EM_BM_transferMC(s, bmid0,index,0,1,1,-1);
}



static int emid1;
static int bmid1;
int matmul_setup_elt_data1MC(SINGinfo *s)
{
    int err;
    int conversions[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

    //emid1=SING_EM_allocMC(s, 32, conversions, 131068, &err);
    emid1=SING_EM_allocMC(s, 32, conversions, 409600, &err);
    if (emid1 < 0){
        fprintf(stderr,"register jp, EMalloc err = %d\n",err);
        exit(1);
    }
    bmid1=SING_BM_allocMC(s, emid1,1,&err);
    if (bmid1 < 0){
      fprintf(stderr,"register jp, BMalloc err = %d\n",err);
      exit(1);
    }
}

int matmul_send_elt_data1MC(SINGinfo *s, struct matmul_elt_struct1 *ip, int index_in_EM)
{
    int ret;
    ret = SING_EM_sendMC(s, emid1,index_in_EM,1,ip);
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
	exit(1);
    }
}

int matmul_send_elt_data1MC_m(SINGinfo *s, struct matmul_elt_struct1 *ip, int index_in_EM, int count)
{
    int ret;
    ret = SING_EM_sendMC(s, emid1,index_in_EM,count,ip);
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(1);
    }
}

int matmul_send_elt_data1MC_m_singlethread(int nchips,
					   SINGinfo *s[nchips],
					   struct matmul_elt_struct1 *ip,
					   int index_in_EM, int count,
					   int increment)
{
    int ret;
    ret = SING_EM_send_i_multichip(nchips, s, emid1,index_in_EM,count,ip,
				   increment);
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(1);
    }
}


int matmul_move_elt_data1_nosendMC(SINGinfo *s, int index)
{
  int areaid, bmstart, emstart, ndata, mode, bbid;
  int emid, nword, nbm, len, eit_register_mode;
  SINGEM_INFO *eminfo = &(s->em);
  SINGBM_INFO *bminfo = &(s->bm);
  CTRLinfo *c = s->c;
  BM_AREA *b;
  EM_AREA *e;

  //  dbp("SING_EM_BM_transfer\n");
  areaid = bmid1;
  bmstart = 0;
  emstart = 0;
  ndata = 1;
  mode = 1;//Seqencial write
  bbid = -1; //16BB

  if (areaid < 0 || areaid >= bminfo->bm_narea) {
    fprintf(stderr, "SING_EM_BM_trasfer: BM ID %d is unrecognizable\n", areaid);
    return 16;
  }
  b = &((bminfo->bm_areas)[areaid]);
  if (bmstart < 0 || bmstart >= b->size) {
    fprintf(stderr, "SING_EM_BM_transfer: bmstart %d is not the right index\n", bmstart);
    return 2;
  }

  emid = b->emid;
  e = &((eminfo->em_areas)[emid]);
  if (emstart < 0 || emstart >= e->size) {
    fprintf(stderr, "SING_EM_BM_transfer: emstart %d is not the right index\n", emstart);
    return 1;
  }
  nword = e->nword;
  if (ndata < 0 || bmstart + ndata > b->size || emstart + ndata > e->size) {
    fprintf(stderr, "SING_EM_BM_transfer: ndata %d is inappropriate\n", ndata);
    return 4;
  }

  //  dbp("SING_EM_BM_transfer: %d active bb\n", SING_number_of_active_bb());
  
  len = ndata * nword;
  /* error check; len must be 1 - 256 */
  if (0 == mode) {
    if (bbid >= 0) {
      eit_register_mode = 0; nbm = bbid; 
    } else {
      eit_register_mode = 1; nbm = 0; /* don't care about the value of nbm */
    }
  } else if (1 == mode) {
    eit_register_mode = 2; nbm = SING_number_of_active_bb();
  } else {
    fprintf(stderr, "SING_EM_BM_transfer: undefined mode %d\n", mode);
    return 8;
  }

  CTRL_eit_register(c, bmid1, /* idpid: for now, fixed to 0 */
		    e->addr + emstart * nword, /* emsadr */
                    0, /* emiadr0 */
                    nword, /* emiadr1 */
                    2*(b->addr + bmstart * nword), /* bmsadr */
                    nbm,
                    len, /* len */
                    eit_register_mode, /* mode */
                    0); /* no start , only setup registers */
  
  return 0;
}

int matmul_move_elt_data1MC(SINGinfo *s, int index)
{
  SING_EM_BM_transferMC(s, bmid1,index,0,1,0,-1);
}


static int emid2;
static int bmid2;

static int id_loadelt2, id_loadelt2_init, id_loadelt2_nbb, id_loadelt2_nbb_512;


int matmul_setup_elt_data2MC(SINGinfo *s)
{
    int err;
    int conversions[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

    emid2=SING_EM_allocMC(s, 32, conversions, 4096, &err);
    if (emid2 < 0){
        fprintf(stderr,"register jp, EMalloc err = %d\n",err);
        exit(1);
    }
    bmid2=SING_BM_allocMC(s, emid2,8,&err);
    if (bmid2 < 0){
    fprintf(stderr,"register jp, BMalloc err = %d\n",err);
          exit(1);
    }
}

int matmul_send_elt_data2MC(SINGinfo *s, struct matmul_elt_struct1 *ip, int index_in_EM)
{
    int ret;
    ret = SING_EM_sendMC(s, emid2,index_in_EM,1,ip);
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(1);
    }
}

int matmul_send_elt_data2MC_m(SINGinfo *s, struct matmul_elt_struct1 *ip, int index_in_EM, int count)
{
    int ret;
    ret = SING_EM_sendMC(s, emid2,index_in_EM,count,ip);
    if (ret){
        fprintf(stderr,"SING_EM_send returns: %d\n", ret);
         exit(1);
    }
}

static void wait_dmas_to_become_safe();

int CTRL_write_nhib(CTRLinfo *c[NCHIP], int nc, int module,
		    UINT64 addr, const void *data[NCHIP], int len) 
{
    UINT64 *p[NCHIP];
    UINT64 header, start, swap, trans, b, e;
    int devid[NCHIP];
    int i, j, k, size, iblk;
    Hib *hib[NCHIP];
    int s, t;
    int jstart;

    for(i=0;i<nc;i++){
	devid[i] = c[i]->hib_id;
	hib[i] = c[i]->h;
	p[i] = (UINT64*)data[i];
    }
    //s = (hib[0]->piowbuf_bytes>>3)-1;
    s = 64; //16; //32;//16;   // 16LW send
    t = 192; //256;  // 192LW swap
  
    if(c[0]->bcastflag){
	header = ((UINT64)len << 40) | ((UINT64)1 << 39) | ((UINT64)module<<36) | addr;
    } else {
	header = ((UINT64)len << 40) | ((UINT64)module << 36) | addr; //For new hic header KK
    }
    size = len+1;
  
    swap = trans = 0;
    b = rdtsc2();
    jstart = 1;
    
    for (k=0;k<4;k++)hib[k]->piow_dblbuf[0] = header;
    for(iblk =0;iblk < size; iblk +=t){
	int  ibsend;
	ibsend = t;
	start = rdtsc2();
	//	wait_dmas_to_become_safe();
	// activating wait_dmas here seems to cause
	// hardware tranferr error either in X58 or X200 or P6T6 motherboard?
	// JM 2010/1/3
	
	if (iblk+ibsend > size) ibsend = size - iblk;
	for(i=0;i<ibsend;i+= s){
	    int isend = s;
	    if (isend + i > ibsend) isend = ibsend - i;
	    for (k=0;k<4;k++){
		for (j = jstart; j < isend; j++){
		  /*
		    __builtin_ia32_movntq(&(hib[k]->piow_dblbuf[i+j]),
					  p[k][iblk+i+j-1]);
		  */
		  
		  hib[k]->piow_dblbuf[i+j] = p[k][iblk+i+j-1];
		  
		}
	    }
	    jstart = 0; // should be 1 only for the first time
	}
	trans += rdtsc2() - start;
	start = rdtsc2();
	for(k=0;k<4;k++){
#if 1
	    hib_mem_writeMC(devid[k], hib[k]->dma0misc,
			    (1<<(hib[k]->dma0misc_swap_sram_bit)) |
			    (ibsend<<(hib[k]->dma0misc_sram_wcnt_bit)));
#endif
	}
	swap += rdtsc2() - start;
	//printf("swapped1 : %d word \n", t);
    }
    e = rdtsc2();
#ifdef BENCHBACKSEND
    printf("trans %lld [clk],  swap %lld [clk],  all %lld[clk] = %e [s]\n", trans, swap, e-b, (double)(e-b)/2.67e9);
#endif
}


UINT64 SING_EM_send_nhib(SINGinfo *s[NCHIP],
			 int nc,
			 int emid,
			 int index,
			 int ndata,
			 double *a[NCHIP],
			 int setup,
			 int waitmode)
{
    EM_AREA *e = &((s[0]->em).em_areas[emid]);
    CTRLinfo *c[NCHIP];
    int i;
    const int MODULE_HET = 0;
    UINT64 start, end;
    
    for(i=0;i<nc;i++){
	c[i] = s[i]->c;
	if(setup==1){
	    //	    fprintf(stderr,"before setup\n");
	    //	    hib_dump_sreg(s[i]->c->hib_id);
	    CTRL_het_convaddr(s[i]->c, e->convaddr);
	    CTRL_het_length(s[i]->c, e->convlength);
	    //	    fprintf(stderr,"after setup\n");
	    //	    hib_dump_sreg(s[i]->c->hib_id);

	}
    }
    //    wait_dmas_to_become_safe(); 
    start = rdtsc2();
    int em_addr = e->addr + (index * e->nword);
    //	fprintf(stderr,"SING_EM_send_nhib, index=%d, emid=%d,length=%d\n", index,emid,e->convlength);
    
    SING_DMAR_wait(nc, s);
    //	    fprintf(stderr,"calling CTRL_write_multichip_usingdmar_simple_da\n");
    CTRL_write_multichip_usingdmar_simple_da(nc, c, MODULE_HET, 
					     em_addr + (0x1ULL << 35), (void*)a,
					     e->convlength * ndata);
    //    for(i=0;i<nc;i++){
    //	fprintf(stderr,"after DMAR start\n");
    //	hib_dump_sreg(s[i]->c->hib_id);
    //    }
    //	    fprintf(stderr,"end CTRL_write_multichip_usingdmar_simple_da\n");
    if (waitmode)SING_DMAR_wait(nc, s);
    //	    fprintf(stderr,"end SING_DMAR_wait\n");
    //fprintf(stderr," ndata for dma = %d\n", e->convlength * ndata);
    
    end = rdtsc2();
    //    wait_dmas_to_become_safe();
    return end-start;
}

UINT64 SING_EM_send_nhib_usingdmar_start(SINGinfo *s[NCHIP],
					int nc,
					int emid,
					int index,
					int ndata,
					double *a[NCHIP],
					int setup)
{
    EM_AREA *e = &((s[0]->em).em_areas[emid]);
    CTRLinfo *c[NCHIP];
    int i;
    const int MODULE_HET = 0;
    UINT64 start, end;
    
    for(i=0;i<nc;i++){
	c[i] = s[i]->c;
	if(setup==1){
	    CTRL_het_convaddr(s[i]->c, e->convaddr);
	    CTRL_het_length(s[i]->c, e->convlength);
	}
    }
    {
	int em_addr = e->addr + (index * e->nword);
	int em_offset = 0x1000;
	
	//CTRL_write_nhib(c, nc, MODULE_HET, em_addr + (0x1ULL << 35), a,
	//		e->convlength * ndata);
	//fprintf(stderr," ndata for dma = %d\n", e->convlength * ndata);
	CTRL_write_multichip_usingdmar_dataarray_start(nc, c, MODULE_HET,
						       em_addr + (0x1ULL << 35),
						       (void*)a,
						       e->convlength * ndata);
	
    }
    return 0;
}



#if 1
inline UINT64 backgroundsend128_nchip(SINGinfo *s[NCHIP], int nc,
				      double *a[NCHIP], int index,
				      int nsend, int setup)
{

    return SING_EM_send_nhib(s, nc, emid2, index*nsend, nsend, a, setup,1);
    //1block = 32LW
}
#endif



#define STATUS_EIT_DONE             (1 << 3)

inline UINT32
hib_mem_readMC_i(Hib *h, UINT32 addr)
{
    UINT32 ret;

    ret =  h->local_reg[addr>>2];
    return (ret);
}

inline int CTRL_eit_busy_i(CTRLinfo *c) 
{ 
  int f = hib_mem_readMC_i(c->h, c->h->boardinfo) & STATUS_EIT_DONE;
  if(f!=0){
    return 0;
  } else {
    return 1;
  }
}




/* Chunk size=1024 Version*/
int matmul_move_elt_data2_m1024(SINGinfo *s, int index, int emindex, int nloop)
{
  //SING_EM_BM_transferMC(s, bmid2,index,0,1,1,-1);
  UINT64 start, end, setup;
  SINGISP_INFO *info = &(s->isp);
  SINGEM_INFO *em = &(s->em);
  EM_AREA *e = &(em->em_areas)[emid2];
  int j, l;
  static int count=0;

  start = rdtsc2();
  SING_EM_fifoclrMC(s);
  if(emindex==0){
    for(j=0;j<4;j++){
      CTRL_eit_register(s->c, bmid2+j, /* idpid */
			e->addr + (j+4*emindex)*64*16, /* emsadr */
			3072, /* emiadr0 */
			64, /* emiadr1 */
			j*128, /* bmsadr */
			16,
			64, /* len */
			2, /* mode */
			0); /* start */
    }
  }
  setup = rdtsc2();
  //SING_send_instlist(s->c, &(info->instlists)[id_loadelt2], 1, 1);
  SING_execute_i(&(s->isp), s->c, -1, id_loadelt2, -1, 1, NULL, NULL);
  
  l=0;
  while(CTRL_coc_busy(s->c)){l++;}

  end = rdtsc2();
  //printf("matmul_move_elt_data2 : %lld [clk], setup : %lld[clk] loop : %d \n", end-start, setup-start, l);

  SING_EM_fifoclrMC(s);
  return end-start;
}

/* Chunk size=1024 Version*/
int matmul_move_elt_data2_m1024_npe(SINGinfo *s, int index, int emindex, int nloop)
{
    //SING_EM_BM_transferMC(s, bmid2,index,0,1,1,-1);
    UINT64 start, end, setup;
    SINGISP_INFO *info = &(s->isp);
    SINGEM_INFO *em = &(s->em);
    EM_AREA *e = &(em->em_areas)[emid2];
    int j, l;
    static int count=0;

    start = rdtsc2();
    SING_EM_fifoclrMC(s);
    if(emindex==0){
	for(j=0;j<4;j++){
	    CTRL_eit_register(s->c, bmid2+j, /* idpid */
			      e->addr + (j+4*emindex)*64*16, /* emsadr */
			      3072, /* emiadr0 */
			      64, /* emiadr1 */
			      j*128, /* bmsadr */
			      16,
			      64, /* len */
			      2, /* mode */
			      0); /* start */
	}
    }
    //    fprintf(stderr,"matmul_move_elt_data2_m1024_npe end eit register\n");
    setup = rdtsc2();
    //SING_send_instlist(s->c, &(info->instlists)[id_loadelt2], 1, 1);
#ifndef MATMULELT2ASYNC
    SING_execute_i(&(s->isp), s->c, id_loadelt2_init, id_loadelt2, -1, nloop, NULL, NULL);
#else
    SING_send_instlist(s->c, &(info->instlists)[id_loadelt2_init], 1, 1);
    SING_send_instlist(s->c, &(info->instlists)[id_loadelt2], nloop, 1);
    //    fprintf(stderr,"matmul_move_elt_data2_m1024_npe end loadelt2\n");
#endif
    l=0;
  
#ifndef MATMULELT2ASYNC
    while(CTRL_coc_busy(s->c)){l++;}
    SING_EM_fifoclrMC(s);
#endif
    end = rdtsc2();
#ifdef BENCHSENDI
    //printf("matmul_move_elt_data2 : %lld [clk], setup : %lld[clk] loop : %d \n", end-start, setup-start, l);
#endif

    return end-start;
}

#if 1
/* Chunk size=1024 32PE loop K=1024  Version*/
int matmul_move_elt_data2_m1024_npe_nbb(SINGinfo *s, int index, int emindex, int nloop)
{
    //SING_EM_BM_transferMC(s, bmid2,index,0,1,1,-1);
    UINT64 start, end, setup;
    SINGISP_INFO *info = &(s->isp);
    SINGEM_INFO *em = &(s->em);
    EM_AREA *e = &(em->em_areas)[emid2];
    int j, l;
    static int count=0;


    start = rdtsc2();
    SING_EM_fifoclrMC(s);
    if(emindex==0){
	for(j=0;j<8;j++){
	    CTRL_eit_register(s->c, bmid2+j, /* idpid */
			      e->addr + (j+4*emindex)*256, /* emsadr */
			      1792, /* emiadr0 */
			      256, /* emiadr1 */
			      0, /* bmsadr */
			      j,
			      256, /* len */
			      0, /* mode */
			      0); /* start */
	}
    }
    setup = rdtsc2();
    //SING_send_instlist(s->c, &(info->instlists)[id_loadelt2], 1, 1);
#ifndef MATMULELT2ASYNC
    SING_execute_i(&(s->isp), s->c, id_loadelt2_init, id_loadelt2_nbb_512, -1, nloop, NULL, NULL);
    //SING_send_instlist(s->c, &(info->instlists)[id_trans], 1, 1);
#else
    SING_send_instlist(s->c, &(info->instlists)[id_loadelt2_init], 1, 0);
    SING_send_instlist(s->c, &(info->instlists)[id_loadelt2_nbb], nloop, 1);
#endif
    l=0;
  
#ifndef MATMULELT2ASYNC
    while(CTRL_coc_busy(s->c)){l++;}
    SING_EM_fifoclrMC(s);
#endif
    end = rdtsc2();
#ifdef BENCHSENDI
    //printf("matmul_move_elt_data2 : %lld [clk], setup : %lld[clk] loop : %d \n", end-start, setup-start, l);
#endif

    return end-start;
}

/* Chunk size=1024 32PE loop K=512  Version*/
int matmul_move_elt_data2_m1024_npe_nbb_k512(SINGinfo *s, int index, int emindex, int nloop)
{
  //SING_EM_BM_transferMC(s, bmid2,index,0,1,1,-1);
  UINT64 start, end, setup;
  SINGISP_INFO *info = &(s->isp);
  SINGEM_INFO *em = &(s->em);
  EM_AREA *e = &(em->em_areas)[emid2];
  int j, l;
  static int count=0;

  start = rdtsc2();
  SING_EM_fifoclrMC(s);
  if(emindex==0){
    for(j=0;j<4;j++){
      CTRL_eit_register(s->c, bmid2+j, /* idpid */
			e->addr + (j+4*emindex)*256, /* emsadr */
			768, /* emiadr0 */
			256, /* emiadr1 */
			0, /* bmsadr */
			j,
			256, /* len */
			0, /* mode */
			0); /* start */
    }
  }
  setup = rdtsc2();
  //SING_send_instlist(s->c, &(info->instlists)[id_loadelt2], 1, 1);
#ifndef MATMULELT2ASYNC
  SING_execute_i(&(s->isp), s->c, id_loadelt2_init, id_loadelt2_nbb_512, -1, nloop, NULL, NULL);
  //SING_send_instlist(s->c, &(info->instlists)[id_trans], 1, 1);
#else
  SING_send_instlist(s->c, &(info->instlists)[id_loadelt2_init], 1, 0);
  SING_send_instlist(s->c, &(info->instlists)[id_loadelt2_nbb_512], nloop, 1);
#endif
  l=0;
  
#ifndef MATMULELT2ASYNC
  while(CTRL_coc_busy(s->c)){l++;}
  SING_EM_fifoclrMC(s);
#endif
  end = rdtsc2();
#ifdef BENCHSENDI
  //printf("matmul_move_elt_data2 : %lld [clk], setup : %lld[clk] loop : %d \n", end-start, setup-start, l);
#endif

  return end-start;
}

#endif

void matmul_move_elt_data2_m1024_npe_finish(SINGinfo *s)
{
#ifdef MATMULELT2ASYNC
    //  while(CTRL_coc_busy(s->c)){}
  matmul_coc_busywait(s->c);
  SING_EM_fifoclrMC(s);
#endif  
}


void send_i_elt2_16bbMC(SINGinfo *s, int pe)
{
  CTRLinfo *c = s->c;
  UINT64 convdata[256]; 
  UINT64 convpeid[4] = {4<<4|4, 4<<4|4, 4<<4|4, 4<<4|4}; //fix64to72rs
  UINT64 peid[4];
  double x[4], *p;
  int i, instid;
  UINT64 start, trans, isp;

  for(i=0;i<4;i++){
    peid[i] = pe;
  }
  
  start = rdtsc2();
  //CTRL_hit_reset_count(c);
  CTRL_hit_convtable(c, 0, convpeid, 4);
  CTRL_hit_header(c, 4, 512, 0, 0, 0);// broadcast peid to 16BB
  CTRL_hit_length(c, 4);
  CTRL_hit_data(c, peid, 4);
  
  trans = rdtsc2();
  SING_execute_i(&(s->isp), c, -1, idtrans, -1, 1, NULL, NULL);
  isp = rdtsc2();
  //printf("Host->BM : %lld, ISP : %lld [clk] \n", trans-start, isp-trans);
}

/* ONLY IPE -> $lb512v verison */
void setsend_i_elt2_16bbMC(SINGinfo *s, int pe)
{
  CTRLinfo *c = s->c;
  UINT64 convdata[256]; 
  UINT64 convpeid[4] = {4<<4|4, 4<<4|4, 4<<4|4, 4<<4|4}; //fix64to72rs
  UINT64 peid[4];
  double x[4], *p;
  int i, instid;
  UINT64 start, trans, isp;

  for(i=0;i<4;i++){
    peid[i] = pe;
  }
  
  start = rdtsc2();
  //CTRL_hit_reset_count(c);
  CTRL_hit_convtable(c, 0, convpeid, 4);
  CTRL_hit_header(c, 4, 512, 0, 0, 0);// broadcast peid to 16BB
  CTRL_hit_length(c, 4);
  CTRL_hit_data(c, peid, 4);
}

/* ONLY NBB -> $lb520v verison */
void setsend_i_elt2_BBid_MC(SINGinfo *s, int bb)
{
  CTRLinfo *c = s->c;
  UINT64 convpeid[4] = {4<<4|4, 4<<4|4, 4<<4|4, 4<<4|4}; //fix64to72rs
  UINT64 bbid[4];
  int i;

  for(i=0;i<4;i++){
    bbid[i] = bb;
  }
  
  //CTRL_hit_reset_count(c);
  CTRL_hit_convtable(c, 0, convpeid, 4);
  CTRL_hit_header(c, 4, 520, 0, 0, 0);// broadcast peid to 16BB
  CTRL_hit_length(c, 4);
  CTRL_hit_data(c, bbid, 4);
}

static matmul_copy_vr_to_r(struct matmul_loopout_vectorstruct *vp,
                              struct matmul_loopout_struct *p,
                         int k)
{
   p->x0=vp->x0[k];
   p->x1=vp->x1[k];

}
static char* codes_1[]={
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 1   # idp 0",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 1 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # idp 1",
"ISP 4 0 0 0 0 0 0 1 2  0 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 1 rdp 0 # bm b00 $lr0v ",
"ISP 4 0 0 0 0 0 0 1 2  8 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   8  0 1 # bm b01 $lr8v",
"ISP 4 0 0 0 1 0 0 0 0  0 0 0  0 0 1  0 0 0 0 0   0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 1 1 0 0 1 0 0  0 0 0 0   0  0 0 # dmul0 $lr0 $lm0v $t   ; ",
"ISP 4 0 0 0 1 1 1 0 0  0 0 0  0 0 1  0 0 0 0 0   0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 1 1 0 0 1 6 2  a 1 0 0   0  0 0 # dmul1 $lr0 $lm0v    ; upassa $fb $ti $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  0 0 1  0 0 0 0 0 100 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 0 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr0 $lm256v  ; faddAB $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1  0 0 0 0 0 100 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 1 1 0 0 1 6 2  a 1 0 0   0  0 0 # dmul1 $lr0 $lm256v  ; upassa $fb $t $t",
"ISP 4 0 0 0 1 1 0 1 1 38 1 1  2 0 1  0 0 0 0 0   8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 0 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr2 $lm8v $t   ; faddAB $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 30 1 1 0 0   8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm8v    ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  2 0 1  0 0 0 0 0 108 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr2 $lm264v  ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 38 1 1 0 0 108 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm264v  ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  4 0 1  0 0 0 0 0  10 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr4 $lm16v    ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 30 1 1 0 0  10 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm16v    ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  4 0 1  0 0 0 0 0 110 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr4 $lm272v  ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 38 1 1 0 0 110 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm272v  ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  6 0 1  0 0 0 0 0  18 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr6 $lm24v   ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  6 0 1 30 1 1 0 0  18 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr6 $lm24v   ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  6 0 1  0 0 0 0 0 118 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr6 $lm280v  ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 1 2  0 1 1  6 0 1 38 1 1 0 0 118 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  10  0 1 # dmul1 $lr6 $lm280v  ; faddA $fb $lr56v $t ; bm b02 $lr0v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  8 0 1  0 0 0 0 0  20 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr8 $lm32v   ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 30 1 1 0 0  20 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm32v   ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  8 0 1  0 0 0 0 0 120 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr8 $lm288v  ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 38 1 1 0 0 120 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm288v  ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  a 0 1  0 0 0 0 0  28 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr10 $lm40v   ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 30 1 1 0 0  28 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm40v   ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  a 0 1  0 0 0 0 0 128 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr10 $lm296v  ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 38 1 1 0 0 128 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm296v  ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  c 0 1  0 0 0 0 0  30 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr12 $lm48v   ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 30 1 1 0 0  30 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm48v   ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  c 0 1  0 0 0 0 0 130 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr12 $lm304v  ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 38 1 1 0 0 130 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm304v  ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  e 0 1  0 0 0 0 0  38 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr14 $lm56v   ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  e 0 1 30 1 1 0 0  38 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr14 $lm56v   ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  e 0 1  0 0 0 0 0 138 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr14 $lm312v  ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 1 2  8 1 1  e 0 1 38 1 1 0 0 138 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  18  0 1 # dmul1 $lr14 $lm312v  ; faddA $fb $lr56v $t ; bm b03 $lr8v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  0 0 1  0 0 0 0 0  40 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr0 $lm64v   ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 30 1 1 0 0  40 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm64v   ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  0 0 1  0 0 0 0 0 140 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr0 $lm320v  ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 38 1 1 0 0 140 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm320v  ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  2 0 1  0 0 0 0 0  48 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr2 $lm72v   ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 30 1 1 0 0  48 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm72v   ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  2 0 1  0 0 0 0 0 148 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr2 $lm328v  ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 38 1 1 0 0 148 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm328v  ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  4 0 1  0 0 0 0 0  50 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr4 $lm80v  ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 30 1 1 0 0  50 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm80v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  4 0 1  0 0 0 0 0 150 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr4 $lm336v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 38 1 1 0 0 150 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm336v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  6 0 1  0 0 0 0 0  58 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr6 $lm88v  ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  6 0 1 30 1 1 0 0  58 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr6 $lm88v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  6 0 1  0 0 0 0 0 158 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr6 $lm344v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 1 2  0 1 1  6 0 1 38 1 1 0 0 158 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  20  0 1 # dmul1 $lr6 $lm344v ; faddA $fb $lr56v $t ; bm b04 $lr0v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  8 0 1  0 0 0 0 0  60 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr8 $lm96v  ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 30 1 1 0 0  60 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm96v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  8 0 1  0 0 0 0 0 160 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr8 $lm352v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 38 1 1 0 0 160 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm352v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  a 0 1  0 0 0 0 0  68 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr10 $lm104v  ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 30 1 1 0 0  68 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm104v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  a 0 1  0 0 0 0 0 168 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr10 $lm360v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 38 1 1 0 0 168 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm360v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  c 0 1  0 0 0 0 0  70 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr12 $lm112v  ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 30 1 1 0 0  70 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm112v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  c 0 1  0 0 0 0 0 170 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr12 $lm368v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 38 1 1 0 0 170 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm368v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  e 0 1  0 0 0 0 0  78 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr14 $lm120v  ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  e 0 1 30 1 1 0 0  78 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr14 $lm120v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  e 0 1  0 0 0 0 0 178 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr14 $lm376v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 1 2  8 1 1  e 0 1 38 1 1 0 0 178 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  28  0 1 # dmul1 $lr14 $lm376v ; faddA $fb $lr56v $t ; bm b05 $lr8v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  0 0 1  0 0 0 0 0  80 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr0 $lm128v  ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 30 1 1 0 0  80 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm128v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  0 0 1  0 0 0 0 0 180 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr0 $lm384v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 38 1 1 0 0 180 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm384v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  2 0 1  0 0 0 0 0  88 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr2 $lm136v  ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 30 1 1 0 0  88 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm136v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  2 0 1  0 0 0 0 0 188 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr2 $lm392v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 38 1 1 0 0 188 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm392v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  4 0 1  0 0 0 0 0  90 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr4 $lm144v  ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 30 1 1 0 0  90 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm144v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  4 0 1  0 0 0 0 0 190 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr4 $lm400v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 38 1 1 0 0 190 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm400v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  6 0 1  0 0 0 0 0  98 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr6 $lm152v  ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  6 0 1 30 1 1 0 0  98 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr6 $lm152v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  6 0 1  0 0 0 0 0 198 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr6 $lm408v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 1 2  0 1 1  6 0 1 38 1 1 0 0 198 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  30  0 1 # dmul1 $lr6 $lm408v ; faddA $fb $lr56v $t ; bm b06 $lr0v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  8 0 1  0 0 0 0 0  a0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr8 $lm160v  ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 30 1 1 0 0  a0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm160v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  8 0 1  0 0 0 0 0 1a0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr8 $lm416v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 38 1 1 0 0 1a0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm416v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  a 0 1  0 0 0 0 0  a8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr10 $lm168v  ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 30 1 1 0 0  a8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm168v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  a 0 1  0 0 0 0 0 1a8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr10 $lm424v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 38 1 1 0 0 1a8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm424v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  c 0 1  0 0 0 0 0  b0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr12 $lm176v  ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 30 1 1 0 0  b0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm176v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  c 0 1  0 0 0 0 0 1b0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr12 $lm432v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 38 1 1 0 0 1b0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm432v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  e 0 1  0 0 0 0 0  b8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr14 $lm184v  ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  e 0 1 30 1 1 0 0  b8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr14 $lm184v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  e 0 1  0 0 0 0 0 1b8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr14 $lm440v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 1 2  8 1 1  e 0 1 38 1 1 0 0 1b8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  38  0 1 # dmul1 $lr14 $lm440v ; faddA $fb $lr56v $t ; bm b07 $lr8v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  0 0 1  0 0 0 0 0  c0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr0 $lm192v  ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 30 1 1 0 0  c0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm192v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  0 0 1  0 0 0 0 0 1c0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr0 $lm448v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 38 1 1 0 0 1c0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm448v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  2 0 1  0 0 0 0 0  c8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr2 $lm200v ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 30 1 1 0 0  c8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm200v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  2 0 1  0 0 0 0 0 1c8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr2 $lm456v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 38 1 1 0 0 1c8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm456v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  4 0 1  0 0 0 0 0  d0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr4 $lm208v ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 30 1 1 0 0  d0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm208v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  4 0 1  0 0 0 0 0 1d0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr4 $lm464v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 38 1 1 0 0 1d0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm464v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  6 0 1  0 0 0 0 0  d8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr6 $lm216v ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  6 0 1 30 1 1 0 0  d8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr6 $lm216v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  6 0 1  0 0 0 0 0 1d8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr6 $lm472v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  6 0 1 38 1 1 0 0 1d8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr6 $lm472v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  8 0 1  0 0 0 0 0  e0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr8 $lm224v ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 30 1 1 0 0  e0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm224v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  8 0 1  0 0 0 0 0 1e0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr8 $lm480v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 38 1 1 0 0 1e0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm480v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  a 0 1  0 0 0 0 0  e8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr10 $lm232v ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 30 1 1 0 0  e8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm232v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  a 0 1  0 0 0 0 0 1e8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr10 $lm488v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 38 1 1 0 0 1e8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm488v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  c 0 1  0 0 0 0 0  f0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr12 $lm240v ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 30 1 1 0 0  f0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm240v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  c 0 1  0 0 0 0 0 1f0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr12 $lm496v ; faddA $fb $ti $lr48v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 38 1 1 0 0 1f0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm496v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  e 0 1  0 0 0 0 0  f8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr14 $lm248v ; faddA $fb $ti $lr56v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  e 0 1 30 1 1 0 0  f8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr14 $lm248v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 20 1 1  e 0 1  0 0 0 0 0 1f8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # dmul0 $lr14 $lm504v ; faddA $fb $ti $lr32v",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  e 0 1 38 1 1 0 0 1f8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr14 $lm504v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 28 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 0 1 0 0 1 6 2  0 0 1 0   0  0 0 wdp # faddA $fb $ti $lr40v;",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128"
};
static char* codes_2[]={
"ISP 4 0 0 0 0 0 0 1 2  0 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  40  0 1 # bm b10 $lr0v ",
"ISP 4 0 0 0 0 0 0 1 2  8 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  48  0 1 # bm b11 $lr8v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 1 20 1 1 0 0   0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 1 1 0 0 1 0 0  0 0 0 1  80  0 1 # rrn 80 100 0 1 1 1 1 1 0 0 1 0 0 1 1 conv 0 # dmul0 $lr0 $lm0v    ;   bm $lr32v c0 0      ; rrn fadd c0 256 flt72to64",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1  0 0 0 0 0   0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 1 1 0 0 1 6 2  a 1 0 0   0  0 0 # # dmul1 $lr0 $lm0v    ; upassa $fb $t $t      ; idp 0",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  0 0 1 28 1 1 0 0 100 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 0 0 0 1 6 2  0 0 1 1  88  0 1 # rrn 80 100 0 1 1 1 1 1 0 0 1 0 0 1 1 conv 0 #  # dmul0 $lr0 $lm256v  ; faddAB $fb $ti $lr48v ; bm $lr40v c1 0  ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1  0 0 0 0 0 100 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 1 1 0 0 1 6 2  a 1 0 0   0  0 0 # dmul1 $lr0 $lm256v  ; upassa $fb $t $t      ",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  2 0 1 20 1 1 0 0   8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 0 0 0 1 6 2  0 0 1 1  90  1 1 rrn 80 100 0 1 1 1 1 1 0 0 1 0 0 1 1 conv 0 # dmul0 $lr2 $lm8v    ; faddAB $fb $ti $lr56v ; bm $lr32v c2 1 ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 30 1 1 0 0   8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm8v    ; faddA $fb $lr48v $t ",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  2 0 1 28 1 1 0 0 108 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  98  1 1 idp 0 # dmul0 $lr2 $lm264v  ; faddA $fb $ti $lr48v  ; bm $lr40v c3 1",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 38 1 1 0 0 108 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 #idp 0 # dmul1 $lr2 $lm264v  ; faddA $fb $lr56v $t ",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  4 0 1 20 1 1 0 0  10 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  a0  2 1 rdp 1 # dmul0 $lr4 $lm16v    ; faddA $fb $ti $lr56v ; bm $lr32v c4 2",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 30 1 1 0 0  10 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm16v    ; faddA $fb $lr48v $t ",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  4 0 1 28 1 1 0 0 110 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  a8  2 1 # dmul0 $lr4 $lm272v  ; faddA $fb $ti $lr48v  ; bm $lr40v c5 2  ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 38 1 1 0 0 110 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm272v  ; faddA $fb $lr56v $t  ",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  6 0 1 20 1 1 0 0  18 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  b0  3 1 # dmul0 $lr6 $lm24v   ; faddA $fb $ti $lr56v  ; bm $lr32v c6 3 ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  6 0 1 30 1 1 0 0  18 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr6 $lm24v   ; faddA $fb $lr48v $t   ",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  6 0 1 28 1 1 0 0 118 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  b8  3 1 # dmul0 $lr6 $lm280v  ; faddA $fb $ti $lr48v  ; bm $lr40v c7 3 ",
"ISP 4 0 0 0 1 0 1 1 2  0 1 1  6 0 1 38 1 1 0 0 118 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  50  0 1 # dmul1 $lr6 $lm280v  ; faddA $fb $lr56v $t   ; bm b12 $lr0v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  8 0 1 20 1 1 0 0  20 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  c0  4 1 # dmul0 $lr8 $lm32v   ; faddA $fb $ti $lr56v  ; bm $lr32v c8 4",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 30 1 1 0 0  20 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm32v   ; faddA $fb $lr48v $t  ",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  8 0 1 28 1 1 0 0 120 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  c8  4 1 # dmul0 $lr8 $lm288v  ; faddA $fb $ti $lr48v  ; bm $lr40v c9 4  ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 38 1 1 0 0 120 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm288v  ; faddA $fb $lr56v $t  ",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  a 0 1 20 1 1 0 0  28 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  d0  5 1 # dmul0 $lr10 $lm40v   ; faddA $fb $ti $lr56v ; bm $lr32v c10 5",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 30 1 1 0 0  28 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm40v   ; faddA $fb $lr48v $t ",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  a 0 1 28 1 1 0 0 128 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  d8  5 1 # dmul0 $lr10 $lm296v  ; faddA $fb $ti $lr48v ; bm $lr40v c11 5  ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 38 1 1 0 0 128 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm296v  ; faddA $fb $lr56v $t ",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  c 0 1 20 1 1 0 0  30 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  e0  6 1 # dmul0 $lr12 $lm48v   ; faddA $fb $ti $lr56v ; bm $lr32v c12 6",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 30 1 1 0 0  30 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm48v   ; faddA $fb $lr48v $t ",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  c 0 1 28 1 1 0 0 130 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  e8  6 1 # dmul0 $lr12 $lm304v  ; faddA $fb $ti $lr48v ; bm $lr40v c13 6",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 38 1 1 0 0 130 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm304v  ; faddA $fb $lr56v $t ",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  e 0 1 20 1 1 0 0  38 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  f0  7 1 # dmul0 $lr14 $lm56v   ; faddA $fb $ti $lr56v ; bm $lr32v c14 7",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  e 0 1 30 1 1 0 0  38 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr14 $lm56v   ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  e 0 1 28 1 1 0 0 138 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  f8  7 1 # dmul0 $lr14 $lm312v  ; faddA $fb $ti $lr48v ; bm $lr40v c15 7",
"ISP 4 0 0 0 1 0 1 1 2  8 1 1  e 0 1 38 1 1 0 0 138 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  58  0 1 # dmul1 $lr14 $lm312v  ; faddA $fb $lr56v $t  ; bm b13 $lr8v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  0 0 1 20 1 1 0 0  40 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 100  8 1 # dmul0 $lr0 $lm64v   ; faddA $fb $ti $lr56v  ; bm $lr32v c16 8 ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 30 1 1 0 0  40 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm64v   ; faddA $fb $lr48v $t  ",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  0 0 1 28 1 1 0 0 140 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 108  8 1 # dmul0 $lr0 $lm320v  ; faddA $fb $ti $lr48v  ; bm $lr40v c17 8",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 38 1 1 0 0 140 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm320v  ; faddA $fb $lr56v $t  ",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  2 0 1 20 1 1 0 0  48 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 110  9 1 # dmul0 $lr2 $lm72v   ; faddA $fb $ti $lr56v  ; bm $lr32v c18 9",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 30 1 1 0 0  48 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm72v   ; faddA $fb $lr48v $t  ",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  2 0 1 28 1 1 0 0 148 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 118  9 1 # dmul0 $lr2 $lm328v  ; faddA $fb $ti $lr48v  ; bm $lr40v c19 9",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 38 1 1 0 0 148 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm328v  ; faddA $fb $lr56v $t  ",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  4 0 1 20 1 1 0 0  50 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 120  a 1 # dmul0 $lr4 $lm80v  ; faddA $fb $ti $lr56v   ; bm $lr32v c20 10",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 30 1 1 0 0  50 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm80v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  4 0 1 28 1 1 0 0 150 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 128  a 1 # dmul0 $lr4 $lm336v ; faddA $fb $ti $lr48v   ; bm $lr40v c21 10  ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 38 1 1 0 0 150 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm336v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  6 0 1 20 1 1 0 0  58 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 130  b 1 # dmul0 $lr6 $lm88v  ; faddA $fb $ti $lr56v   ; bm $lr32v c22 11",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  6 0 1 30 1 1 0 0  58 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr6 $lm88v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  6 0 1 28 1 1 0 0 158 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 138  b 1 # dmul0 $lr6 $lm344v ; faddA $fb $ti $lr48v   ; bm $lr40v c23 11  ",
"ISP 4 0 0 0 1 0 1 1 2  0 1 1  6 0 1 38 1 1 0 0 158 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  60  0 1 # dmul1 $lr6 $lm344v ; faddA $fb $lr56v $t    ; bm b14 $lr0v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  8 0 1 20 1 1 0 0  60 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 140  c 1 # dmul0 $lr8 $lm96v  ; faddA $fb $ti $lr56v   ; bm $lr32v c24 12 ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 30 1 1 0 0  60 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm96v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  8 0 1 28 1 1 0 0 160 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 148  c 1 # dmul0 $lr8 $lm352v ; faddA $fb $ti $lr48v   ; bm $lr40v c25 12   ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 38 1 1 0 0 160 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm352v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  a 0 1 20 1 1 0 0  68 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 150  d 1 # dmul0 $lr10 $lm104v  ; faddA $fb $ti $lr56v ; bm $lr32v c26 13",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 30 1 1 0 0  68 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm104v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  a 0 1 28 1 1 0 0 168 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 158  d 1 # dmul0 $lr10 $lm360v ; faddA $fb $ti $lr48v  ; bm $lr40v c27 13",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 38 1 1 0 0 168 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm360v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  c 0 1 20 1 1 0 0  70 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 160  e 1 # dmul0 $lr12 $lm112v  ; faddA $fb $ti $lr56v ; bm $lr32v c28 14",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 30 1 1 0 0  70 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm112v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  c 0 1 28 1 1 0 0 170 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 168  e 1 # dmul0 $lr12 $lm368v ; faddA $fb $ti $lr48v  ; bm $lr40v c29 14",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 38 1 1 0 0 170 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm368v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  e 0 1 20 1 1 0 0  78 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 170  f 1 # dmul0 $lr14 $lm120v  ; faddA $fb $ti $lr56v ; bm $lr32v c30 15",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  e 0 1 30 1 1 0 0  78 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr14 $lm120v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  e 0 1 28 1 1 0 0 178 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 178  f 1 # dmul0 $lr14 $lm376v ; faddA $fb $ti $lr48v  ; bm $lr40v c31 15",
"ISP 4 0 0 0 1 0 1 1 2  8 1 1  e 0 1 38 1 1 0 0 178 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  68  0 1 # dmul1 $lr14 $lm376v ; faddA $fb $lr56v $t   ; bm b15 $lr8v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  0 0 1 20 1 1 0 0  80 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 180 10 1 # dmul0 $lr0 $lm128v  ; faddA $fb $ti $lr56v  ; bm $lr32v c32 16",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 30 1 1 0 0  80 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm128v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  0 0 1 28 1 1 0 0 180 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 188 10 1 # dmul0 $lr0 $lm384v ; faddA $fb $ti $lr48v   ; bm $lr40v c33 16",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 38 1 1 0 0 180 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm384v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  2 0 1 20 1 1 0 0  88 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 190 11 1 # dmul0 $lr2 $lm136v  ; faddA $fb $ti $lr56v  ; bm $lr32v c34 17",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 30 1 1 0 0  88 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm136v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  2 0 1 28 1 1 0 0 188 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 198 11 1 # dmul0 $lr2 $lm392v ; faddA $fb $ti $lr48v   ; bm $lr40v c35 17",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 38 1 1 0 0 188 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm392v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  4 0 1 20 1 1 0 0  90 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1a0 12 1 # dmul0 $lr4 $lm144v  ; faddA $fb $ti $lr56v  ; bm $lr32v c36 18",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 30 1 1 0 0  90 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm144v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  4 0 1 28 1 1 0 0 190 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1a8 12 1 # dmul0 $lr4 $lm400v ; faddA $fb $ti $lr48v   ; bm $lr40v c37 18",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 38 1 1 0 0 190 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm400v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  6 0 1 20 1 1 0 0  98 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1b0 13 1 # dmul0 $lr6 $lm152v  ; faddA $fb $ti $lr56v  ; bm $lr32v c38 19",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  6 0 1 30 1 1 0 0  98 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr6 $lm152v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  6 0 1 28 1 1 0 0 198 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1b8 13 1 # dmul0 $lr6 $lm408v ; faddA $fb $ti $lr48v   ; bm $lr40v c39 19",
"ISP 4 0 0 0 1 0 1 1 2  0 1 1  6 0 1 38 1 1 0 0 198 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  70  0 1 # dmul1 $lr6 $lm408v ; faddA $fb $lr56v $t    ; bm b16 $lr0v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  8 0 1 20 1 1 0 0  a0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1c0 14 1 # dmul0 $lr8 $lm160v  ; faddA $fb $ti $lr56v  ; bm $lr32v c40 20",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 30 1 1 0 0  a0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm160v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  8 0 1 28 1 1 0 0 1a0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1c8 14 1 # dmul0 $lr8 $lm416v ; faddA $fb $ti $lr48v   ; bm $lr40v c41 20",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 38 1 1 0 0 1a0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm416v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  a 0 1 20 1 1 0 0  a8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1d0 15 1 # dmul0 $lr10 $lm168v  ; faddA $fb $ti $lr56v ; bm $lr32v c42 21",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 30 1 1 0 0  a8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm168v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  a 0 1 28 1 1 0 0 1a8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1d8 15 1 # dmul0 $lr10 $lm424v ; faddA $fb $ti $lr48v  ; bm $lr40v c43 21",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 38 1 1 0 0 1a8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm424v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  c 0 1 20 1 1 0 0  b0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1e0 16 1 # dmul0 $lr12 $lm176v  ; faddA $fb $ti $lr56v ; bm $lr32v c44 22",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 30 1 1 0 0  b0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm176v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  c 0 1 28 1 1 0 0 1b0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1e8 16 1 # dmul0 $lr12 $lm432v ; faddA $fb $ti $lr48v  ; bm $lr40v c45 22",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 38 1 1 0 0 1b0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm432v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  e 0 1 20 1 1 0 0  b8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1f0 17 1 # dmul0 $lr14 $lm184v  ; faddA $fb $ti $lr56v ; bm $lr32v c46 23",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  e 0 1 30 1 1 0 0  b8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr14 $lm184v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  e 0 1 28 1 1 0 0 1b8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1f8 17 1 # dmul0 $lr14 $lm440v ; faddA $fb $ti $lr48v  ; bm $lr40v c47 23",
"ISP 4 0 0 0 1 0 1 1 2  8 1 1  e 0 1 38 1 1 0 0 1b8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  78  0 1 # dmul1 $lr14 $lm440v ; faddA $fb $lr56v $t   ; bm b17 $lr8v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  0 0 1 20 1 1 0 0  c0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 200 18 1 # dmul0 $lr0 $lm192v  ; faddA $fb $ti $lr56v  ; bm $lr32v c48 24",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 30 1 1 0 0  c0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm192v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  0 0 1 28 1 1 0 0 1c0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 208 18 1 # dmul0 $lr0 $lm448v ; faddA $fb $ti $lr48v   ; bm $lr40v c49 24",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 38 1 1 0 0 1c0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm448v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  2 0 1 20 1 1 0 0  c8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 210 19 1 # dmul0 $lr2 $lm200v ; faddA $fb $ti $lr56v   ; bm $lr32v c50 25",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 30 1 1 0 0  c8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm200v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  2 0 1 28 1 1 0 0 1c8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 218 19 1 # dmul0 $lr2 $lm456v ; faddA $fb $ti $lr48v   ; bm $lr40v c51 25",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 38 1 1 0 0 1c8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm456v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  4 0 1 20 1 1 0 0  d0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 220 1a 1 # dmul0 $lr4 $lm208v ; faddA $fb $ti $lr56v   ; bm $lr32v c52 26",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 30 1 1 0 0  d0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm208v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  4 0 1 28 1 1 0 0 1d0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 228 1a 1 # dmul0 $lr4 $lm464v ; faddA $fb $ti $lr48v   ; bm $lr40v c53 26",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 38 1 1 0 0 1d0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm464v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  6 0 1 20 1 1 0 0  d8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 230 1b 1 # dmul0 $lr6 $lm216v ; faddA $fb $ti $lr56v   ; bm $lr32v c54 27",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  6 0 1 30 1 1 0 0  d8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr6 $lm216v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  6 0 1 28 1 1 0 0 1d8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 238 1b 1 # dmul0 $lr6 $lm472v ; faddA $fb $ti $lr48v   ; bm $lr40v c55 27",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  6 0 1 38 1 1 0 0 1d8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr6 $lm472v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  8 0 1 20 1 1 0 0  e0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 240 1c 1 # dmul0 $lr8 $lm224v ; faddA $fb $ti $lr56v   ; bm $lr32v c56 28",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 30 1 1 0 0  e0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm224v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  8 0 1 28 1 1 0 0 1e0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 248 1c 1 # dmul0 $lr8 $lm480v ; faddA $fb $ti $lr48v   ; bm $lr40v c57 28",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 38 1 1 0 0 1e0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm480v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  a 0 1 20 1 1 0 0  e8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 250 1d 1 # dmul0 $lr10 $lm232v ; faddA $fb $ti $lr56v  ; bm $lr32v c58 29",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 30 1 1 0 0  e8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm232v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  a 0 1 28 1 1 0 0 1e8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 258 1d 1 # dmul0 $lr10 $lm488v ; faddA $fb $ti $lr48v  ; bm $lr40v c59 29",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 38 1 1 0 0 1e8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm488v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  c 0 1 20 1 1 0 0  f0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 260 1e 1 # dmul0 $lr12 $lm240v ; faddA $fb $ti $lr56v  ; bm $lr32v c60 30",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 30 1 1 0 0  f0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm240v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  c 0 1 28 1 1 0 0 1f0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 268 1e 1 # dmul0 $lr12 $lm496v ; faddA $fb $ti $lr48v  ; bm $lr40v c61 30",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 38 1 1 0 0 1f0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm496v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  e 0 1 20 1 1 0 0  f8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 270 1f 1 # dmul0 $lr14 $lm248v ; faddA $fb $ti $lr56v  ; bm $lr32v c62 31",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  e 0 1 30 1 1 0 0  f8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr14 $lm248v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 20 1 1  e 0 1 28 1 1 0 0 1f8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 278 1f 1 # wdp # dmul0 $lr14 $lm504v ; faddA $fb $ti $lr32v  ; bm $lr40v c63 31",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  e 0 1 38 1 1 0 0 1f8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr14 $lm504v ; faddA $fb $lr56v $t ",
"ISP 4 0 0 0 0 1 0 1 1 28 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # faddA $fb $ti $lr40v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # wdp # nop",
"ISP 4 0 0 0 0 0 0 1 2  0 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 1 # bm b00 $lr0v ; ",
"ISP 4 0 0 0 0 0 0 1 2  8 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   8  0 1 # bm b01 $lr8v",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 1 20 1 1 0 0   0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 1 1 0 0 1 0 0  0 0 0 1  80  0 1 # dmul0 $lr0 $lm0v    ;   bm $lr32v c0 0      ; rrn fadd c0 256 flt72to64",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1  0 0 0 0 0   0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 1 1 0 0 1 6 2  a 1 0 0   0  0 0 # dmul1 $lr0 $lm0v    ; upassa $fb $t $t      ; idp 1",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  0 0 1 28 1 1 0 0 100 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 0 0 0 1 6 2  0 0 1 1  88  0 1 # dmul0 $lr0 $lm256v  ; faddAB $fb $ti $lr48v ; bm $lr40v c1 0  ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1  0 0 0 0 0 100 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 1 1 0 0 1 6 2  a 1 0 0   0  0 0 rrn 80 100 0 1 1 1 1 1 0 0 1 0 0 1 1 conv 0 # dmul1 $lr0 $lm256v  ; upassa $fb $t $t      ",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  2 0 1 20 1 1 0 0   8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 0 0 0 1 6 2  0 0 1 1  90  1 1 # dmul0 $lr2 $lm8v    ; faddAB $fb $ti $lr56v ; bm $lr32v c2 1 ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 30 1 1 0 0   8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm8v    ; faddA $fb $lr48v $t ",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  2 0 1 28 1 1 0 0 108 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  98  1 1 idp 1 # dmul0 $lr2 $lm264v  ; faddA $fb $ti $lr48v  ; bm $lr40v c3 1",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 38 1 1 0 0 108 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 rdp 0 # dmul1 $lr2 $lm264v  ; faddA $fb $lr56v $t ",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  4 0 1 20 1 1 0 0  10 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  a0  2 1 # dmul0 $lr4 $lm16v    ; faddA $fb $ti $lr56v ; bm $lr32v c4 2",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 30 1 1 0 0  10 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm16v    ; faddA $fb $lr48v $t ",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  4 0 1 28 1 1 0 0 110 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  a8  2 1 # dmul0 $lr4 $lm272v  ; faddA $fb $ti $lr48v  ; bm $lr40v c5 2  ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 38 1 1 0 0 110 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm272v  ; faddA $fb $lr56v $t  ",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  6 0 1 20 1 1 0 0  18 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  b0  3 1 # dmul0 $lr6 $lm24v   ; faddA $fb $ti $lr56v  ; bm $lr32v c6 3 ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  6 0 1 30 1 1 0 0  18 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr6 $lm24v   ; faddA $fb $lr48v $t   ",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  6 0 1 28 1 1 0 0 118 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  b8  3 1 # dmul0 $lr6 $lm280v  ; faddA $fb $ti $lr48v  ; bm $lr40v c7 3 ",
"ISP 4 0 0 0 1 0 1 1 2  0 1 1  6 0 1 38 1 1 0 0 118 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  10  0 1 # dmul1 $lr6 $lm280v  ; faddA $fb $lr56v $t   ; bm b02 $lr0v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  8 0 1 20 1 1 0 0  20 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  c0  4 1 # dmul0 $lr8 $lm32v   ; faddA $fb $ti $lr56v  ; bm $lr32v c8 4",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 30 1 1 0 0  20 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm32v   ; faddA $fb $lr48v $t  ",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  8 0 1 28 1 1 0 0 120 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  c8  4 1 # dmul0 $lr8 $lm288v  ; faddA $fb $ti $lr48v  ; bm $lr40v c9 4  ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 38 1 1 0 0 120 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm288v  ; faddA $fb $lr56v $t  ",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  a 0 1 20 1 1 0 0  28 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  d0  5 1 # dmul0 $lr10 $lm40v   ; faddA $fb $ti $lr56v ; bm $lr32v c10 5",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 30 1 1 0 0  28 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm40v   ; faddA $fb $lr48v $t ",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  a 0 1 28 1 1 0 0 128 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  d8  5 1 # dmul0 $lr10 $lm296v  ; faddA $fb $ti $lr48v ; bm $lr40v c11 5  ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 38 1 1 0 0 128 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm296v  ; faddA $fb $lr56v $t ",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  c 0 1 20 1 1 0 0  30 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  e0  6 1 # dmul0 $lr12 $lm48v   ; faddA $fb $ti $lr56v ; bm $lr32v c12 6",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 30 1 1 0 0  30 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm48v   ; faddA $fb $lr48v $t ",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  c 0 1 28 1 1 0 0 130 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  e8  6 1 # dmul0 $lr12 $lm304v  ; faddA $fb $ti $lr48v ; bm $lr40v c13 6",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 38 1 1 0 0 130 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm304v  ; faddA $fb $lr56v $t ",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  e 0 1 20 1 1 0 0  38 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  f0  7 1 # dmul0 $lr14 $lm56v   ; faddA $fb $ti $lr56v ; bm $lr32v c14 7",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  e 0 1 30 1 1 0 0  38 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr14 $lm56v   ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  e 0 1 28 1 1 0 0 138 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1  f8  7 1 # dmul0 $lr14 $lm312v  ; faddA $fb $ti $lr48v ; bm $lr40v c15 7",
"ISP 4 0 0 0 1 0 1 1 2  8 1 1  e 0 1 38 1 1 0 0 138 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  18  0 1 # dmul1 $lr14 $lm312v  ; faddA $fb $lr56v $t  ; bm b03 $lr8v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  0 0 1 20 1 1 0 0  40 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 100  8 1 # dmul0 $lr0 $lm64v   ; faddA $fb $ti $lr56v  ; bm $lr32v c16 8 ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 30 1 1 0 0  40 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm64v   ; faddA $fb $lr48v $t  ",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  0 0 1 28 1 1 0 0 140 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 108  8 1 # dmul0 $lr0 $lm320v  ; faddA $fb $ti $lr48v  ; bm $lr40v c17 8",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 38 1 1 0 0 140 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm320v  ; faddA $fb $lr56v $t  ",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  2 0 1 20 1 1 0 0  48 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 110  9 1 # dmul0 $lr2 $lm72v   ; faddA $fb $ti $lr56v  ; bm $lr32v c18 9",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 30 1 1 0 0  48 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm72v   ; faddA $fb $lr48v $t  ",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  2 0 1 28 1 1 0 0 148 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 118  9 1 # dmul0 $lr2 $lm328v  ; faddA $fb $ti $lr48v  ; bm $lr40v c19 9",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 38 1 1 0 0 148 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm328v  ; faddA $fb $lr56v $t  ",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  4 0 1 20 1 1 0 0  50 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 120  a 1 # dmul0 $lr4 $lm80v  ; faddA $fb $ti $lr56v   ; bm $lr32v c20 10",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 30 1 1 0 0  50 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm80v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  4 0 1 28 1 1 0 0 150 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 128  a 1 # dmul0 $lr4 $lm336v ; faddA $fb $ti $lr48v   ; bm $lr40v c21 10  ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 38 1 1 0 0 150 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm336v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  6 0 1 20 1 1 0 0  58 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 130  b 1 # dmul0 $lr6 $lm88v  ; faddA $fb $ti $lr56v   ; bm $lr32v c22 11",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  6 0 1 30 1 1 0 0  58 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr6 $lm88v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  6 0 1 28 1 1 0 0 158 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 138  b 1 # dmul0 $lr6 $lm344v ; faddA $fb $ti $lr48v   ; bm $lr40v c23 11  ",
"ISP 4 0 0 0 1 0 1 1 2  0 1 1  6 0 1 38 1 1 0 0 158 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  20  0 1 # dmul1 $lr6 $lm344v ; faddA $fb $lr56v $t    ; bm b04 $lr0v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  8 0 1 20 1 1 0 0  60 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 140  c 1 # dmul0 $lr8 $lm96v  ; faddA $fb $ti $lr56v   ; bm $lr32v c24 12 ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 30 1 1 0 0  60 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm96v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  8 0 1 28 1 1 0 0 160 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 148  c 1 # dmul0 $lr8 $lm352v ; faddA $fb $ti $lr48v   ; bm $lr40v c25 12   ",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 38 1 1 0 0 160 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm352v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  a 0 1 20 1 1 0 0  68 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 150  d 1 # dmul0 $lr10 $lm104v  ; faddA $fb $ti $lr56v ; bm $lr32v c26 13",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 30 1 1 0 0  68 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm104v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  a 0 1 28 1 1 0 0 168 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 158  d 1 # dmul0 $lr10 $lm360v ; faddA $fb $ti $lr48v  ; bm $lr40v c27 13",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 38 1 1 0 0 168 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm360v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  c 0 1 20 1 1 0 0  70 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 160  e 1 # dmul0 $lr12 $lm112v  ; faddA $fb $ti $lr56v ; bm $lr32v c28 14",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 30 1 1 0 0  70 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm112v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  c 0 1 28 1 1 0 0 170 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 168  e 1 # dmul0 $lr12 $lm368v ; faddA $fb $ti $lr48v  ; bm $lr40v c29 14",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 38 1 1 0 0 170 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm368v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  e 0 1 20 1 1 0 0  78 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 170  f 1 # dmul0 $lr14 $lm120v  ; faddA $fb $ti $lr56v ; bm $lr32v c30 15",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  e 0 1 30 1 1 0 0  78 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr14 $lm120v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  e 0 1 28 1 1 0 0 178 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 178  f 1 # dmul0 $lr14 $lm376v ; faddA $fb $ti $lr48v  ; bm $lr40v c31 15",
"ISP 4 0 0 0 1 0 1 1 2  8 1 1  e 0 1 38 1 1 0 0 178 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  28  0 1 # dmul1 $lr14 $lm376v ; faddA $fb $lr56v $t   ; bm b05 $lr8v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  0 0 1 20 1 1 0 0  80 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 180 10 1 # dmul0 $lr0 $lm128v  ; faddA $fb $ti $lr56v  ; bm $lr32v c32 16",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 30 1 1 0 0  80 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm128v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  0 0 1 28 1 1 0 0 180 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 188 10 1 # dmul0 $lr0 $lm384v ; faddA $fb $ti $lr48v   ; bm $lr40v c33 16",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 38 1 1 0 0 180 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm384v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  2 0 1 20 1 1 0 0  88 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 190 11 1 # dmul0 $lr2 $lm136v  ; faddA $fb $ti $lr56v  ; bm $lr32v c34 17",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 30 1 1 0 0  88 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm136v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  2 0 1 28 1 1 0 0 188 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 198 11 1 # dmul0 $lr2 $lm392v ; faddA $fb $ti $lr48v   ; bm $lr40v c35 17",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 38 1 1 0 0 188 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm392v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  4 0 1 20 1 1 0 0  90 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1a0 12 1 # dmul0 $lr4 $lm144v  ; faddA $fb $ti $lr56v  ; bm $lr32v c36 18",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 30 1 1 0 0  90 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm144v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  4 0 1 28 1 1 0 0 190 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1a8 12 1 # dmul0 $lr4 $lm400v ; faddA $fb $ti $lr48v   ; bm $lr40v c37 18",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 38 1 1 0 0 190 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm400v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  6 0 1 20 1 1 0 0  98 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1b0 13 1 # dmul0 $lr6 $lm152v  ; faddA $fb $ti $lr56v  ; bm $lr32v c38 19",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  6 0 1 30 1 1 0 0  98 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr6 $lm152v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  6 0 1 28 1 1 0 0 198 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1b8 13 1 # dmul0 $lr6 $lm408v ; faddA $fb $ti $lr48v   ; bm $lr40v c39 19",
"ISP 4 0 0 0 1 0 1 1 2  0 1 1  6 0 1 38 1 1 0 0 198 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  30  0 1 # dmul1 $lr6 $lm408v ; faddA $fb $lr56v $t    ; bm b06 $lr0v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  8 0 1 20 1 1 0 0  a0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1c0 14 1 # dmul0 $lr8 $lm160v  ; faddA $fb $ti $lr56v  ; bm $lr32v c40 20",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 30 1 1 0 0  a0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm160v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  8 0 1 28 1 1 0 0 1a0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1c8 14 1 # dmul0 $lr8 $lm416v ; faddA $fb $ti $lr48v   ; bm $lr40v c41 20",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 38 1 1 0 0 1a0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm416v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  a 0 1 20 1 1 0 0  a8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1d0 15 1 # dmul0 $lr10 $lm168v  ; faddA $fb $ti $lr56v ; bm $lr32v c42 21",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 30 1 1 0 0  a8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm168v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  a 0 1 28 1 1 0 0 1a8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1d8 15 1 # dmul0 $lr10 $lm424v ; faddA $fb $ti $lr48v  ; bm $lr40v c43 21",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 38 1 1 0 0 1a8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm424v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  c 0 1 20 1 1 0 0  b0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1e0 16 1 # dmul0 $lr12 $lm176v  ; faddA $fb $ti $lr56v ; bm $lr32v c44 22",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 30 1 1 0 0  b0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm176v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  c 0 1 28 1 1 0 0 1b0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1e8 16 1 # dmul0 $lr12 $lm432v ; faddA $fb $ti $lr48v  ; bm $lr40v c45 22",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 38 1 1 0 0 1b0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm432v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  e 0 1 20 1 1 0 0  b8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1f0 17 1 # dmul0 $lr14 $lm184v  ; faddA $fb $ti $lr56v ; bm $lr32v c46 23",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  e 0 1 30 1 1 0 0  b8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr14 $lm184v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  e 0 1 28 1 1 0 0 1b8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 1f8 17 1 # dmul0 $lr14 $lm440v ; faddA $fb $ti $lr48v  ; bm $lr40v c47 23",
"ISP 4 0 0 0 1 0 1 1 2  8 1 1  e 0 1 38 1 1 0 0 1b8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0  38  0 1 # dmul1 $lr14 $lm440v ; faddA $fb $lr56v $t   ; bm b07 $lr8v",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  0 0 1 20 1 1 0 0  c0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 200 18 1 # dmul0 $lr0 $lm192v  ; faddA $fb $ti $lr56v  ; bm $lr32v c48 24",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 30 1 1 0 0  c0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm192v  ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  0 0 1 28 1 1 0 0 1c0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 208 18 1 # dmul0 $lr0 $lm448v ; faddA $fb $ti $lr48v   ; bm $lr40v c49 24",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  0 0 1 38 1 1 0 0 1c0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr0 $lm448v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  2 0 1 20 1 1 0 0  c8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 210 19 1 # dmul0 $lr2 $lm200v ; faddA $fb $ti $lr56v   ; bm $lr32v c50 25",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 30 1 1 0 0  c8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm200v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  2 0 1 28 1 1 0 0 1c8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 218 19 1 # dmul0 $lr2 $lm456v ; faddA $fb $ti $lr48v   ; bm $lr40v c51 25",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  2 0 1 38 1 1 0 0 1c8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr2 $lm456v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  4 0 1 20 1 1 0 0  d0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 220 1a 1 # dmul0 $lr4 $lm208v ; faddA $fb $ti $lr56v   ; bm $lr32v c52 26",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 30 1 1 0 0  d0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm208v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  4 0 1 28 1 1 0 0 1d0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 228 1a 1 # dmul0 $lr4 $lm464v ; faddA $fb $ti $lr48v   ; bm $lr40v c53 26",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  4 0 1 38 1 1 0 0 1d0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr4 $lm464v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  6 0 1 20 1 1 0 0  d8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 230 1b 1 # dmul0 $lr6 $lm216v ; faddA $fb $ti $lr56v   ; bm $lr32v c54 27",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  6 0 1 30 1 1 0 0  d8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr6 $lm216v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  6 0 1 28 1 1 0 0 1d8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 238 1b 1 # dmul0 $lr6 $lm472v ; faddA $fb $ti $lr48v   ; bm $lr40v c55 27",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  6 0 1 38 1 1 0 0 1d8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr6 $lm472v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  8 0 1 20 1 1 0 0  e0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 240 1c 1 # dmul0 $lr8 $lm224v ; faddA $fb $ti $lr56v   ; bm $lr32v c56 28",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 30 1 1 0 0  e0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm224v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  8 0 1 28 1 1 0 0 1e0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 248 1c 1 # dmul0 $lr8 $lm480v ; faddA $fb $ti $lr48v   ; bm $lr40v c57 28",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  8 0 1 38 1 1 0 0 1e0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr8 $lm480v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  a 0 1 20 1 1 0 0  e8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 250 1d 1 # dmul0 $lr10 $lm232v ; faddA $fb $ti $lr56v  ; bm $lr32v c58 29",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 30 1 1 0 0  e8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm232v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  a 0 1 28 1 1 0 0 1e8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 258 1d 1 # dmul0 $lr10 $lm488v ; faddA $fb $ti $lr48v  ; bm $lr40v c59 29",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  a 0 1 38 1 1 0 0 1e8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr10 $lm488v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  c 0 1 20 1 1 0 0  f0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 260 1e 1 # dmul0 $lr12 $lm240v ; faddA $fb $ti $lr56v  ; bm $lr32v c60 30",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 30 1 1 0 0  f0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm240v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 30 1 1  c 0 1 28 1 1 0 0 1f0 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 268 1e 1 # dmul0 $lr12 $lm496v ; faddA $fb $ti $lr48v  ; bm $lr40v c61 30",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  c 0 1 38 1 1 0 0 1f0 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr12 $lm496v ; faddA $fb $lr56v $t",
"ISP 4 0 0 0 0 1 0 1 1 38 1 1  e 0 1 20 1 1 0 0  f8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 270 1f 1 # dmul0 $lr14 $lm248v ; faddA $fb $ti $lr56v  ; bm $lr32v c62 31",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  e 0 1 30 1 1 0 0  f8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr14 $lm248v ; faddA $fb $lr48v $t",
"ISP 4 0 0 0 0 1 0 1 1 20 1 1  e 0 1 28 1 1 0 0 1f8 1 0 1 0 1 0 1 0 0 0 1 0 0 0 3 0 1 0 0 1 6 2  0 0 1 1 278 1f 1 # dmul0 $lr14 $lm504v ; faddA $fb $ti $lr32v  ; bm $lr40v c63 31",
"ISP 4 0 0 0 1 0 1 0 0  0 0 0  e 0 1 38 1 1 0 0 1f8 1 0 1 0 1 0 1 1 0 1 0 0 0 0 3 0 1 0 0 1 6 1  0 0 1 0   0  0 0 # dmul1 $lr14 $lm504v ; faddA $fb $lr56v $t ",
"ISP 4 0 0 0 0 1 0 1 1 28 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 0 1 0 0 1 6 2  0 0 1 0   0  0 0 # wdp # faddA $fb $ti $lr40v                       ",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # wdp # nop",
"ISP 0 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop"
};

//Chunksize=1024LW Version
static char *codes_loadelt2_init[]={
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 2 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop"
};


static char *codes_loadelt2_loop_original[]={
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 2 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 3 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 3 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 4 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 4 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 5 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 5 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 2 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
 "ISP 4 0 0 0 1 0 2 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 200  0 1 # bm $lb512v $t", 
 "ISP 4 0 1 0 0 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 4 2  7 1 0 0   0  0 0 # uxor $peid $ti ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2   0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 1 # bm $lb0v $lm0v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2   8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   8  0 1 # bm $lb8v $lm8v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  10 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  10  0 1 # bm $lb16v $lm16v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  18 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  18  0 1 # bm $lb24v $lm24v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  20 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  20  0 1 # bm $lb32v $lm32v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  28 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  28  0 1 # bm $lb40v $lm40v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  30 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  30  0 1 # bm $lb48v $lm48v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  38 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  38  0 1 # bm $lb56v $lm56v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  40 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  40  0 1 # bm $lb64v $lm64v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  48 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  48  0 1 # bm $lb72v $lm72v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  50 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  50  0 1 # bm $lb80v $lm80v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  58 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  58  0 1 # bm $lb88v $lm88v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  60 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  60  0 1 # bm $lb96v $lm96v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  68 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  68  0 1 # bm $lb104v $lm104v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  70 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  70  0 1 # bm $lb112v $lm112v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  78 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  78  0 1 # bm $lb120v $lm120v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  80 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  80  0 1 # bm $lb128v $lm128v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  88 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  88  0 1 # bm $lb136v $lm136v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  90 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  90  0 1 # bm $lb144v $lm144v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  98 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  98  0 1 # bm $lb152v $lm152v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  a0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  a0  0 1 # bm $lb160v $lm160v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  a8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  a8  0 1 # bm $lb168v $lm168v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  b0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  b0  0 1 # bm $lb176v $lm176v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  b8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  b8  0 1 # bm $lb184v $lm184v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  c0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  c0  0 1 # bm $lb192v $lm192v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  c8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  c8  0 1 # bm $lb200v $lm200v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  d0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  d0  0 1 # bm $lb208v $lm208v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  d8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  d8  0 1 # bm $lb216v $lm216v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  e0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  e0  0 1 # bm $lb224v $lm224v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  e8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  e8  0 1 # bm $lb232v $lm232v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  f0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  f0  0 1 # bm $lb240v $lm240v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  f8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  f8  0 1 # bm $lb248v $lm248v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 100 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 100  0 1 # bm $lb256v $lm256v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 108 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 108  0 1 # bm $lb264v $lm264v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 110 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 110  0 1 # bm $lb272v $lm272v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 118 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 118  0 1 # bm $lb280v $lm280v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 120 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 120  0 1 # bm $lb288v $lm288v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 128 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 128  0 1 # bm $lb296v $lm296v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 130 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 130  0 1 # bm $lb304v $lm304v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 138 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 138  0 1 # bm $lb312v $lm312v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 140 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 140  0 1 # bm $lb320v $lm320v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 148 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 148  0 1 # bm $lb328v $lm328v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 150 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 150  0 1 # bm $lb336v $lm336v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 158 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 158  0 1 # bm $lb344v $lm344v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 160 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 160  0 1 # bm $lb352v $lm352v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 168 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 168  0 1 # bm $lb360v $lm360v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 170 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 170  0 1 # bm $lb368v $lm368v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 178 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 178  0 1 # bm $lb376v $lm376v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 180 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 180  0 1 # bm $lb384v $lm384v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 188 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 188  0 1 # bm $lb392v $lm392v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 190 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 190  0 1 # bm $lb400v $lm400v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 198 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 198  0 1 # bm $lb408v $lm408v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1a0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1a0  0 1 # bm $lb416v $lm416v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1a8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1a8  0 1 # bm $lb424v $lm424v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1b0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1b0  0 1 # bm $lb432v $lm432v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1b8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1b8  0 1 # bm $lb440v $lm440v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1c0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1c0  0 1 # bm $lb448v $lm448v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1c8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1c8  0 1 # bm $lb456v $lm456v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1d0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1d0  0 1 # bm $lb464v $lm464v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1d8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1d8  0 1 # bm $lb472v $lm472v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1e0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1e0  0 1 # bm $lb480v $lm480v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1e8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1e8  0 1 # bm $lb488v $lm488v ",
"ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1f0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1f0  0 1 # bm $lb496v $lm496v ",
"ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1f8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1f8  0 1 # bm $lb504v $lm504v ",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  2 1 0 0   0  0 0 # uinc $t $t $lr0v", 
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 200  0 1 # bm $lr0v $lb512v 0"
};


static char *codes_loadelt2_loop[]={
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 2 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 3 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 3 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 4 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 4 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 5 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 5 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 2 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
 "ISP 4 0 0 0 1 0 2 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 200  0 1 # bm $lb512v $t", 
 "ISP 4 0 1 0 0 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 4 2  7 1 0 0   0  0 0 # uxor $peid $ti ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2   0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 1 # bm $lb0v $lm0v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 100 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   8  0 1 # bm $lb8v $lm8v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2   8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  10  0 1 # bm $lb16v $lm16v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 108 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  18  0 1 # bm $lb24v $lm24v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  10 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  20  0 1 # bm $lb32v $lm32v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 110 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  28  0 1 # bm $lb40v $lm40v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  18 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  30  0 1 # bm $lb48v $lm48v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 118 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  38  0 1 # bm $lb56v $lm56v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  20 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  40  0 1 # bm $lb64v $lm64v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 120 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  48  0 1 # bm $lb72v $lm72v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  28 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  50  0 1 # bm $lb80v $lm80v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 128 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  58  0 1 # bm $lb88v $lm88v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  30 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  60  0 1 # bm $lb96v $lm96v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 130 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  68  0 1 # bm $lb104v $lm104v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  38 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  70  0 1 # bm $lb112v $lm112v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 138 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  78  0 1 # bm $lb120v $lm120v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  40 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  80  0 1 # bm $lb128v $lm128v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 140 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  88  0 1 # bm $lb136v $lm136v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  48 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  90  0 1 # bm $lb144v $lm144v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 148 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  98  0 1 # bm $lb152v $lm152v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  50 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  a0  0 1 # bm $lb160v $lm160v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 150 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  a8  0 1 # bm $lb168v $lm168v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  58 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  b0  0 1 # bm $lb176v $lm176v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 158 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  b8  0 1 # bm $lb184v $lm184v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  60 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  c0  0 1 # bm $lb192v $lm192v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 160 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  c8  0 1 # bm $lb200v $lm200v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  68 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  d0  0 1 # bm $lb208v $lm208v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 168 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  d8  0 1 # bm $lb216v $lm216v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  70 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  e0  0 1 # bm $lb224v $lm224v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 170 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  e8  0 1 # bm $lb232v $lm232v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  78 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  f0  0 1 # bm $lb240v $lm240v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 178 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  f8  0 1 # bm $lb248v $lm248v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  80 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 100  0 1 # bm $lb256v $lm256v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 180 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 108  0 1 # bm $lb264v $lm264v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  88 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 110  0 1 # bm $lb272v $lm272v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 188 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 118  0 1 # bm $lb280v $lm280v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  90 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 120  0 1 # bm $lb288v $lm288v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 190 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 128  0 1 # bm $lb296v $lm296v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  98 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 130  0 1 # bm $lb304v $lm304v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 198 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 138  0 1 # bm $lb312v $lm312v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  a0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 140  0 1 # bm $lb320v $lm320v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1a0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 148  0 1 # bm $lb328v $lm328v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  a8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 150  0 1 # bm $lb336v $lm336v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1a8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 158  0 1 # bm $lb344v $lm344v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  b0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 160  0 1 # bm $lb352v $lm352v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1b0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 168  0 1 # bm $lb360v $lm360v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  b8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 170  0 1 # bm $lb368v $lm368v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1b8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 178  0 1 # bm $lb376v $lm376v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  c0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 180  0 1 # bm $lb384v $lm384v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1c0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 188  0 1 # bm $lb392v $lm392v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  c8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 190  0 1 # bm $lb400v $lm400v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1c8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 198  0 1 # bm $lb408v $lm408v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  d0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1a0  0 1 # bm $lb416v $lm416v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1d0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1a8  0 1 # bm $lb424v $lm424v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  d8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1b0  0 1 # bm $lb432v $lm432v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1d8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1b8  0 1 # bm $lb440v $lm440v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  e0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1c0  0 1 # bm $lb448v $lm448v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1e0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1c8  0 1 # bm $lb456v $lm456v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  e8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1d0  0 1 # bm $lb464v $lm464v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1e8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1d8  0 1 # bm $lb472v $lm472v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  f0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1e0  0 1 # bm $lb480v $lm480v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1f0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1e8  0 1 # bm $lb488v $lm488v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  f8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1f0  0 1 # bm $lb496v $lm496v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1f8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1f8  0 1 # bm $lb504v $lm504v ",
"ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  2 1 0 0   0  0 0 # uinc $t $t $lr0v", 
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 200  0 1 # bm $lr0v $lb512v 0"
};



static char *codes_trans[]={
 "ISP 4 0 0 0 1 0 2 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 200  0 1 # bm $lb512v $t", 
 "ISP 4 4 1 0 0 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 4 2  7 1 0 0   0  0 0 # uxor $peid $ti ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2   0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 1 # bm $lb0v $lm0v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2   8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   8  0 1 # bm $lb8v $lm8v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  10 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  10  0 1 # bm $lb16v $lm16v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  18 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  18  0 1 # bm $lb24v $lm24v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  20 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  20  0 1 # bm $lb32v $lm32v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  28 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  28  0 1 # bm $lb40v $lm40v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  30 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  30  0 1 # bm $lb48v $lm48v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  38 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  38  0 1 # bm $lb56v $lm56v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  40 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  40  0 1 # bm $lb64v $lm64v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  48 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  48  0 1 # bm $lb72v $lm72v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  50 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  50  0 1 # bm $lb80v $lm80v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  58 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  58  0 1 # bm $lb88v $lm88v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  60 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  60  0 1 # bm $lb96v $lm96v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  68 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  68  0 1 # bm $lb104v $lm104v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  70 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  70  0 1 # bm $lb112v $lm112v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  78 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  78  0 1 # bm $lb120v $lm120v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  80 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  80  0 1 # bm $lb128v $lm128v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  88 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  88  0 1 # bm $lb136v $lm136v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  90 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  90  0 1 # bm $lb144v $lm144v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  98 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  98  0 1 # bm $lb152v $lm152v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  a0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  a0  0 1 # bm $lb160v $lm160v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  a8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  a8  0 1 # bm $lb168v $lm168v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  b0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  b0  0 1 # bm $lb176v $lm176v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  b8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  b8  0 1 # bm $lb184v $lm184v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  c0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  c0  0 1 # bm $lb192v $lm192v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  c8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  c8  0 1 # bm $lb200v $lm200v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  d0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  d0  0 1 # bm $lb208v $lm208v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  d8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  d8  0 1 # bm $lb216v $lm216v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  e0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  e0  0 1 # bm $lb224v $lm224v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  e8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  e8  0 1 # bm $lb232v $lm232v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  f0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  f0  0 1 # bm $lb240v $lm240v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  f8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  f8  0 1 # bm $lb248v $lm248v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 100 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 100  0 1 # bm $lb256v $lm256v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 108 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 108  0 1 # bm $lb264v $lm264v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 110 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 110  0 1 # bm $lb272v $lm272v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 118 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 118  0 1 # bm $lb280v $lm280v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 120 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 120  0 1 # bm $lb288v $lm288v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 128 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 128  0 1 # bm $lb296v $lm296v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 130 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 130  0 1 # bm $lb304v $lm304v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 138 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 138  0 1 # bm $lb312v $lm312v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 140 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 140  0 1 # bm $lb320v $lm320v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 148 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 148  0 1 # bm $lb328v $lm328v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 150 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 150  0 1 # bm $lb336v $lm336v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 158 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 158  0 1 # bm $lb344v $lm344v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 160 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 160  0 1 # bm $lb352v $lm352v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 168 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 168  0 1 # bm $lb360v $lm360v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 170 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 170  0 1 # bm $lb368v $lm368v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 178 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 178  0 1 # bm $lb376v $lm376v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 180 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 180  0 1 # bm $lb384v $lm384v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 188 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 188  0 1 # bm $lb392v $lm392v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 190 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 190  0 1 # bm $lb400v $lm400v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 198 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 198  0 1 # bm $lb408v $lm408v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1a0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1a0  0 1 # bm $lb416v $lm416v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1a8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1a8  0 1 # bm $lb424v $lm424v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1b0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1b0  0 1 # bm $lb432v $lm432v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1b8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1b8  0 1 # bm $lb440v $lm440v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1c0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1c0  0 1 # bm $lb448v $lm448v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1c8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1c8  0 1 # bm $lb456v $lm456v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1d0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1d0  0 1 # bm $lb464v $lm464v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1d8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1d8  0 1 # bm $lb472v $lm472v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1e0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1e0  0 1 # bm $lb480v $lm480v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1e8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1e8  0 1 # bm $lb488v $lm488v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1f0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1f0  0 1 # bm $lb496v $lm496v ",
 "ISP 4 1 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1f8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1f8  0 1 # bm $lb504v $lm504v "};

static char *codes_set_mask2[]={
    "ISP 4 0 0 0 1 0 2 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 200  0 1 # bm $lb512v $t", 
    "ISP 4 0 4 0 0 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 5 2  7 1 0 0   0  0 0 # uxor $bbid $ti ",
    "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
    "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128"
};
static char *codes_reset_mask2[]={
    "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
    "ISP 4 0 4 0 0 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  7 1 0 0   0  0 0 # uxor reg0 reg0 ",
    "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
    "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128"
};
//static char *codes_reset_mask2[]={
//    "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
//    "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128",
//    "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop 128"};

#if 1
/* This is for K=1024 overlap */
static char *codes_loadelt2_nbb[]={
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 2 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 3 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 3 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 4 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 4 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 5 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 5 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 6 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 6 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 7 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 7 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 8 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 8 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 9 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 9 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 2 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
 "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop ",
 "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop ",
 "ISP 4 0 0 0 1 0 2 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 200  0 1 # bm $lb512v $t $lr0v ",
 "ISP 4 0 0 0 0 1 0 1 1  0 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 # upassa $ti $ti $lr0v ",
 "ISP 4 0 1 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 4 2  7 1 0 0   0  0 0 # uxor $peid $t  #pe==lb512v",
 "ISP 4 1 2 0 1 0 2 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 208  0 1 # bm $lb520v $t ",
 "ISP 4 1 2 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 5 2  1 0 0 0   0  0 0 # isub  $bbid $ti $t  ",
 "ISP 4 1 2 0 0 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2 10 1 0 0   0  0 0 # ulnot $ti $ti      # bbid < $lb512v (nested) ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2   0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 1 # bm $lb0v $lm0v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2   8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   8  0 1 # bm $lb8v $lm8v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  10 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  10  0 1 # bm $lb16v $lm16v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  18 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  18  0 1 # bm $lb24v $lm24v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  20 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  20  0 1 # bm $lb32v $lm32v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  28 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  28  0 1 # bm $lb40v $lm40v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  30 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  30  0 1 # bm $lb48v $lm48v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  38 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  38  0 1 # bm $lb56v $lm56v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  40 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  40  0 1 # bm $lb64v $lm64v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  48 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  48  0 1 # bm $lb72v $lm72v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  50 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  50  0 1 # bm $lb80v $lm80v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  58 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  58  0 1 # bm $lb88v $lm88v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  60 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  60  0 1 # bm $lb96v $lm96v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  68 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  68  0 1 # bm $lb104v $lm104v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  70 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  70  0 1 # bm $lb112v $lm112v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  78 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  78  0 1 # bm $lb120v $lm120v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  80 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  80  0 1 # bm $lb128v $lm128v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  88 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  88  0 1 # bm $lb136v $lm136v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  90 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  90  0 1 # bm $lb144v $lm144v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  98 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  98  0 1 # bm $lb152v $lm152v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  a0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  a0  0 1 # bm $lb160v $lm160v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  a8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  a8  0 1 # bm $lb168v $lm168v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  b0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  b0  0 1 # bm $lb176v $lm176v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  b8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  b8  0 1 # bm $lb184v $lm184v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  c0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  c0  0 1 # bm $lb192v $lm192v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  c8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  c8  0 1 # bm $lb200v $lm200v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  d0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  d0  0 1 # bm $lb208v $lm208v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  d8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  d8  0 1 # bm $lb216v $lm216v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  e0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  e0  0 1 # bm $lb224v $lm224v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  e8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  e8  0 1 # bm $lb232v $lm232v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  f0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  f0  0 1 # bm $lb240v $lm240v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  f8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  f8  0 1 # bm $lb248v $lm248v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 100 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 100  0 1 # bm $lb256v $lm256v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 108 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 108  0 1 # bm $lb264v $lm264v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 110 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 110  0 1 # bm $lb272v $lm272v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 118 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 118  0 1 # bm $lb280v $lm280v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 120 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 120  0 1 # bm $lb288v $lm288v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 128 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 128  0 1 # bm $lb296v $lm296v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 130 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 130  0 1 # bm $lb304v $lm304v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 138 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 138  0 1 # bm $lb312v $lm312v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 140 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 140  0 1 # bm $lb320v $lm320v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 148 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 148  0 1 # bm $lb328v $lm328v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 150 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 150  0 1 # bm $lb336v $lm336v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 158 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 158  0 1 # bm $lb344v $lm344v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 160 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 160  0 1 # bm $lb352v $lm352v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 168 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 168  0 1 # bm $lb360v $lm360v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 170 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 170  0 1 # bm $lb368v $lm368v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 178 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 178  0 1 # bm $lb376v $lm376v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 180 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 180  0 1 # bm $lb384v $lm384v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 188 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 188  0 1 # bm $lb392v $lm392v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 190 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 190  0 1 # bm $lb400v $lm400v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 198 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 198  0 1 # bm $lb408v $lm408v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1a0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1a0  0 1 # bm $lb416v $lm416v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1a8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1a8  0 1 # bm $lb424v $lm424v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1b0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1b0  0 1 # bm $lb432v $lm432v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1b8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1b8  0 1 # bm $lb440v $lm440v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1c0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1c0  0 1 # bm $lb448v $lm448v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1c8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1c8  0 1 # bm $lb456v $lm456v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1d0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1d0  0 1 # bm $lb464v $lm464v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1d8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1d8  0 1 # bm $lb472v $lm472v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1e0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1e0  0 1 # bm $lb480v $lm480v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1e8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1e8  0 1 # bm $lb488v $lm488v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1f0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1f0  0 1 # bm $lb496v $lm496v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1f8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1f8  0 1 # bm $lb504v $lm504v ",
 "ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 1 1  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  2 1 0 0   0  0 0 # uinc $lr0v $lr0v $lr0v ",
 "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop ",
 "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 200  0 1 # bm $lr0v $lb512v 0 ",
 "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop ",
};

static char *codes_loadelt2_nbb_512[]={
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 2 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 3 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 3 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 4 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 4 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 5 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 idp 5 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 rdp 2 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop",
"ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 wdp # nop",
 "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop ",
 "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop ",
 "ISP 4 0 0 0 1 0 2 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 200  0 1 # bm $lb512v $t $lr0v ",
 "ISP 4 0 0 0 0 1 0 1 1  0 1 1  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2  a 1 0 0   0  0 0 # upassa $ti $ti $lr0v ",
 "ISP 4 0 1 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 4 2  7 1 0 0   0  0 0 # uxor $peid $t  #pe==lb512v",
 "ISP 4 1 2 0 1 0 2 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 208  0 1 # bm $lb520v $t ",
 "ISP 4 1 2 0 1 1 1 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 5 2  1 0 0 0   0  0 0 # isub  $bbid $ti $t  ",
 "ISP 4 1 2 0 0 1 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 2 2 10 1 0 0   0  0 0 # ulnot $ti $ti      # bbid < $lb512v (nested) ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2   0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   0  0 1 # bm $lb0v $lm0v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2   8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0   8  0 1 # bm $lb8v $lm8v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  10 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  10  0 1 # bm $lb16v $lm16v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  18 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  18  0 1 # bm $lb24v $lm24v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  20 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  20  0 1 # bm $lb32v $lm32v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  28 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  28  0 1 # bm $lb40v $lm40v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  30 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  30  0 1 # bm $lb48v $lm48v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  38 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  38  0 1 # bm $lb56v $lm56v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  40 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  40  0 1 # bm $lb64v $lm64v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  48 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  48  0 1 # bm $lb72v $lm72v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  50 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  50  0 1 # bm $lb80v $lm80v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  58 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  58  0 1 # bm $lb88v $lm88v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  60 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  60  0 1 # bm $lb96v $lm96v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  68 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  68  0 1 # bm $lb104v $lm104v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  70 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  70  0 1 # bm $lb112v $lm112v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  78 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  78  0 1 # bm $lb120v $lm120v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  80 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  80  0 1 # bm $lb128v $lm128v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  88 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  88  0 1 # bm $lb136v $lm136v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  90 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  90  0 1 # bm $lb144v $lm144v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  98 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  98  0 1 # bm $lb152v $lm152v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  a0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  a0  0 1 # bm $lb160v $lm160v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  a8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  a8  0 1 # bm $lb168v $lm168v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  b0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  b0  0 1 # bm $lb176v $lm176v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  b8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  b8  0 1 # bm $lb184v $lm184v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  c0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  c0  0 1 # bm $lb192v $lm192v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  c8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  c8  0 1 # bm $lb200v $lm200v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  d0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  d0  0 1 # bm $lb208v $lm208v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  d8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  d8  0 1 # bm $lb216v $lm216v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  e0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  e0  0 1 # bm $lb224v $lm224v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  e8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  e8  0 1 # bm $lb232v $lm232v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  f0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  f0  0 1 # bm $lb240v $lm240v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2  f8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0  f8  0 1 # bm $lb248v $lm248v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 100 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 100  0 1 # bm $lb256v $lm256v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 108 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 108  0 1 # bm $lb264v $lm264v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 110 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 110  0 1 # bm $lb272v $lm272v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 118 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 118  0 1 # bm $lb280v $lm280v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 120 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 120  0 1 # bm $lb288v $lm288v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 128 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 128  0 1 # bm $lb296v $lm296v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 130 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 130  0 1 # bm $lb304v $lm304v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 138 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 138  0 1 # bm $lb312v $lm312v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 140 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 140  0 1 # bm $lb320v $lm320v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 148 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 148  0 1 # bm $lb328v $lm328v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 150 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 150  0 1 # bm $lb336v $lm336v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 158 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 158  0 1 # bm $lb344v $lm344v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 160 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 160  0 1 # bm $lb352v $lm352v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 168 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 168  0 1 # bm $lb360v $lm360v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 170 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 170  0 1 # bm $lb368v $lm368v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 178 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 178  0 1 # bm $lb376v $lm376v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 180 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 180  0 1 # bm $lb384v $lm384v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 188 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 188  0 1 # bm $lb392v $lm392v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 190 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 190  0 1 # bm $lb400v $lm400v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 198 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 198  0 1 # bm $lb408v $lm408v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1a0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1a0  0 1 # bm $lb416v $lm416v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1a8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1a8  0 1 # bm $lb424v $lm424v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1b0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1b0  0 1 # bm $lb432v $lm432v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1b8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1b8  0 1 # bm $lb440v $lm440v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1c0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1c0  0 1 # bm $lb448v $lm448v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1c8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1c8  0 1 # bm $lb456v $lm456v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1d0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1d0  0 1 # bm $lb464v $lm464v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1d8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1d8  0 1 # bm $lb472v $lm472v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1e0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1e0  0 1 # bm $lb480v $lm480v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1e8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1e8  0 1 # bm $lb488v $lm488v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1f0 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1f0  0 1 # bm $lb496v $lm496v ",
 "ISP 4 2 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 1 2 1f8 1 0 1 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 0 1f8  0 1 # bm $lb504v $lm504v ",
 "ISP 4 0 0 0 0 0 0 1 1  0 1 1  0 1 1  0 0 0 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  2 1 0 0   0  0 0 # uinc $lr0v $lr0v $lr0v ",
 "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop ",
 "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 1 1 0 0   0 0 0 0 0 0 1 1 0 0 1 1 0 1 0 0 1 1 0 0 1 0 0  0 0 0 1 200  0 1 # bm $lr0v $lb512v 0 ",
 "ISP 4 0 0 0 0 0 0 0 0  0 0 0  0 0 0  0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0 0 0 0   0  0 0 # nop ",
};

#endif

static matmul_register_grape_codesMC(SINGinfo *s, int id[])
{
    int k;
    for (k=0;k<4;k++) id[k]=-1;
    SING_iflushMC(s);
    id[1]=SING_iregisterMC(s, sizeof(codes_1)/sizeof(char*),
			   (const char**) codes_1);
    id[2]=SING_iregisterMC(s, sizeof(codes_2)/sizeof(char*),
			   (const char**) codes_2);
    id_set_mask2=SING_iregisterMC(s, sizeof(codes_set_mask2)/sizeof(char*),
				  (const char**) codes_set_mask2);
    id_reset_mask2=SING_iregisterMC(s, sizeof(codes_reset_mask2)/sizeof(char*),
				    (const char**) codes_reset_mask2);
    idtrans=SING_iregisterMC(s, sizeof(codes_trans)/sizeof(char*),
			     (const char**) codes_trans);
    id_loadelt2 =SING_iregisterMC(s, sizeof(codes_loadelt2_loop)/sizeof(char*),
				  (const char**) codes_loadelt2_loop);
    id_loadelt2_init =SING_iregisterMC(s,
				       sizeof(codes_loadelt2_init)/sizeof(char*),
				       (const char**) codes_loadelt2_init);
    id_loadelt2_nbb  =SING_iregisterMC(s,
				       sizeof(codes_loadelt2_nbb)/sizeof(char*),
				       (const char**) codes_loadelt2_nbb);
    id_loadelt2_nbb_512  =SING_iregisterMC(s, sizeof(codes_loadelt2_nbb_512)/sizeof(char*),
					   (const char**) codes_loadelt2_nbb_512);
    //idtrans_4pe=SING_iregisterMC(s, sizeof(codes_itrans_4pe)/sizeof(char*), codes_itrans_4pe); 
}

static int ids[4];
int * matmul_codes_pointer()
{
    return ids;
}

void matmul_grape_init(SINGinfo *s)
{
  //SING_open();
  matmul_send_vsm_constants();
  matmul_setup_elt_data0MC(s);
  matmul_setup_elt_data1MC(s);
  matmul_setup_elt_data2MC(s);
  //  SING_EM_statusMC(s);

  //matmul_register_i_particle_conversion();
  matmul_register_grape_codesMC(s, ids);
  SING_set_result_sizeMC(s, sizeof(struct matmul_loopout_vectorstruct),0);

  //dqsset
  //setdqsdelay2(s->c);
  gethostname(myhostname,256);
}


int SING_print_LM(SINGinfo *s, int saddr, int length, int bbid, int peid) 
{
  /* error check e.g. bbid, peid */
  int i, id, err;
  INSTLIST *instlist;
  int nblock = (length + 7) / 8;

  id = SING_ialloc_i(&(s->isp), MAX_INST);
  instlist = &(s->isp.instlists[id]);
  for (i = 0; i < nblock; i++) {
    SING_asm_add_op(4, "upassa", "lmv", saddr + 8 * i, "t", 0, "lrv", 0, instlist);
    SING_asm_add_nop(instlist);
    SING_asm_add_bm(4, "lrv", 0, "lbv", 8 * i, peid, instlist);
  }
  SING_register_instlist(s->c, instlist);
  SING_send_instlist(s->c, instlist, 1, 0);
  SING_ipop_i(&(s->isp));

  err = SING_print_BM_i(&(s->isp), s->c, 0, length, bbid);
  return 0;
}


void matmul_set_2stage(SINGinfo *s[NCHIP], int nchip, int f)
{
  int i;
  
  if(f==1){
    for(i=0;i<nchip;i++){
      CTRL_setodpcom(s[i]->c, 0x0ffULL);
      CTRL_setodpcom(s[i]->c, 0x200ULL);
    }
  } else {
    for(i=0;i<nchip;i++){
      CTRL_setodpcom(s[i]->c, 0x0ffULL);
      CTRL_setodpcom(s[i]->c, 0x000ULL);
    }
  }
}

#define NAN_AT_EOD (0x12345678ULL)
extern volatile UINT64 *eobuf[NHIB];
extern unsigned long dmar_pa[NHIB]; /* physical addres of hib[].dmar_buf */
extern unsigned long dmaw_pa[NHIB];
extern Hib hib[NHIB];
extern int hib_fd[NHIB];

inline void _hib_mem_writeMC(int devid, UINT32 addr, UINT32 value)
{
  /*
    WARN(4, "hib[%d] hib_mem_writeMC: 0x%08x pa: %08x\n",
         devid, addr, value);
  */
    //    asm volatile("mfence":::"memory");
    hib[devid].local_reg[addr>>2] = value; // bar0, 32-bit address
    //    asm volatile("mfence":::"memory");

    //    hib[devid].backend[addr>>3] = value; // bar1, 64-bit address
    //    hib[devid].piow_dblbuf[addr>>3] = value; // bar2, 64-bit address
}
  

void _hib_start_dmawMC(int devid, int size, UINT64 *buf, int addronly) // size in 8-byte word
{
    unsigned long offset;
    static int firstcall[8] = {
        1, 1, 1, 1, 1, 1, 1, 1, 
    };

    if (size > (hib[devid].dmabuf_bytes>>3)) {
        fprintf(stderr, "hib_dmawMC(): size too large.\n");
        fprintf(stderr, "size: %d\n", size);
        exit(2);
    }

    offset = buf - hib[devid].dmaw_buf; // offset in 8-byte word.

    if (offset < 0 || hib[devid].dmabuf_bytes < offset * 8) {
	fprintf(stderr, "hib_start_dmawMC: address offset (0x%016llx) out of range.\n", offset);
	exit(2);
    }

    // set a dummy data at the end of buffer.
    buf[size - 1] = NAN_AT_EOD;
    eobuf[devid] = &(buf[size - 1]);

    if (hib[devid].type == HIB_HIBDRV) {
#if 1
        // write two 32-bit registers by a single 64-bit write access.
        // write PCI lower 32-bit address register and transfer size register at once,
        // and then kick off a DMA transfer.
        hib_mem_write64MC(devid, hib[devid].dma1lsb,
                          ((UINT64)(size*8) << 32) | (dmaw_pa[devid] + offset * 8));
        //        asm volatile("mfence":::"memory");
#else

        // hib_mem_writeMC(devid, hib[devid].dma1msb, 0x0);
        //        hib_mem_writeMC(devid, hib[devid].dma1laddr, 0x0); /* start address in local space */
        //        hib_mem_writeMC(devid, hib[devid].dma1cmd, 0); // set default param

        // lower 32-bit of start address in PCI space.
        hib_mem_writeMC(devid, hib[devid].dma1lsb, dmaw_pa[devid] + offset * 8);
        // size in byte and then start DMA.
        hib_mem_writeMC(devid, hib[devid].dma1size, size*8);
#endif
    }
    else {
#if 0
      _hib_mem_writeMC(devid, hib[devid].dma1lsb, dmaw_pa[devid] + offset * 8); /* lower 32-bit of start address in PCI space */
      _hib_mem_writeMC(devid, hib[devid].dma1msb, 0x0); /* higher 32-bit of start address in PCI space */
      _hib_mem_writeMC(devid, hib[devid].dma1size, size*8); /* size in byte */
      _hib_mem_writeMC(devid, hib[devid].dma1cmd, 1<<hib[devid].dma1cmd_kickoff_bit);
#else
      _hib_mem_writeMC(devid, hib[devid].dma1lsb, dmaw_pa[devid] + offset * 8); /* lower 32-bit of start address in PCI space */
      _hib_mem_writeMC(devid, hib[devid].dma1size, size*8); /* size in byte */
      if(addronly == 0){
	_hib_mem_writeMC(devid, hib[devid].dma1msb, 0x0); /* higher 32-bit of start address in PCI space */
      } 
      _hib_mem_writeMC(devid, hib[devid].dma1cmd, 1<<hib[devid].dma1cmd_kickoff_bit);
#endif
    }
}

/*
 * wait completion of the DMA write (host <- hib) transaction
 * kicked off by hib_start_dmawMC()
 */
int _hib_finish_dmawMC(int devid)
{
    volatile unsigned long misc;
    int ret = 0;

    /*
     * wait till the DMA transfer completes
     */
#if 0
    // wait done bit of DMA1MISC register is asserted.
    do {
        misc = hib_mem_readMC(devid, hib[devid].dma1misc);
        asm volatile("mfence":::"memory");
    } while ((misc & (1<<hib[devid].dma1misc_done_bit)) == 0); /* wait until dmadone1 is asserted */
#else
    // wait until a dummy data at the end of buffer is overwritten by a data received from hib.
    while (*eobuf[devid] == NAN_AT_EOD);
#endif

    return ret;
}



int g_nloop = NLOOP; //64; //-1 means adaptive mode 8:ok 16:ok 32:bad


int det_nloop(int n)
{
  if(g_nloop<0){
    if(n<2048){
      return 32;
    } else {
      return 64;
    }
  } else {
    return g_nloop;
  }
}


int matmul_type2_runMC_tb4_2dg(SINGinfo *s[NCHIP], int nchip, int n,
			       double *loopout, int LDC, double al, double bt)
{
    int i , j, k, l, result_size, nloop; 
    int result_packet;
    int buf_offsetw, buf_offsetr;
    int wind[NCHIP] = {0,1,3,2};
    double *p, *dmaw[NCHIP];
    UINT64 start, sing, copy;

    nloop = det_nloop(n);
    result_size = sizeof(struct matmul_loopout_vectorstruct)/sizeof(double)*nloop;
    result_packet = result_size / nchip;
    //printf("nchip : %d , resultsize : %d , alpha : %e , beta : %e \n", nchip, result_size, al, bt);
    for(i=0;i<nchip;i++){
	SING_EM_fifoclrMC(s[i]);
	matmul_move_elt_data0MC(s[i], 0);
	matmul_move_elt_data1_nosendMC(s[i], 0);
    }

    p = loopout;
    buf_offsetr = 0;
    buf_offsetw = 0;

    for(j=0;j<nchip;j++){
	dmaw[j] = (double*)(s[j]->c->h->dmaw_buf);
    }
    sing =0;
    CTRL_beginbcast(s[0]->c);
    for(j=0;j<nchip;j++){
	//_hib_start_dmawMC(s[j]->c->hib_id, result_packet, (void*)(dmaw[j]+buf_offsetw));
	_hib_start_dmawMC(s[j]->c->hib_id, result_packet, (void*)(dmaw[j]+buf_offsetw), 0);
    }
    SING_send_instlist(s[0]->c, &(s[0]->isp.instlists[ids[1]]), 1, 0);
    for(i=0;i<n;i+=nloop){ // 2column
	start = rdtsc2();
	
	SING_send_instlist(s[0]->c, &(s[0]->isp.instlists[ids[2]]), nloop, 1);
	if(i != 0){
	    if(bt==0.0){
		for(l=0;l<nloop;l++){
		    int packetsize = result_size/nchip/nloop; 
		    for(j=0;j<packetsize/2;j++){ //one loop contains 2 columns
			for(k=0;k<nchip;k++){
			    double *data = dmaw[k];
			    //printf("%e \n", data[j]);
			    p[wind[k]+nchip*j]     = al*data[j+buf_offsetr+packetsize*l];
			    p[wind[k]+nchip*j+LDC] = al*data[j+buf_offsetr+packetsize*l+packetsize/2];
			}
		    }
		    p += LDC*2;
		}
	    } else {
		for(l=0;l<nloop;l++){
		    int packetsize = result_size/nchip/nloop; 
		    for(j=0;j<packetsize/2;j++){ //one loop contains 2 columns
			for(k=0;k<nchip;k++){
			    double *data = dmaw[k];
			    //printf("%e \n", data[j]);
			    p[wind[k]+nchip*j]     += al*data[j+buf_offsetr+packetsize*l];
			    p[wind[k]+nchip*j+LDC] += al*data[j+buf_offsetr+packetsize*l+packetsize/2];
			}
		    }
		    p += LDC*2;
		}
	    }
	}
	if(i!=(n-nloop)){
	    if(i%(nloop*2)==0){
		buf_offsetw = result_packet;
		buf_offsetr = 0;
	    } else {
		buf_offsetw = 0;
		buf_offsetr = result_packet;
	    }
	}
	for(j=0;j<nchip;j++){
	    if(j==0)
		sing = rdtsc2();
	    _hib_finish_dmawMC(s[j]->c->hib_id);
	    if(j==0)
		copy = rdtsc2();
	    if(i!=(n-nloop)){
		_hib_start_dmawMC(s[j]->c->hib_id, result_packet, (void*)(dmaw[j]+buf_offsetw), 1);
	    }
	}
	//printf("loop elapsed %lld [clk] %lld [clk] nloop=%d \n", sing-start, copy-sing, n);
    }
    for(l=0;l<nloop;l++){
	int packetsize = result_size/nchip/nloop; 
	for(j=0;j<packetsize/2;j++){ //one loop contains 2 columns
	    for(k=0;k<nchip;k++){
		double *data = dmaw[k];
		//printf("%e \n", data[j]);
		if(bt==0.0){
		    p[wind[k]+nchip*j]     = al*data[j+buf_offsetw+packetsize*l];
		    p[wind[k]+nchip*j+LDC] = al*data[j+buf_offsetw+packetsize*l+packetsize/2];
		} else {
		    p[wind[k]+nchip*j]     += al*data[j+buf_offsetw+packetsize*l];
		    p[wind[k]+nchip*j+LDC] += al*data[j+buf_offsetw+packetsize*l+packetsize/2];
		}
	    }
	}
	p += LDC*2;
    }
    SING_EM_fifoclrMC(s[0]);

    CTRL_endbcast(s[0]->c);
    return 0;
}



#if NCHIP==4

SINGinfo ** singchip_p;


static void wait_dmas_to_become_safe()
{
    
    int dd;
    // currently unused
    return;
    if (hib_get_dmacheck_mode()){
	while (dd=diff_in_dmaw_status()>16){
		    gdr_multi_cntl_setstate(5);
	    //	    xwait(1000);
	    //fprintf(stderr,"diff = %d\n", diff_in_dmaw_status());
	    
	}
	gdr_multi_cntl_setstate(3);
	if (dd == -1) gdr_multi_cntl_setstate(1);
	while(dd= gdr_multi_cntl_getstate() > 3){
	    fprintf(stderr,"getstate=%d\n",gdr_multi_cntl_getstate());
	}
    }
}

int diff_in_dmaw_status()
// return the difference in the returned words on four channels
// returns -1 if all ended
{
    int nchip=NCHIP;
    int nwords[nchip];
    int nwords2[nchip];
    int i;
    for(i=0;i<nchip;i++){
	nwords[i]= hib_remaining_words_dmawMC(singchip_p[i]->c->hib_id);
    }
    for(i=nchip-1;i>=0;i--){
	nwords2[i]= hib_remaining_words_dmawMC(singchip_p[i]->c->hib_id);
    }
    int maxr=(nwords[0]+nwords2[0])/2;
    int minr=maxr;
    for(i=1;i<nchip;i++){
	int nw = (nwords[i]+nwords2[i])/2;
	if (nw > maxr) maxr = nw;
	if (nw < minr) minr = nw;
    }
    if (maxr == 0) return -1;
    return (maxr-minr);
}


/* background tasks in matmul loop */

static int skip_cmat_mode = 0;

void gdrdgemm_set_skip_cmat_mode(int mode)
{
    skip_cmat_mode = mode;
}
	


void backcalcmatc(double *cmat, double *dmaw[NCHIP], int nloop,
		  int result_size, int buf_offsetr, double al,
		  double bt, int LDC, int transpose)
{
    int l, j, k;
    double *p;
    int wind[NCHIP] = {0,1,3,2};
    int packetsize = result_size/NCHIP/nloop; 
    p=cmat;
    if (skip_cmat_mode) return;

    //    fprintf(stderr,"transpose=%d, beta=%g, alpha=%g,  %d\n", transpose,bt,al, nloop);
    
    int phalf=packetsize/2;
    if(transpose==0){
	if(bt==0.0){
	    for(l=0;l<nloop;l++){
		//		if (l %4 == 0)  wait_dmas_to_become_safe();
		for(j=0;j<packetsize/2;j++){ //one loop contains 2 columns
		    int rptr = j+buf_offsetr+packetsize*l;
		    int rptr2 = rptr+phalf;
		    for(k=0;k<NCHIP;k++){
			double *data = dmaw[k];
			int ind  = wind[k]+NCHIP*j;
			p[ind]     = al*data[rptr];
			p[ind+LDC] = al*data[rptr2];
		    }
		}
		p += LDC*2;
	    }
	} else {
	    for(l=0;l<nloop;l++){
		int p2 = packetsize/2;
		if (l %4 == 0)  wait_dmas_to_become_safe();
		p= cmat + l*(LDC*2);
		if (al != 1.0){
		    for(j=0;j<p2;j++){ 
			for(k=0;k<NCHIP;k++){
			    double *data = dmaw[k];
			    int ind  = wind[k]+NCHIP*j;
			    int rptr = j+buf_offsetr+packetsize*l;
			    p[ind]     += al*data[rptr];
			    p[ind+LDC] += al*data[rptr+p2];
			}
		    }
		}else{
		    for(j=0;j<p2;j++){ 
			int rptr = j+buf_offsetr+packetsize*l;
			int rptr2 = rptr+phalf;
#if 0			
			for(k=0;k<NCHIP;k++){
			    double *data = dmaw[k];
			    int ind  = wind[k]+NCHIP*j;
			    p[ind]     += data[rptr];
			    p[ind+LDC] += data[rptr2];
			}
#endif
			//    int wind[NCHIP] = {0,1,3,2};
			p[0+NCHIP*j]+= *(dmaw[0]+rptr);
			p[1+NCHIP*j]+= *(dmaw[1]+rptr);
			p[3+NCHIP*j]+= *(dmaw[2]+rptr);
			p[2+NCHIP*j]+= *(dmaw[3]+rptr);
			p[0+NCHIP*j+LDC]+= *(dmaw[0]+rptr2);
			p[1+NCHIP*j+LDC]+= *(dmaw[1]+rptr2);
			p[3+NCHIP*j+LDC]+= *(dmaw[2]+rptr2);
			p[2+NCHIP*j+LDC]+= *(dmaw[3]+rptr2);
			
		    }
		}		    
	    }
	}
    } else {
	if(bt==0.0){
	    for(l=0;l<nloop;l++){
		//		if (l %4 == 0)  wait_dmas_to_become_safe();
		for(j=0;j<packetsize/2;j++){ //one loop contains 2 columns
		    for(k=0;k<NCHIP;k++){
			double *data = (dmaw)[k];
			int index = (wind[k]+NCHIP*j)*(LDC); //to be nontemporal
			int rptr  = j+buf_offsetr+packetsize*l;
			p[index]   = (al)*data[rptr];
			p[index+1] = (al)*data[rptr+packetsize/2];
		    }
		}
		p += 2;
	    }
	} else {
	    for(l=0;l<nloop;l++){ 
		//		if (l %4 == 0)  wait_dmas_to_become_safe();
		for(j=0;j<packetsize/2;j++){ //one loop contains 2 columns
		    for(k=0;k<NCHIP;k++){
			double *data = (dmaw)[k];
			int index = (wind[k]+NCHIP*j)*(LDC); //to be nontemporal
			int rptr  = j+buf_offsetr+packetsize*l;
			p[index]   += (al)*data[rptr];
			p[index+1] += (al)*data[rptr+packetsize/2];
		    }
		}
		p += 2;
	    }
	}
    }
}

void calcmatc(double *cmat, double *dmaw[NCHIP], int l0, int l1, int nloop,
		  int result_size, int buf_offsetr, double al,
		  double bt, int LDC, int transpose)
{
    int l, j, k;
    double *p;
    int wind[NCHIP] = {0,1,3,2};
    int packetsize = result_size/NCHIP/nloop; 
    p=cmat;
    if (skip_cmat_mode) return;
    //    fprintf(stderr,"transpose, beta=%d, %g %d\n", transpose,bt,nloop);
    int phalf=packetsize/2;

    if(transpose==0){
	if(bt==0.0){
	    for(l=l0;l<l1;l++){
		int p2 = packetsize/2;
		p= cmat + ((long)l)*((long)LDC*2);
		v2df * pv = (v2df*) p;
		double *d0=dmaw[0]+buf_offsetr+packetsize*l;
		double *d1=dmaw[1]+buf_offsetr+packetsize*l;
		double *d2=dmaw[3]+buf_offsetr+packetsize*l;
		double *d3=dmaw[2]+buf_offsetr+packetsize*l;
		int k;
		for(k=0;k<2;k++){
		    for(j=0;j<p2;j++){ 
			int rptr = j+buf_offsetr+packetsize*l;
#if 0			
			p[0+NCHIP*j]= al*d0[j];
			p[1+NCHIP*j]= al*d1[j];
			p[2+NCHIP*j]= al*d2[j];
			p[3+NCHIP*j]= al*d3[j];
#else
			__builtin_ia32_movntpd(p+0+NCHIP*j, (v2df){al*d0[j],al*d1[j]});
			__builtin_ia32_movntpd(p+2+NCHIP*j, (v2df){al*d2[j],al*d3[j]});
#endif
#if 0
			__builtin_prefetch(d0+j+packetsize, 0, 0);
			__builtin_prefetch(d1+j+packetsize, 0, 0);
			__builtin_prefetch(d2+j+packetsize, 0, 0);
			__builtin_prefetch(d3+j+packetsize, 0, 0);
#endif			
		    }
		    d0+= phalf;
		    d1+= phalf;
		    d2+= phalf;
		    d3+= phalf;
		    p+= LDC;
		}
	    }
#if 0		
	    for(l=l0;l<l1;l++){
		p= cmat + l*(LDC*2);
		for(j=0;j<packetsize/2;j++){ //one loop contains 2 columns
		    for(k=0;k<NCHIP;k++){
			double *data = dmaw[k];
			int ind  = wind[k]+NCHIP*j;
			int rptr = j+buf_offsetr+packetsize*l;
			p[ind]     = al*data[rptr];
			p[ind+LDC] = al*data[rptr+packetsize/2];
		    }
		}
	    }
#endif	    
	} else {
#if 1
	    double pbuf[packetsize*NCHIP];
	    for(l=l0;l<l1;l++){
		int p2 = packetsize/2;
		p= cmat + ((long)l)*((long)LDC*2);
		if (al != -1.0){
		    v2df * pv = (v2df*) p;
		    double *d0=dmaw[0]+buf_offsetr+packetsize*l;
		    double *d1=dmaw[1]+buf_offsetr+packetsize*l;
		    double *d2=dmaw[3]+buf_offsetr+packetsize*l;
		    double *d3=dmaw[2]+buf_offsetr+packetsize*l;
		    int k;
		    for(k=0;k<2;k++){
#if 1
			for(j=0;j<p2;j++){ 
			    int rptr = j+buf_offsetr+packetsize*l;
			    p[0+NCHIP*j]+= al*d0[j];
			    p[1+NCHIP*j]+= al*d1[j];
			    p[2+NCHIP*j]+= al*d2[j];
			    p[3+NCHIP*j]+= al*d3[j];
			    //    __builtin_prefetch(p+NCHIP*j+LDC, 1, 1);
			    // __builtin_prefetch(d0+j+phalf, 0, 0);
			    //__builtin_prefetch(d1+j+phalf, 0, 0);
			    //__builtin_prefetch(d2+j+phalf, 0, 0);
			    //__builtin_prefetch(d3+j+phalf, 0, 0);
			}
#else
			
			for(j=0;j<p2;j++){ 
			    pbuf[NCHIP*j] =p[NCHIP*j]+ al*d0[j];
			    pbuf[NCHIP*j+1] =p[NCHIP*j+1]+ al*d1[j];
			    pbuf[NCHIP*j+2] =p[NCHIP*j+2]+ al*d2[j];
			    pbuf[NCHIP*j+3] =p[NCHIP*j+3]+ al*d3[j];
			}
			//			for(j=0;j<p2*4;j++)  p[j]= pbuf[j];
			v2df * pv = (v2df*)p;
			v2df * pbv = (v2df*)pbuf;
			for(j=0;j<p2*2;j++) {
			    __builtin_ia32_movntpd((double*)(pv+j), pbv[j]);
			}
#endif		    
			d0+= phalf;
			d1+= phalf;
			d2+= phalf;
			d3+= phalf;
			p+= LDC;
		    }
		}else{
		    v2df * pv = (v2df*) p;
		    double *d0=dmaw[0]+buf_offsetr+packetsize*l;
		    double *d1=dmaw[1]+buf_offsetr+packetsize*l;
		    double *d2=dmaw[3]+buf_offsetr+packetsize*l;
		    double *d3=dmaw[2]+buf_offsetr+packetsize*l;
		    int k;
		    for(k=0;k<2;k++){
			for(j=0;j<p2;j++){ 
			    int rptr = j+buf_offsetr+packetsize*l;
			    p[0+NCHIP*j] -= d0[j];
			    p[1+NCHIP*j] -= d1[j];
			    p[2+NCHIP*j] -= d2[j];
			    p[3+NCHIP*j] -= d3[j];
			    __builtin_prefetch(p+NCHIP*j+LDC, 1, 1);
			    // __builtin_prefetch(d0+j+phalf, 0, 0);
			    //__builtin_prefetch(d1+j+phalf, 0, 0);
			    //__builtin_prefetch(d2+j+phalf, 0, 0);
			    //__builtin_prefetch(d3+j+phalf, 0, 0);
			}
			d0+= phalf;
			d1+= phalf;
			d2+= phalf;
			d3+= phalf;
			p+= LDC;
		    }
		}		    
	    }
#else
	    for(l=l0;l<l1;l++){
		int p2 = packetsize/2;
		p= cmat + ((long)l)*((long)LDC*2);
		for(j=0;j<p2;j++){ 
		    for(k=0;k<NCHIP;k++){
			double *data = dmaw[k];
			int ind  = wind[k]+NCHIP*j;
			int rptr = j+buf_offsetr+packetsize*l;
			p[ind]     += al*data[rptr];
			p[ind+LDC] += al*data[rptr+p2];
		    }
		}
	    }
#endif	    
	}
    } else {
	if(bt==0.0){
	    for(l=l0;l<l1;l++){
		p = cmat + l*2;
		for(j=0;j<packetsize/2;j++){ //one loop contains 2 columns
		    for(k=0;k<NCHIP;k++){
			double *data = (dmaw)[k];
			int index = (wind[k]+NCHIP*j)*(LDC); //to be nontemporal
			int rptr  = j+buf_offsetr+packetsize*l;
			p[index]   = (al)*data[rptr];
			p[index+1] = (al)*data[rptr+packetsize/2];
		    }
		}
	    }
	} else {
	    for(l=l0;l<l1;l++){ 
		p = cmat + l*2;
		for(j=0;j<packetsize/2;j++){ //one loop contains 2 columns
		    for(k=0;k<NCHIP;k++){
			double *data = (dmaw)[k];
			int index = (wind[k]+NCHIP*j)*(LDC); //to be nontemporal
			int rptr  = j+buf_offsetr+packetsize*l;
			p[index]   += (al)*data[rptr];
			p[index+1] += (al)*data[rptr+packetsize/2];
		    }
		}
	    }
	}
    }
}

struct backcalcmatc_data 
{
  double al;
  double bt;
  double *cmat;
  double *dmaw[NCHIP];
  int nloop;
  int result_size;
  int buf_offsetr;
  int LDC;
  int transpose;
} __attribute__((aligned(16)));

struct backcalcmatc_data cmatdata;


void backcalcmatc_mtwork(struct backcalcmatc_data *ptr)
{
  backcalcmatc(ptr->cmat, ptr->dmaw, ptr->nloop, ptr->result_size, ptr->buf_offsetr, ptr->al, ptr->bt, ptr->LDC, ptr->transpose);
  
#ifdef BENCHBACKTASK
  printf("background calc :  ->  %lld [clk] %e [s]  start : %lld  end : %lld \n", end-start, (end-start)/(2.67e9), start, end);
#endif
}

#ifndef NTHREADS
#define NTHREADS 4
#endif

void backcalcmatc_mt(double *cmat, double *dmaw[NCHIP], int nloop, int result_size, int buf_offsetr, double al, double bt, int LDC)
{
  int i;
  void *ptr[NTHREADS];

  cmatdata.cmat = cmat;
  for(i=0;i<NCHIP;i++){
    cmatdata.dmaw[i] = dmaw[i];
  }
  cmatdata.nloop       = nloop;
  cmatdata.result_size = result_size;
  cmatdata.buf_offsetr = buf_offsetr;
  cmatdata.al          = al;
  cmatdata.bt          = bt;
  cmatdata.LDC         = LDC;
}


struct backsendamat_data
{
  SINGinfo *s[NCHIP];
  double *next_a[NCHIP];
  int i;
  int *send128;
  int sendc;
  int DIMK;
} __attribute__((aligned(16)));

struct backsendamat_data amatdata;

static int sendamat_usesafemode = 1;

void sendamat(SINGinfo *s[NCHIP], double next_a[NCHIP][NPE*NBB*256],
	      int i, int *send128, int nsend, int sendc, int DIMK, int waitmode)
{
    double *aptr[NCHIP];
    int setup, k;
    int lmsize;
    UINT64 start, end, wait, st;

    int packetsize = sendc/nsend;// packetsize: this should be 32
    int dn = 32;
    int nrealsend = (dn*DIMK)/2048;
    if (sendamat_usesafemode){
	nrealsend = dn;
    }

    start = rdtsc2();

    lmsize = 256*512;
    int increment = NPE*NBB*256;
    if((*(send128))<(lmsize/(sendc)) && next_a){ //for 256x512 matrix send
	//	fprintf(stderr,"sendamat sending data\n");
	CTRL_endbcast(s[0]->c);
	for(k=0;k<NCHIP;k++){
	    aptr[k] = &(next_a[k][(*(send128))*(sendc)]);
	}
	if(i==0){
	    setup=1; //send het_convaddr and convlength
	    SING_EM_set_areaid_multichip(NCHIP, s, 2);
	    SING_EM_set_skip_areaid(1);
	} else {
	    setup=0; //don't send het_convaddr and convlength
	}
	fprintf(stderr,"i=%d\n", i);
	for (i=0;i<nsend; i+= dn){
	    double *ap = next_a[0] + (*send128)*(sendc)+i*packetsize;
	    SING_EM_send_i_multichip(NCHIP, s, emid2, (*send128)*nsend+i,
				     nrealsend,ap,increment);
	}

	(*send128)++;
    }
    SING_EM_set_skip_areaid(0);
    end = rdtsc2();
#ifdef BENCHBACKTASK
    printf("background send :  ->  %lld [clk] %e [s]  start : %lld  end : %lld \n", end-start, (end-start)/(2.67e9), start, end);
#endif
}
void sendamat_simple(SINGinfo *s[NCHIP], double next_a[NCHIP][NPE*NBB*256],
	      int i, int *send128, int nsend, int sendc, int DIMK, int waitmode)
{
    double *aptr[NCHIP];
    int setup, k;
    int lmsize;
    UINT64 start, end, wait, st;

    int packetsize = sendc/nsend;// packetsize: this should be 32
    int dn = 32;
    int nrealsend = (dn*DIMK)/2048;
    if (sendamat_usesafemode){
	nrealsend = dn;
    }
    //  fprintf(stderr,"sendamat_simple send128, nsend, sendc= %d %d %d\n", *send128, nsend, sendc);
    start = rdtsc2();

    lmsize = 256*512;
    int increment = NPE*NBB*256;
    if((*(send128))<(lmsize/(sendc)) && next_a){ //for 256x512 matrix send
	//	fprintf(stderr,"sendamat sending data %d %d %d\n", nrealsend, sendc, DIMK);
	for(k=0;k<NCHIP;k++){
	    aptr[k] = &(next_a[k][(*(send128))*(sendc)]);
	}
	for (i=0;i<nsend; i+= dn){
	    double *ap = next_a[0] + (*send128)*(sendc)+i*packetsize;
	    SING_EM_send_i_multichip(NCHIP, s, emid2, (*send128)*nsend+i,
				     nrealsend,ap,increment);
	}
	(*send128)++;
    }
    end = rdtsc2();
#ifdef BENCHBACKTASK
    printf("background send :  ->  %lld [clk] %e [s]  start : %lld  end : %lld \n", end-start, (end-start)/(2.67e9), start, end);
#endif
}


void sendamat_onepe(SINGinfo *s[NCHIP], double next_a[NCHIP][NPE*NBB*256],
	      int ipe,  int DIMK)
{
    // assumption here:
    // single PE packet is divided to 4 pieces.
    // so each block has 16*64 =1024 words, and one need to send this as 4 blocks
    
    int i;
    int npe = 32;
    int nrealsend = (npe*DIMK)/2048;
    if (sendamat_usesafemode){
	nrealsend = npe;
    }

    int increment = NPE*NBB*256;
    for (i=0;i<4; i++){
	double *ap = next_a[0] + (ipe %1)*(NBB*256)+i*1024;
	SING_EM_send_i_multichip(NCHIP, s, emid2, (ipe)*128+i*32,
				 nrealsend,ap,increment);
    }
}


void sendamat_old(SINGinfo *s[NCHIP], double next_a[NCHIP][NPE*NBB*256],
	      int i, int *send128, int nsend, int sendc, int DIMK, int waitmode)
{
    double *aptr[NCHIP];
    int setup, k;
    int lmsize;
    UINT64 start, end, wait, st;
    
    start = rdtsc2();
    //    lmsize = (DIMK)*256*512/2048;
    //original code: clever no-padding assumed

    lmsize = 256*512;

    if((*(send128))<(lmsize/(sendc)) && next_a){ //for 256x512 matrix send
	//	fprintf(stderr,"sendamat sending data\n");
	CTRL_endbcast(s[0]->c);
	for(k=0;k<NCHIP;k++){
	    aptr[k] = &(next_a[k][(*(send128))*(sendc)]);
	}
	if(i==0){
	    setup=1; //send het_convaddr and convlength
	} else {
	    setup=0; //don't send het_convaddr and convlength
	}
	SING_EM_send_nhib(s, NCHIP, emid2, (*send128)*nsend, nsend, aptr,
			  setup,waitmode);
	
	//	CTRL_beginbcast(s[0]->c);
	(*send128)++;
	/* wait for finishing writing to EM */
#ifndef DONTFIRSTWAIT
	if (waitmode){
	    //	wait = 300000; 
	    wait = 100000; 
	    
	    st = rdtsc2();
	    //printf("wait for het finish : sent128=%d \n", send128);
	    while((rdtsc2()-st)<wait) {}
	}
#endif
    }
    end = rdtsc2();
#ifdef BENCHBACKTASK
    printf("background send :  ->  %lld [clk] %e [s]  start : %lld  end : %lld \n", end-start, (end-start)/(2.67e9), start, end);
#endif
}


struct backtask_data
{
  enum {amatsend, cmatcalc, none} type;
  void *param;
} __attribute__((aligned(16)));

struct backtask_data backtaskdat[NTHREADS];


#else
#error "NCHIP==4 is required!"
#endif

void print_dmaw_status(SINGinfo *s[NCHIP], int nchip)
{
    int nwords[nchip];
    int nwords2[nchip];
    int i;
    for(i=0;i<nchip;i++){
	nwords[i]= hib_remaining_words_dmawMC(s[i]->c->hib_id);
    }
    for(i=nchip-1;i>=0;i--){
	nwords2[i]= hib_remaining_words_dmawMC(s[i]->c->hib_id);
    }
    fprintf(stderr,"remaining words= ");
    int maxr=(nwords[0]+nwords2[0])/2;
    int minr=maxr;
    for(i=0;i<nchip;i++){
	int nw = (nwords[i]+nwords2[i])/2;
	fprintf(stderr," %5d",nw);
	if (nw > maxr) maxr = nw;
	if (nw < minr) minr = nw;
    }
    fprintf(stderr,", max-min=%3d\n",maxr-minr);
}

static int debug_matmul = 0;

static int dummy = 0;

static int wait_before_dmaw = 0;
static hib_dummy_read(int devid)
{
    dummy += hib_mem_readMC(devid, 0x60);
}

void wait_dmaw_and_errout(SINGinfo *s[], int nchip, int seqid_to_wait,
			  char* myhostname, int i, double* dmaw[],
			  int buf_offsetw, int dmawsize, int halfmode)
{
    int j;
    int jend = nchip;
    if (halfmode) jend = 1;
    for(j=0;j<nchip;j++){
	int iret;
	if (halfmode){
	    iret = hib_half_finish_dmaw_seqMC(s[j]->c->hib_id,seqid_to_wait);
	}else{
	    iret = hib_finish_dmaw_seqMC(s[j]->c->hib_id,seqid_to_wait);
	}
	if (iret){
	    // DMA timeout error
	    fprintf(stderr,"DMA timeout for host %s i=%d, chip=%d\n",
		    myhostname, i, j);
	    SING_dump_savedstatus(nchip, "saved: before calc start");
	    SING_dump_syncstatus(nchip,s,"after xwait");
	    fprintf(stderr,"DMAW first word\n");
	    for(j=0;j<nchip;j++){
		fprintf(stderr,"[%d]=%lx ",j,
			*((UINT64*)(dmaw[j]+buf_offsetw)));
	    }
	    fprintf(stderr,"\n");
	    fprintf(stderr,"DMAW last word\n");
	    for(j=0;j<nchip;j++){
		fprintf(stderr,"[%d]=%lx ",j,
			*((UINT64*)(dmaw[j]+buf_offsetw+dmawsize-1)));
	    }
	    for(j=0;j<nchip;j++){
		hib_dump_sreg(s[j]->c->hib_id);
	    }
	    fprintf(stderr,"\n");
	    exit(-1);
	}
	//	    SING_dump_syncstatus(nchip,s,"after DMAW done");
    }
}


int matmul_type2_runMC_tb4_2_ovl_dg(SINGinfo *s[NCHIP], int nchip, int n,
				    double *loopout, int LDC,
				    double next_a[NCHIP][NPE*NBB*256],
				    double al, double bt, int transpose,
				    int DIMK,
				    int istart,
				    int nloop,
				    int NOTA,
				    int LDA,
				    double a[][LDA],
				    int useoverlapa)
{
    int i , j, k, l, result_size;
    int buf_offsetw, buf_offsetr;
    int send128;
    int sendc,  nsend;
    int wind[NCHIP] = {0,1,3,2};
    double *p, *dmaw[NCHIP], *nap[NCHIP];
    UINT64 start, sing, copy, run, fini, init, loops, loop, cmatcopy, ispstart, dmawwait;
    int lmsize=256*512;
    volatile UINT64 *test;
    int dmawsize;
    if(debug_matmul)fprintf(stderr,"matmul_type2 enter\n");

    singchip_p = s;

    for(i=0;i<nchip;i++)nap[i]=next_a[i];
    
    //printf("overlap \n");
    nsend = nloop*4;
    sendc = nsend*32;
    result_size = sizeof(struct matmul_loopout_vectorstruct)/sizeof(double)*nloop;
    dmawsize = result_size/nchip;
    //    fprintf(stderr,"nchip : %d , nloop: %d resultsize : %d \n",
    //	    nchip, nloop,result_size);
    start = rdtsc2();
    UINT64 start0 = start;
    CTRL_endbcast(s[0]->c);

#if 0    
    for(i=0;i<nchip;i++){
	//	if(debug_matmul)fprintf(stderr,"call fifoclr %d\n", i);
	SING_EM_fifoclrMC(s[i]);
	//	if(debug_matmul)fprintf(stderr,"call move_elt_data0 %d\n", i);
	matmul_move_elt_data0MC(s[i], 0);
	//	if(debug_matmul)fprintf(stderr,"call move_elt_data1_nosend %d\n", i);
	matmul_move_elt_data1_nosendMC(s[i], 0);
    }
#endif
    //    fprintf(stderr,"call fifoclr \n");
    for(i=0;i<nchip;i++)SING_EM_fifoclrMC(s[i]);
    //    fprintf(stderr,"call move_elt_data0MC \n");
    for(i=0;i<nchip;i++)matmul_move_elt_data0MC(s[i], 0);
    //    fprintf(stderr,"call move_elt_data1MC \n");
    for(i=0;i<nchip;i++)matmul_move_elt_data1_nosendMC(s[i], 0);


    p = loopout;
    buf_offsetr = 0;
    buf_offsetw = 0;
    send128 = 0;
    ispstart = 0;
    cmatcopy = 0;
    dmawwait=0;
    for(j=0;j<nchip;j++){
	dmaw[j] = (double*)(s[j]->c->h->dmaw_buf);
	int k;
	for (k=0;k<2;k++){
	    hib_register_dma_seqMC(s[j]->c->hib_id,k, 1,dmawsize,
				   (void*)(dmaw[j]+(1-k)*dmawsize));
	}

    }
    
    copy =0;
    CTRL_beginbcast(s[0]->c);

    
    //     if(debug_matmul)fprintf(stderr,"sending ids[1]\n");
    //    fprintf(stderr,"call coc_setflags\n");
    CTRL_coc_setflags(0,-1,-1);
    //    fprintf(stderr,"call instlist(ids1)\n");
    //    SING_dump_syncstatus(nchip,s,"before ids1");
    SING_send_instlist(s[0]->c, &(s[0]->isp.instlists[ids[1]]), 1, 0);
    //    SING_dump_syncstatus(nchip,s,"after ids1");
    //    if(debug_matmul)fprintf(stderr,"end sending ids[1]\n");
    int seqid = 1;
    if (wait_before_dmaw == 0){
	for(j=0;j<nchip;j++){
	    if (use_old_dmaw){
		hib_start_dmawMC(s[j]->c->hib_id, dmawsize, (void*)(dmaw[j]+buf_offsetw));
	    }else{
		hib_start_dma_seqMC(s[j]->c->hib_id, seqid, 1);
	    }
	    
	    //    fprintf(stderr,"dmaw buffer address = %lx\n",
	    //	    (unsigned long)(dmaw[j]+buf_offsetw));
	}
    }
    init = rdtsc2() - start;
    loops = rdtsc2();
    int coc_dmaw_id = -1;
    xwait(10000);
    int iter=0;
    int niter = 1024/nloop;
    int seqid_to_wait;
    int buf_offsetw_to_wait;

    UINT64 cocstart0, cocstart, cocend, dmaend;
    int maxcycles = 0;
    for(i=0;i<n;i+=nloop){ // 2column
	run = rdtsc2();
	
	if ((DIMK==2048) && useoverlapa){
	    if (i==0){
		copytomata_partial_mc(iter,nloop,
				      LDA, NOTA,  a,
				      istart, nchip,
				      DIMK, nap);
		iter++;
	    }
	}
	//	gdr_multi_cntl_setstate(3);
	//	fprintf(stderr,"call coc_setflags\n");
	int coc_flag = 0;
	if (useoverlapa) coc_flag = 7;
	coc_flag = 0;
	if (iter >= niter -1) coc_flag = 0;
	if (i > 864) coc_flag = 0;
	//fprintf(stderr,"coc flags = %d %d %d\n", coc_flag, -1, coc_dmaw_id);
	//	SING_dump_syncstatus(nchip,s,"before start");

	//	SING_save_syncstatus(nchip,s); // need thit to make two cards wok?
	
	CTRL_coc_setflags(coc_flag,-1, coc_dmaw_id);
	//	SING_dump_syncstatus(nchip,s,"before calc start");

	if (i){
	    //	    while ((rdtsc2() - cocstart) < 945*300){xwait(1000);}
	    matmul_coc_busywait(s[0]->c);
	}
	cocend = rdtsc2();

	SING_send_instlist(s[0]->c, &(s[0]->isp.instlists[ids[2]]), nloop, 1);
	cocstart0 = cocstart;
	cocstart = rdtsc2();
	//xwait(100000);
	//	hib_finish_dmawMC(s[0]->c->hib_id);
	//		SING_dump_syncstatus(nchip,s,"after calc start");
	//	fprintf(stderr,"isp run : %d \n", start-run);
	ispstart += start - run; 
	//	UINT64 xstart = rdtsc2();
	//	for(j=0;j<nchip;j++)hib_finish_dmawMC(s[j]->c->hib_id);
	start = rdtsc2();
	//	dmawwait+= start-xstart;
	

	int ccend = nloop/2;

	
	if (i){
	    // not waiting here is unsafe....
	    // JM 2010/11/06
	    wait_dmaw_and_errout(s,nchip,seqid_to_wait, myhostname, i, dmaw,
				 buf_offsetw_to_wait, dmawsize,0);
	    //	    dmaend = rdtsc2();
	    //	    fprintf(stderr, "dmaend - cocend, cocend - cocstart = %d, %d\n",
	    //		    (int)(dmaend-cocend), (int)(cocend - cocstart0));
	    if (maxcycles < cocend - cocstart0) maxcycles = cocend - cocstart0;
	}
	
	if(i){
	    calcmatc(p, dmaw, 0,ccend, nloop, result_size, buf_offsetr,
		     al, bt, LDC, transpose);
//	    wait_dmaw_and_errout(s,nchip,seqid_to_wait, myhostname, i, dmaw,
//				 buf_offsetw_to_wait, dmawsize,0);
	    if (ccend < nloop)calcmatc(p, dmaw, ccend,nloop, nloop,
				       result_size, buf_offsetr,
				       al, bt, LDC, transpose);
	    if (useoverlapa){
		if (iter <= niter){
		    if(wait_before_dmaw==0){
			hib_finish_dmawMC(s[0]->c->hib_id);
		    }
		    sendamat(s,  next_a, i, &send128, nsend,
			     sendc,  DIMK,0);
		}
		if (DIMK==2048){
		    if (iter < niter){
			copytomata_partial_mc(iter,nloop,
					      LDA, NOTA,  a,
					      istart, nchip,
					      DIMK, nap);
		    }
		    iter++;
		}
	    }
	}

	//	if (i)gdr_multi_cntl_setstate(1);

	UINT64 st = rdtsc2();
	cmatcopy += st-start;
	//	fprintf(stderr,"st, s0= %lld %lld %lld %lld\n", st, start, st-start, cmatcopy);
	if (wait_before_dmaw){
	    xwait(10000);
	    for(j=0;j<nchip;j++){
		hib_finish_dmarMC(s[j]->c->hib_id);
		seqid = (i%(nloop*2))? 0:1;
		hib_start_dma_seqMC(s[j]->c->hib_id, seqid, 1);
	    }
	}
	
	UINT64 wait = 0;
	
	if(i != 0){
	    //start = rdtsc2();
	    if(transpose==0){
		p += LDC*2*nloop;
	    } else {
		p += 2*nloop;
	    }
	    //sing = rdtsc2() - start;
	} 
	seqid_to_wait = seqid;
	buf_offsetw_to_wait = buf_offsetw;

	if (matmul_getnboards() != 1)matmul_coc_busywait(s[0]->c);

	

	dmawwait += rdtsc2()-st;

	if(i!=(n-nloop)){
	    if(i%(nloop*2)==0){
		buf_offsetw = result_size/nchip;
		buf_offsetr = 0;
	    } else {
		buf_offsetw = 0;
		buf_offsetr = result_size/nchip;
	    }
	}

#if 1
	coc_dmaw_id = -1;
	if (wait_before_dmaw == 0){
	    for(j=0;j<nchip;j++){
		if(i!=(n-nloop)){
		    start = rdtsc2();
		    if (use_old_dmaw){
			hib_start_dmawMC(s[j]->c->hib_id, dmawsize, (void*)(dmaw[j]+buf_offsetw));
		    }else{
			seqid = (i%(nloop*2))? 1:0;
			if (matmul_getnboards() != 1){
			    //hib_start_dma_seqMC(s[j]->c->hib_id, seqid, 1);
			}else{
			    hib_setup_dma_eodMC(s[j]->c->hib_id, seqid);
			    coc_dmaw_id = seqid;
			}
			// starting DMAW here seems to be safer
			// for multi-card environment -- JM 2010/5/19
		    }
		    ispstart += rdtsc2() - start;
		}
	    }
	}
#endif
	int wait2 = 0;

    }
    wait_dmaw_and_errout(s,nchip,seqid_to_wait, myhostname, i, dmaw,
			 buf_offsetw_to_wait, dmawsize,0);
    loop = rdtsc2() - loops;
    loops = rdtsc2();
    backcalcmatc(p, dmaw, nloop, result_size, buf_offsetw, al, bt, LDC, transpose);
    cmatcopy += rdtsc2() - loops;
    int sendsize=DIMK*DIM0*DIM1/2048/sendc/NCHIP;
    if (useoverlapa){
	int firstzero=1;
	while (send128 < sendsize){
	    sendamat(s, next_a, firstzero, &send128, nsend, sendc, DIMK,1);
	    
	    firstzero=1;
	    //	usleep (100);
	}
    }
	

    //check if previous calculations and DMA operations are all finished
    //    SING_dump_syncstatus(nchip,s,"after matmul32 main loop");
    if (useoverlapa){
	for(j=0;j<nchip;j++){
	    //	fprintf(stderr,"wait to finish DMAR %d\n", j);
	    hib_finish_dmarMC(s[j]->c->hib_id);
	    //	fprintf(stderr,"wait to finish COC %d\n", j);
	    while(CTRL_coc_busy(s[j]->c)){xwait(500);}
	    //	fprintf(stderr,"finished COC %d\n", j);
	}
    }
    //    fprintf(stderr,"maxcycles = %d\n", maxcycles);
    SING_EM_fifoclrMC(s[0]);
    CTRL_endbcast(s[0]->c);

    if (matmul_msg_level >= 2)fprintf(stderr, "matmul total =%g cmatcopy=%g dmawait=%g\n", (rdtsc2()-start0)/2.67e9, cmatcopy/2.67e9, dmawwait/2.67e9); 

#ifdef BENCHMATMULLOOP  
    printf("matmul init : %lld [clk], loop %lld [clk], cmatcopy %lld [clk] , ispstart %lld [clk] \n", init, loop, cmatcopy, ispstart); 
#endif
    return send128;
}


int sendoneamat_initialize(SINGinfo *s[], int firstchip, int abcast)
{
    int nc = abcast? nchips:NCHIP;
    SING_EM_set_areaid_multichip(nc, s+firstchip, 2);
    SING_EM_set_skip_areaid(1);
    CTRL_write_set_dmar_buffered_mode(1);
}

int sendoneamat_finalize()
{
    CTRL_write_set_dmar_buffered_mode(0);
    SING_EM_set_skip_areaid(0);
}


int sendoneamat(SINGinfo *s[], int firstchip, int abcast,
		double next_a[NCHIP][NPE*NBB*256],
		int DIMK,
		int istart,
		int NOTA,
		int LDA,
		double a[][LDA])
{
    int aa,i , j, k;
    int send128 = 0;
    int nloop = 32;
    int nsend = nloop*4;
    int sendc = nsend*32;
    int ipe, nipe;
    int ichip;
    double *nap[NCHIP];
    static int lastdimk[NCHIP*2]={2048,2048,2048,2048,2048,2048,2048,2048};
    int nc = abcast? nchips:NCHIP;
    singchip_p = s+firstchip;
    //    fprintf(stderr,"enter sendoneamat n=%d %d\n", n);
    for(i=0;i<NCHIP;i++)nap[i]=next_a[i];
    nipe = 32;
    //    sendoneamat_initialize(s,firstchip, abcast);

    sendamat_usesafemode = 0;
    if (DIMK != lastdimk[firstchip]){
	if (DIMK <lastdimk[firstchip])sendamat_usesafemode = 1;
	lastdimk[firstchip]=DIMK;
    }
    int bcastmode= abcast? NCHIP:0;
    UINT64 copy=0, send=0,dma=0;
    SING_DMAR_wait(nc, s+firstchip);

    for(i=0,ipe=0;(i<1024) && (ipe<nipe);i+=nloop,ipe++){ 
	//	UINT64 st = rdtsc2();

	copytomata_em_1024_tb4_dg_singlepe_mc(ipe,0,LDA, NOTA, a, istart,NCHIP, DIMK,nap);

	//	UINT64 in1 = rdtsc2();
	//	copy += in1-st;
	sendamat_onepe(s+firstchip, next_a,  ipe,  DIMK);
	//	UINT64 in2 = rdtsc2();
	//	send += in2-in1;

	if(matmul_getnboards() != 1){
	    if(ipe)SING_DMAR_wait(nchips, s);
	    for(ichip=0;ichip<nc;ichip++){
		hib_start2_dmarMC_multiplane_bcast(s[ichip+firstchip]->c->hib_id,
						   bcastmode);
	    }
	}else{
	    for(ichip=0;ichip<nc;ichip++){
		if(ipe)SING_DMAR_wait_onechip(s[ichip]);
		hib_start2_dmarMC_multiplane_bcast(s[ichip+firstchip]->c->hib_id,
						   bcastmode);
	    }
	}

	//	UINT64 in3 = rdtsc2();
	//	dma += in3-in2;
    }
    for(ichip=0;ichip<nc;ichip++){
	hib_clear_dmarMC_multiplane(s[ichip+firstchip]->c->hib_id);
    }

    SING_DMAR_wait(nc, s+firstchip);
    //    xwait(1000);
    //    sendoneamat_finalize();
    //    fprintf(stderr,"sendoneamat cycles: copy=%ld send=%ld, dma=%ld\n",
    //	    copy, send, dma);
    return send128;
}

